app.directive('authActivation', function () {
  return {
    restrict: 'A',
    scope: {
      onComplete: '&?',
    },
    templateUrl: 'directives/auth/activation/activation.html',
    controller: function ($scope, $auth, $location, $stateParams, $interpolate, blockUI, zapi, apiError) {
      $scope.user = null;

      $scope.changePassword = function (item) {
        if (!item.password) {
          return swal(
            $interpolate("{{'api.services.auth.changepasswordWrongPasswordTitle' | translate}}")($scope),
            $interpolate("{{'api.services.auth.changepasswordWrongPasswordContent' | translate}}")($scope),
            "error"
          );
        }
        if (item.password !== item.repeat) {
          return swal(
            $interpolate("{{'api.services.auth.changepasswordWrongPasswordTitle' | translate}}")($scope),
            $interpolate("{{'api.services.auth.changepasswordWrongPasswordContent' | translate}}")($scope),
            "error"
          );
        }

        blockUI.start($interpolate("{{'api.services.auth.changepasswordLoad' | translate}}")($scope));
        $auth.changePassword($scope.user, item.password, item.repeat).then(function (response) {
          if ($scope.onComplete && typeof $scope.onComplete() === 'function') return $scope.onComplete()(response.data);

          swal(
            $interpolate("{{'api.services.auth.changepasswordSuccessTitle' | translate}}")($scope),
            $interpolate("{{'api.services.auth.changepasswordSuccessContent' | translate}}")($scope),
            "info"
          );
          $location.path('/');
        }).catch(function (response) {
          swal($interpolate("{{'api.services.auth.changepasswordErrorTitle' | translate}}")($scope), response.data || apiError.timeout, "error");
        }).finally(function (response) {
          blockUI.stop();
        });
      };

      initialize();

      function initialize() {
        if (!$stateParams.code) return swal("Código de ativação inválido", "Certifique-se que seguiu o endereço exactamente como enviado no email", "warning");
        var codes = $stateParams.code.split('&');
        if (codes.length !== 2) return swal("Código de ativação inválido", "Certifique-se que seguiu o endereço exactamente como enviado no email", "warning");

        blockUI.start($interpolate("{{'api.services.auth.activateAccountLoad' | translate}}")($scope));
        $auth.activateAccount(codes).then(function (response) {
          $scope.user = response.data;
        }).catch(function (response) {
          swal("Atenção", response.data || apiError.timeout, "warning");
        }).finally(function () {
          blockUI.stop();
        });
      }
    }
  };
});