app.directive('ngClick', function ($license, $interval, $rootScope) {
  function bindClick(element, moduleId) {
    element.bind('click', function (e) {
      e.preventDefault();
      $license.notify(moduleId);
    });
  }

  return {
    restrict: 'A',
    replace: false,
    link: function (scope, element, attributes) {
      if (typeof attributes.license === 'undefined') return;

      var intervalId = $interval(initialize, 100);

      function initialize() {
        if (!$rootScope.login) return;
        if (!$rootScope.login.role) return;

        $interval.cancel(intervalId);
        var isAllowed = $license.isLicensed(attributes.license, $rootScope.login);
        if (!isAllowed) return bindClick(element, attributes.license);
      }
    }
  };
});