app.controller('authLoginCtrl', function (blockUI, $auth, $location, $scope, $uibModalStack, $interpolate, apiError) {
  $scope.login = function () {
    if (!$scope.item.username) return;
    if (!$scope.item.password) return;

    blockUI.start($interpolate("{{'api.services.auth.loginLoad' | translate}}")($scope));
    $auth.login($scope.item.username, $scope.item.password).then(function (response) {
      $location.path('/profile');
      $uibModalStack.dismissAll();
    }).catch(function (response) {
      swal($interpolate("{{'api.services.auth.loginErrorTitle' | translate}}")($scope), response.data || apiError.timeout, "error");
      reset();
    }).finally(function () {
      blockUI.stop();
    });
  };

  function reset() {
    $scope.item.username = "";
    $scope.item.password = "";
  }
});