app.controller('authResetCtrl', function ($scope, $auth, $location, $interpolate, blockUI, apiError) {
  $scope.reset = function (item) {
    if ($scope.validateReset(item)) return;

    blockUI.start($interpolate("{{'api.services.auth.resetPasswordLoad' | translate}}")($scope));
    $auth.resetPassword(item.email, item.username).then(function (response) {
      swal(
        $interpolate("{{'api.services.auth.resetPasswordSuccessTitle' | translate}}")($scope),
        $interpolate("{{'api.services.auth.resetPasswordSuccessContent' | translate}}")($scope),
        "success"
      );
      $location.path("/");
    }).catch(function (response) {
      swal($interpolate("{{'api.services.auth.resetPasswordErrorTitle' | translate}}")($scope), response.data || apiError.timeout, "error");
    }).finally(function () {
      blockUI.stop();
    });
  };

  $scope.validateReset = function (item) {
    if (!item) return true;
    if (!item.email) return true;
    if (!item.username) return true;
    return false;
  };
});