app.controller('authSignupCtrl', function ($scope, $entity, $uibModalStack, blockUI, apiError) {
  $scope.signup = function (item) {
    if ($scope.validateSignup(item)) return;

    blockUI.start("A reservar conta...");
    $entity.add('user', item, $scope).then(function (response) {
      swal("Está quase!", "Consulte o seu email para ativar a conta de utilizador", "success");
      if ($scope.onComplete && typeof $scope.onComplete() === 'function') return $scope.onComplete()();

      $uibModalStack.dismissAll();
    }).catch(function (response) {
      swal("Não foi possível concluir a criação de conta", response.data || apiError.timeout, "error");
    }).finally(function () {
      blockUI.stop();
    });
  };

  $scope.validateSignup = function (item) {
    if (!item) return true;
    if (!item.username) return true;

    var validUsername = new RegExp('^[a-zA-Z0-9.\-_$@*!]{3,30}$');
    if (!validUsername.test(item.username)) return true;
    if (!item.email) return true;

    return false;
  };
});