/*
$scope.calendarView = null;

$scope.events = [{
  title: 'chazinho com a avo',
  type: 'important',
  startsAt: new Date('2016-02-25T10:00:00.000Z'),
  endsAt: new Date('2016-02-25T12:00:00.000Z'),
  draggable: true,
  resizable: true
}];
*/

app.directive('apiCalendar', function () {
  return {
    restrict: 'A',
    scope: {
      calendarView: '=',
      events: '=',
      calendarTitle: '='
    },
    templateUrl: 'directives/calendar/calendar.html',
    controller: function ($scope, $window, calendarConfig, moment) {
      calendarConfig.templates.calendarMonthCell = 'groupedMonthEvents.html';
      calendarConfig.dateFormatter = 'moment';
      calendarConfig.allDateFormats.moment.title.week = "Semana {week} de {year}";
      calendarConfig.allDateFormats.moment.date.hour = 'HH:mm';
      calendarConfig.allDateFormats.moment.date.time = 'D MMMM';
      calendarConfig.allDateFormats.moment.date.datetime = "YYYY.MMM.D";
      calendarConfig.displayEventEndTimes = true;
      $scope.$on('$destroy', function () {
        calendarConfig.templates.calendarMonthCell = 'mwl/calendarMonthCell.html';
      });

      $window.moment = $window.moment || moment;

      if (!$scope.calendarView) {
        $scope.calendarView = 'month';
      }
      $scope.viewDate = new Date();

      $scope.isCellOpen = true;

      $scope.toggle = function ($event, field, event) {
        $event.preventDefault();
        $event.stopPropagation();
        event[field] = !event[field];
      };

      $scope.groupEvents = function (cell) {
        cell.groups = {};
        (cell.events || []).forEach(function (event) {
          cell.groups[event.type] = cell.groups[event.type] || [];
          cell.groups[event.type].push(event);
        });
      };
    }
  };
});
