app.directive('uploadImage', function ($util, $http, apiError) {
  var defaultHeaders = { transformRequest: angular.identity, headers: { 'Content-Type': undefined } };

  function upload(key, item, callback) {
    var fd = new FormData();
    $util.setFormFiles(fd, item);
    fd.append('item', angular.toJson(item));

    $http.post('/api/image/upload/' + key, fd, defaultHeaders).then(function (response) {
      callback(null, response.data);
    }).catch(function (response) {
      callback(response.data || apiError.timeout);
    });
  }

  return {
    restrict: 'EA',
    scope: {
      item: '=',
      key: '@',
      isEditable: '=',
      label: '@?'
    },
    templateUrl: 'directives/document/image/upload.html',
    controller: function ($scope) {
      $scope.label = $scope.label || "Imagem";
      
      $scope.upload = function (key, item, callback) {
        upload(key, item, function (err, url) {
          if (err) return swal("Envio falhou", err, "warning");

          $scope.item[key] = url;
        });
      };
    }
  };
});