app.directive('dynamicField', function () {
  return {
    restrict: 'A',
    scope: {
      field: '=',
      model: '=',
      key: '@',
      lookup: '=?'
    },
    template: '<div ng-include src="contentUrl" include-replace></div>',
    controller: function ($scope, $entity) {
      if (typeof $scope.lookup === 'undefined') $scope.lookup = {};
      $scope.$watch('field.type', onFieldChange);

      function onFieldChange(newField) {
        if (!newField) return;
        var type = $scope.field.type || 'Unknown';
        if (type === 'ObjectId') {
          var ref = $scope.field.ref;
          if (typeof ref === 'undefined') type = "String";
          else {
            if ($scope.lookup[ref]) return;
            else $scope.lookup[ref] = [];

            $entity.lookup(ref).then(function (response) {
              $scope.lookup[ref] = response.data;
            });
          }
        }
        $scope.contentUrl = "directives/dynamicField/" + type + ".html";
      }
    }
  };
});