app.directive('entityRemove', function () {
  return {
    restrict: 'E',
    scope: {
      entity: "@",
      item: "="
    },
    transclude: true,
    templateUrl: 'directives/entity/entity.remove.html',
    controller: function ($scope, $entity, zapi) {
      var entityObj = zapi.entityMap[$scope.entity];
      if (!entityObj) return;

      $scope.remove = function (entity, item) {
        swal({
          title: "Esta ação é irreversível",
          type: "info",
          text: "Está prestes a apagar um registo, deseja continuar?",
          showCancelButton: true,
          cancelButtonText: "Cancelar",
          confirmButtonText: "OK"
        }).then(function (result) {
          if (result && result.dismiss) return;
          $entity.remove(entity, item, $scope);
        }).catch(function (err) {
          console.error(err);
        });
      };
    }
  };
});