app.directive('entitySave', function () {
  return {
    restrict: 'E',
    scope: {
      entity: "@",
      item: "=",
      form: "=",
      afterSave: '&'
    },
    templateUrl: 'directives/entity/entity.save.html',
    controller: function ($scope, $entity, $rootScope, $location, $stateParams, zapi) {
      //validate
      $scope.entity = $scope.entity || $stateParams.entity;
      var entityObj = zapi.entityMap[$scope.entity];
      if (!entityObj) return;

      var isSaving = false;
      if (entityObj.preventDirtyRedirect && !entityObj.modal) $rootScope.$on("$locationChangeStart", preventDirtyRedirect);

      $scope.save = function (entity, item) {
        isSaving = true;

        $entity.add(entity, item, $scope).then(function (response) {
          if (typeof $scope.afterSave === 'function') $scope.afterSave();
        });
      };

      function preventDirtyRedirect(event, url) {
        if (isSaving) return;
        if (!$scope.form.$dirty) return;
        event.preventDefault();
        swal({
          title: "Existem alterações não guardadas, pretende sair na mesma?",
          showConfirmButton: true,
          confirmButtonText: "Sim",
          showCancelButton: true,
          cancelButtonText: "Ainda não!",
          type: "warning"
        }).then(function (result) {
          if (result && result.dismiss) return;
          $scope.form.$setPristine();
          var locationPath = url.substring(url.indexOf('#') + 1);
          $location.path(locationPath);
          $scope.$apply();
        }).catch(function (err) {
          console.error(err);
        });
      }
    }
  };
});