app.directive('entityVersion', function () {
  return {
    restrict: 'E',
    scope: {
      entity: "@",
      item: "=",
    },
    templateUrl: 'directives/entity/entity.version.html',
    controller: function ($scope, $http, $modal, zapi, blockUI) {
      //validate
      $scope.entity = $scope.entity || $stateParams.entity;
      var entityObj = zapi.entityMap[$scope.entity];
      if (!entityObj) return;
      
      $scope.viewHistory = function () {
        if (!$scope.item._id) return;
      
        blockUI.start("A obter alterações...");
        $http.get('/api/application/versions/common/' + $scope.item._id, { cache: true }).then(function (response) {
          $modal.open('versionHistory', 'lg', { labelField: "name", item: $scope.item, versions: response.data });
        }).catch(function (response) {
          swal("Não foi possível obter as alterações", response.data, "warning");
        }).finally(function () {
          blockUI.stop();
        });
      };
    }
  };
});