app.directive('entityNotification', function () {
  return {
    restrict: 'A',
    scope: {
      entity: "@",
    },
    transclude: true,
    replace: true,
    templateUrl: "directives/notification/entity.html",
    controller: function ($scope, $modal, $http, blockUI, zapi) {
      var config = zapi.entityMap[$scope.entity] && zapi.entityMap[$scope.entity].notification;
      $scope.visible = !!config;
      var url = '/api/notification/' + $scope.entity + '/entity';

      $scope.openNotificationModal = function () {
        blockUI.start("A obter configurações de notificação...");
        $http.get(url).then(function (response) {
          var data = { notifications: response.data, entity: $scope.entity, type: 'entityEvent' };
          $modal.open('entityNotification', 'md', data, function (result) {
            //
          }, function (result) {
            //
          });
        }).catch(function (response) {
          swal("Não foi possível obter as suas configurações para esta notificação", response.data, "warning");
        }).finally(function () {
          blockUI.stop();
        });
      };
    }
  };
});