app.directive('recordNotification', function () {
  return {
    restrict: 'A',
    scope: {
      entity: "@",
      item: '='
    },
    transclude: true,
    replace: true,
    templateUrl: "directives/notification/record.html",
    controller: function ($scope, $modal, $http, blockUI, zapi) {
      var config = zapi.entityMap[$scope.entity] && zapi.entityMap[$scope.entity].notification;
      $scope.visible = !!config;
      var url = '/api/notification/' + $scope.entity + '/record/' + $scope.item[config.fields.docId];

      $scope.openNotificationModal = function () {
        blockUI.start("A obter configurações de notificação...");
        $http.get(url).then(function (response) {
          var data = { notifications: response.data, record: $scope.item, entity: $scope.entity, type: 'recordEvent' };
          $modal.open('recordNotification', 'md', data, function (result) {
            //
          }, function (result) {
            //
          });
        }).catch(function (response) {
          swal("Não foi possível obter as suas configurações para esta notificação", response.data, "warning");
        }).finally(function () {
          blockUI.stop();
        });
      };
    }
  };
});