app.directive('editRole', function () {
  return {
    restrict: 'A',
    scope: {
      item: '=',
      lookup: '=',
      form: '='
    },
    templateUrl: 'directives/role/role.edit.html',
    controller: function ($scope, $auth, $role) {
      //get role permissions
      $role.getPermissions().then(function (response) {
        $scope.permissions = response.data;

        //if new user set permissions object
        $scope.item = $scope.item || {};
        if (Object.keys($scope.item.permissions).length > 0) return;
        var permissions = {};
        for (var entity in $scope.permissions) {
          permissions[entity] = {};
          for (var action in $scope.permissions[entity]) {
            if (action === 'label') continue;
            permissions[entity][action] = true;
          }
        }
        $scope.item.permissions = permissions;
      });

      $scope.togglePermissions = function (value) {
        if (!$scope.item.permissions) $scope.item.permissions = {};

        for (var entity in $scope.permissions) {
          if (!$scope.item.permissions[entity]) $scope.item.permissions[entity] = {};

          for (var action in $scope.permissions[entity]) {
            if (action === 'label') continue;

            $scope.item.permissions[entity][action] = value;
          }
        }
      };
    }
  };
});