app.directive('numbersOnly', function() {
  return {
    require: 'ngModel',
    link: function(scope, element, attr, ngModelCtrl) {
      function onlyNumbers(text) {
        if (!text) return undefined;

        var transformedInput = text.replace(/[^0-9]/g, '');
        if (transformedInput !== text) {
          ngModelCtrl.$setViewValue(transformedInput);
          ngModelCtrl.$render();
        }
        return transformedInput;
      }

      if (attr.numbersOnly === 'true') {
        ngModelCtrl.$parsers.push(onlyNumbers);
      }
    }
  };
});