app.controller('alertCtrl', function ($scope, $http, blockUI) {
  $scope.formatEmails = function (emailArray) {
    return (emailArray || []).map(function (set) {
      return set.email;
    }).join();
  };

  $scope.testSend = function (item) {
    swal({
      title: "Email de teste endereçado a...",
      input: 'email',
      inputPlaceholder: 'email@exemplo.pt',
      showConfirmButton: true,
      confirmButtonText: "Enviar",
      showCancelButton: true,
      cancelButtonText: "Cancelar",
      type: "info"
    }).then(function (result) {
      if (result && result.dismiss) return;

      blockUI.start("A enviar email...");
      $http.post('/api/message/test', { template: item.template, email: result.value }).then(function (response) {
        swal("Email de teste", "Enviado", "success");
      }).catch(function (response) {
        swal("Não foi possível enviar teste", response.data, "warning");
      }).finally(function () {
        blockUI.stop();
      });
    }).catch(function (err) {
      console.error(err);
    });
  };
});