var app = angular.module('zapi', [
  'ngSanitize',
  'ngAnimate',
  'ngIdle',
  'ngLetterAvatar',
  'ui.bootstrap',
  'blockUI',
  'btford.socket-io',
  'ngXlsx',
  'ngTable',
  'selector',
  'gettext',
  'angularMoment',
  'moment-picker',
  'angular-loading-bar',
  'checklist-model',
  'chart.js',
  'ui.router',
]).config(function ($httpProvider, TitleProvider, cfpLoadingBarProvider, blockUIConfig, $compileProvider, $locationProvider) {
  //angular
  $httpProvider.interceptors.push(function () {
    return {
      response: function (response) {
        if (response.config.cached) return response;
        if (!response.config.url.startsWith('/api/')) return response;
        console.log(response.config.url, (JSON.stringify(response.data).length / 1024).toFixed(1) + 'kb');
        return response;
      }
    };
  });
  $compileProvider.debugInfoEnabled(false);
  //$compileProvider.commentDirectivesEnabled(false);
  //$compileProvider.cssClassDirectivesEnabled(false);
  $locationProvider.hashPrefix("");

  //ngIdle
  TitleProvider.enabled(false);

  //angular-loading-bar
  cfpLoadingBarProvider.includeSpinner = false;

  //blockUI
  blockUIConfig.autoBlock = false;
  blockUIConfig.resetOnException = true;
}).run(function (gettextCatalog) {
  gettextCatalog.setStrings('pt', {
    "api.pages.activity.title": "Logs de Atividade",
    "api.pages.alert.title": "Templates de Email",
    "api.pages.document.title": "Gestão Documental",
    "api.pages.error.title": "Logs Técnicos",
    "api.pages.holiday.title": "Feriados",
    "api.pages.license.title": "Licenciamento",
    "api.pages.maintenance.title": "Logs de Atualizações",
    "api.pages.message.title": "Logs de Email",
    "api.pages.module.title": "Módulos",
    "api.pages.newsletter.title": "Subscrições à newsletter",
    "api.pages.role.title": "Perfis de Utilização",
    "api.pages.run.title": "Processos",
    "api.pages.slider.title": "Slideshow",
    "api.pages.support.title": "Apoio Técnico",
    "api.pages.task.title": "Tarefas",
    "api.pages.user.title": "Acessos",
  });
});