app.controller('entityNotificationCtrl', function ($scope, $uibModalInstance, $http, zapi, toastr, data) {
  var config = zapi.entityMap[data.entity] && zapi.entityMap[data.entity].notification;
  if (!config) return $uibModalInstance.dismiss();
  $scope.config = config;

  $scope.cancel = $uibModalInstance.dismiss;
  $scope.ok = $uibModalInstance.close;

  $scope.entity = data.entity;
  $scope.record = data.record;

  $scope.notification = {
    entityEvent: data.notifications.find(function (n) {
      return n.type === 'entityEvent' && n.entity === data.entity;
    }) || {
        type: 'entityEvent',
        entity: data.entity,
      },

    entityDate: config.fields.dates.map(function (date) {
      var entityDate = data.notifications.find(function (n) {
        return n.type === 'entityDate' && n.entity === data.entity && n.field === date.field;
      });
      if (entityDate) entityDate.active = true;
      else entityDate = {
        type: 'entityDate',
        entity: data.entity,
        active: false,

        field: date.field,
        fieldLabel: date.label,
        daysNotice: -10,
      };
      return entityDate;
    }),
  };

  $scope.setNotification = function (notification) {
    var url = '/api/notification/set';
    if (notification.type === 'entityDate' && !notification.active) url = '/api/notification/unset';

    $http.post(url, notification).then(function (response) {
      var method;
      var message;
      switch (notification.type) {
        case "entityEvent":
          if (!notification.eventAdd && !notification.eventEdit && !notification.eventRemove) {
            method = 'error';
            message = "Subscrição anulada";
          }
          else {
            method = 'success';
            message = 'Subscrição por evento registada';
          }
          break;

        case "entityDate":
          if (notification.active) {
            method = 'success';
            message = 'Subscrição por data registada';
          }
          else {
            method = 'error';
            message = 'Subscrição anulada';
          }
          break;

        default:
          console.error('unknown notification type', notification.type);
      }

      toastr[method]('Notificação', message);
    }).catch(function (response) {
      swal("Não foi possível guardar a subscrição", response.data, "warning");
    });
  };
});