app.provider('zapi', function (apiEntityMap) {
  var map = {};
  var idle = false;
  var serverUrl = '';
  var websocketUrl;

  return {
    getRoutes: function (param) {
      if (typeof map[param.entity] === 'undefined') return 'entity/entity.notfound.html';
      if (typeof map[param.entity][param.action] === 'undefined') return 'entity/entity.notfound.html';

      switch (param.action) {
        case 'edit':
          return 'entity/entity.edit.html';

        case 'view':
          if (typeof param.id === 'undefined') return 'entity/entity.notfound.html';

          return 'entity/entity.view.html';

        case 'list':
          if (typeof param.id !== 'undefined') return 'entity/entity.notfound.html';

          return 'entity/entity.list.html';

        default:
          return 'entity/entity.notfound.html';
      }
    },

    setMap: function (entityMap) {
      map = apiEntityMap;
      for (var key in entityMap) {
        map[key] = entityMap[key];
      }
    },

    setServerUrl: function (url) {
      serverUrl = url || '';
    },

    setWebsocket: function (url) {
      websocketUrl = url || undefined;
    },

    setIdle: function (state) {
      idle = state;
    },

    $get: function () {
      return {
        entityMap: map,
        idle: idle,
        serverUrl: serverUrl,
        websocketUrl: websocketUrl,
      };
    }
  };
});