app.service('$graph', function ($http, graphOptions, zapi, apiError) {
  this.get = function (driver, namespace, db, collection, query, obj, seriesKey, dataKey, labelsKey, callback) {
    var params = {
      query: query,
      obj: obj,
      seriesKey: seriesKey,
      dataKey: dataKey,
      labelsKey: labelsKey
    };
    if (typeof driver === 'undefined') driver = 'mongo';
    var url = zapi.serverUrl + '/api/graph/auto/' + namespace + '/' + db + '/' + collection + '/' + driver;

    $http.post(url, params).then(function (response) {
      response.data.options = angular.copy(graphOptions);
      if (response.data.series.length > 0) response.data.options.legend = { display: true };
      callback(response.data);
    }).catch(function (response) {
      swal("Não foi possível desenhar o gráfico", response.data || apiError.timeout, "warning");
      callback();
    });
  };

  this.custom = function (driver, namespace, db, graph, callback) {
    if (typeof driver === 'undefined') driver = 'mongo';
    var url = zapi.serverUrl + '/api/graph/custom/' + namespace + '/' + db + '/' + graph + '/' + driver;

    $http.get(url, { cache: true }).then(function (response) {
      response.data.options = angular.copy(graphOptions);
      if (typeof response.data.series !== 'undefined') {
        if (response.data.series.length > 0) response.data.options.legend = { display: true };
      }
      callback(response.data);
    }).catch(function (response) {
      swal("Não foi possível desenhar o gráfico", response.data || apiError.timeout, "warning");
      callback();
    });
  };
});