app.service('$list', function ($http, blockUI, zapi) {
  this.getMetadata = function (callback) {
    blockUI.start("A obter listagens disponíveis...");
    $http.get(zapi.serverUrl + '/api/list/getall').then(function (response) {
      response.data.forEach(function (list) {
        list.values = {};
      });
      callback(response.data);
    }).catch(function (response) {
      swal("Atenção", "Não foi possível obter as listagens disponíveis, por favor actualize a página", "warning");
      callback([]);
    }).finally(function () {
      blockUI.stop();
    });
  };

  this.get = function (list, db, callback) {
    blockUI.start("A obter " + list.caption);
    $http.get(zapi.serverUrl + '/api/list/values/' + db + '/' + list.name, {
      params: {
        query: list.values
      }
    }).then(function (response) {
      var items, cols;
      if (response.data instanceof Array) items = response.data;
      else {
        items = response.data.items;
        cols = response.data.cols;
      }
      callback(items, cols);
    }).catch(function (response) {
      swal("Ocorreu um erro", response.data, "warning");
      callback([]);
    }).finally(function () {
      blockUI.stop();
    });
  };
});