var app = angular.module('zapi', [
  'ngSanitize',
  'ngAnimate',
  'ngIdle',
  'ngLetterAvatar',
  'ui.bootstrap',
  'blockUI',
  'btford.socket-io',
  'ngXlsx',
  'ngTable',
  'selector',
  'gettext',
  'angularMoment',
  'moment-picker',
  'angular-loading-bar',
  'checklist-model',
  'chart.js',
  'ui.router',
]).config(["$httpProvider", "TitleProvider", "cfpLoadingBarProvider", "blockUIConfig", "$compileProvider", "$locationProvider", function ($httpProvider, TitleProvider, cfpLoadingBarProvider, blockUIConfig, $compileProvider, $locationProvider) {
  //angular
  $httpProvider.interceptors.push(function () {
    return {
      response: function (response) {
        if (response.config.cached) return response;
        if (!response.config.url.startsWith('/api/')) return response;
        console.log(response.config.url, (JSON.stringify(response.data).length / 1024).toFixed(1) + 'kb');
        return response;
      }
    };
  });
  $compileProvider.debugInfoEnabled(false);
  //$compileProvider.commentDirectivesEnabled(false);
  //$compileProvider.cssClassDirectivesEnabled(false);
  $locationProvider.hashPrefix("");

  //ngIdle
  TitleProvider.enabled(false);

  //angular-loading-bar
  cfpLoadingBarProvider.includeSpinner = false;

  //blockUI
  blockUIConfig.autoBlock = false;
  blockUIConfig.resetOnException = true;
}]).run(["gettextCatalog", function (gettextCatalog) {
  gettextCatalog.setStrings('pt', {
    "api.pages.activity.title": "Logs de Atividade",
    "api.pages.alert.title": "Templates de Email",
    "api.pages.document.title": "Gestão Documental",
    "api.pages.error.title": "Logs Técnicos",
    "api.pages.holiday.title": "Feriados",
    "api.pages.license.title": "Licenciamento",
    "api.pages.maintenance.title": "Logs de Atualizações",
    "api.pages.message.title": "Logs de Email",
    "api.pages.module.title": "Módulos",
    "api.pages.newsletter.title": "Subscrições à newsletter",
    "api.pages.role.title": "Perfis de Utilização",
    "api.pages.run.title": "Processos",
    "api.pages.slider.title": "Slideshow",
    "api.pages.support.title": "Apoio Técnico",
    "api.pages.task.title": "Tarefas",
    "api.pages.user.title": "Acessos",
  });
}]);
angular.module('zapi').run(['$templateCache', function($templateCache) {$templateCache.put('entity/entity.edit.html','<div ba-panel ba-panel-title="{{item._id ? \'Editar\' : \'Criar\'}} Registo" ba-panel-class="with-scroll"><form name="_form"><div class="row"><div class="col-sm-12 text-right"><!-- SAVE --><entity-save entity="{{entity.key}}" item="item" form="_form" ng-if="(entity.edit ? (entity.edit.admin ? isAdmin() : hasClearance(entity.edit.clearance)) : false)"></entity-save><!-- BACK --> <a class="btn btn-back hvr-icon-back" onclick="window.history.back();">Voltar</a></div></div><br><div class="row"><entity-edit entity="{{entity.key}}" item="item" lookup="lookup" form="_form" fetch="true"></entity-edit></div></form></div>');
$templateCache.put('entity/entity.list.html','<div ba-panel ba-panel-title="Listagem" ba-panel-class="with-scroll"><div class="text-right"><!-- ADICIONAR --><entity-modal entity="{{entity.key}}" lookup="lookup"></entity-modal><!-- EXPORTAR --> <a ng-if="entity.xlsx && items.length != 0" ng-href="/api/{{entity.key}}/xlsx/{{entity.namespace || \'common\'}}" target="_blank" class="btn btn-xs btn-info" role="role"><i class="fa fa-file-excel-o"></i> Exportar</a><!--<entity-xlsx ng-if="!entity.xlsx" entity="entity" items="items"></entity-xlsx>--><!-- VOLTAR --> <a class="btn btn-xs btn-back hvr-icon-back" onclick="window.history.back();">Voltar</a></div><br><!-- LIST --><entity-list entity="{{entity.key}}" items="items" lookup="lookup" no-table="{{entity.noTable}}"></entity-list></div>');
$templateCache.put('entity/entity.modal.html','<div class="modal-header"><button ng-click="cancel();" class="close">&times;</button><h3 class="modal-title">{{entity.title | translate}} <small>- {{view ? "Ver" : (item._id ? "Alterar" : "Novo")}} Registo</small></h3></div><div class="modal-body"><form name="_form"><div class="row" ng-if="!view"><div class="col-md-12 text-right"><entity-save entity="{{entity.key}}" item="item" form="_form" after-save="ok()" ng-if="(entity.edit ? (entity.edit.admin ? isAdmin() : hasClearance(entity.edit.clearance)) : false)"></entity-save></div></div><div class="row"><entity-view ng-hide="!view" entity="{{entity.key}}" item="item" lookup="lookup" form="_form" fetch="true"></entity-view><entity-edit ng-hide="view" entity="{{entity.key}}" item="item" lookup="lookup" form="_form" fetch="true"></entity-edit></div><div class="row" ng-if="!view"><div class="col-md-12 text-right"><entity-save entity="{{entity.key}}" item="item" form="_form" after-save="ok()" ng-if="(entity.edit ? (entity.edit.admin ? isAdmin() : hasClearance(entity.edit.clearance)) : false)"></entity-save></div></div></form></div><div class="modal-footer hidden-xs hidden-sm"><div class="text-right"><span class="text-muted"><kbd>Esc</kbd> para sair.</span></div></div>');
$templateCache.put('entity/entity.notfound.html','<div class="row notfound text-center"><div class="txtnotfound"><h1>OOPS!</h1><br><h6><i class="fa fa-exclamation-triangle"></i> A p\xE1gina que est\xE1 \xE1 procura n\xE3o foi encontrada!</h6><br><br><a href="#/profile" class="btn btn-lg btn-primary btn-notfound"><i class="fa fa-chevron-circle-left"></i> Voltar ao In\xEDcio</a></div></div>');
$templateCache.put('entity/entity.view.html','<div class="row"><div class="col-sm-12"><entity-view ng-if="view" entity="{{entity.key}}" item="item" lookup="lookup" form="_form"></entity-view></div></div>');
$templateCache.put('assets/validation/messages.html','<p ng-message="required">Campo obrigat\xF3rio</p><p ng-message="minlength">Campo demasiado curto</p><p ng-message="maxlength">Campo demasiado longo</p><p ng-message="email">Email em formato inv\xE1lido</p><p ng-message="url">Endere\xE7o web inv\xE1lido</p><p ng-message="min">Menor que o valor m\xEDnimo permitido</p><p ng-message="max">Maior que o valor m\xE1ximo permitido</p><p ng-message="pattern">Campo n\xE3o cumpre o formato exigido</p><p ng-message="step">Valor n\xE3o se encontra dentro dos intervalos permitidos</p>');
$templateCache.put('container/attachments/attachments.new.html','<div class="col-sm-4"><div class="form-group"><label>{{\'api.containers.attachments.new.name\' | translate}}</label> <input type="text" ng-model="newContainerItem.name" class="form-control"></div></div><div class="col-sm-4"><div class="form-group"><label>{{\'api.containers.attachments.new.file\' | translate}}</label> <input type="file" file-model="newContainerItem.newFile[\'document\']" class="form-control"></div></div><div class="col-sm-4"><div class="form-group"><label>{{\'api.containers.attachments.new.cid\' | translate}}</label> <input type="text" ng-model="newContainerItem.cid" class="form-control"></div></div>');
$templateCache.put('container/attachments/attachments.view.html','<p><span ng-if="!containerItem.document">{{containerItem.name}}</span> <a ng-if="!!containerItem.document" ng-href="api/document/download/{{containerItem.document._id ? containerItem.document._id : containerItem.document}}" target="_blank"><i class="fa fa-download" aria-hidden="true"></i> {{containerItem.name}} </a><span ng-if="containerItem.cid">(cid: {{containerItem.cid}})</span></p><p ng-if="containerItem.created_at">{{\'api.containers.attachments.view.since\' | translate}} {{containerItem.created_at | date: \'yyyy-MM-dd\'}}</p>');
$templateCache.put('container/cc/cc.new.html','<div class="col-sm-12"><div class="form-group"><label>{{\'api.containers.cc.new.email\' | translate}}</label> <input type="email" ng-model="newContainerItem.email" class="form-control"></div></div>');
$templateCache.put('container/cc/cc.view.html','<small>{{containerItem.email}}</small>');
$templateCache.put('container/to/to.new.html','<div class="col-sm-12"><div class="form-group"><label>{{\'api.containers.to.new.email\' | translate}}</label> <input type="email" ng-model="newContainerItem.email" class="form-control"></div></div>');
$templateCache.put('container/to/to.view.html','<small>{{containerItem.email}}</small>');
$templateCache.put('directives/address/addressEdit.html','<div><div class="row"><div class="col-sm-9"><div class="form-group"><label>Morada</label> <input type="text" ng-model="item.address" placeholder="ex: Rua Gon\xE7alves Zarco" class="form-control"></div></div><div class="col-sm-3"><div class="form-group"><label>Porta</label> <input type="text" ng-model="item.addressDetails" ng-disabled="disable" placeholder="ex: 3C/3D" class="form-control"></div></div></div><div class="row"><div class="col-sm-4"><div class="form-group"><label>Codigo Postal</label><div class="input-group"><input type="text" ng-model="item.postalCode" code="13" dl-key-code="getAddressPT(item.postalCode)" placeholder="ex: 2910-714" class="form-control"><div class="input-group-btn"><button type="button" class="btn btn-primary" ng-disabled="validateZipcode(item.postalCode)" ng-click="getAddressPT(item.postalCode)"><i class="fa fa-search"></i></button></div></div></div></div><div class="col-sm-8"><div class="form-group"><label>Cidade</label> <input type="text" ng-model="item.city" placeholder="ex: Set\xFAbal" class="form-control"></div></div></div><div class="row"><div class="col-sm-4"><div class="form-group"><label>Concelho</label> <input type="text" ng-model="item.county" placeholder="ex: Set\xFAbal" class="form-control"></div></div><div class="col-sm-4"><div class="form-group"><label>Localidade</label> <input type="text" ng-model="item.locality" placeholder="ex: Set\xFAbal" class="form-control"></div></div><div class="col-sm-4"><div class="form-group"><label>Pa\xEDs</label> <select selector model="item.country" options="lookup.country" placeholder="Indique o pa\xEDs..."></select></div></div></div></div>');
$templateCache.put('directives/address/addressView.html','<div class="row"><div class="form-group col-sm-9 col-md-8"><label>Morada</label><p class="form-control">{{item[prefix + \'address\']}}</p></div><div class="form-group col-sm-3 col-md-4"><label>Porta</label><p class="form-control">{{item[prefix + \'addressDetails\']}}</p></div></div><div class="row"><div class="form-group col-sm-4"><label>Codigo Postal</label><p class="form-control">{{item[prefix + \'postalCode\']}}</p></div><div class="form-group col-sm-8"><label>Cidade</label><p class="form-control">{{item[prefix + \'city\']}}</p></div></div><div class="row"><div class="form-group col-sm-4"><label>Concelho</label><p class="form-control">{{item[prefix + \'county\']}}</p></div><div class="form-group col-sm-4"><label>Localidade</label><p class="form-control">{{item[prefix + \'locality\']}}</p></div><div class="form-group col-sm-4"><label>Pa\xEDs</label><p class="form-control">{{item[prefix + \'country\'].common.name}}</p></div></div>');
$templateCache.put('directives/calendar/calendar.html','<script id="groupedMonthEvents.html" type="text/ng-template"><div class="cal-month-day {{ day.cssClass }}">\n\n    <span\n      class="pull-right"\n      data-cal-date\n      ng-click="calendarCtrl.dateClicked(day.date)"\n      ng-bind="day.label">\n    </span>\n\n    <div style="position: relative; top: 35px; left: 5px">\n      <span ng-repeat="(type, events) in day.groups track by type">\n        <span class="label event-{{ type }}">{{ events.length }}</span>&nbsp;\n      </span>\n    </div>\n\n    <div class="cal-day-tick" ng-show="dayIndex === openDayIndex && view[openDayIndex].events.length > 0 && !slideBoxDisabled">\n      <i class="glyphicon glyphicon-chevron-up"></i>\n      <i class="fa fa-chevron-up"></i>\n    </div>\n\n  </div></script><div><h2 class="text-center">{{calendarTitle}}</h2><div class="row"><div class="col-md-6 text-center"><div class="btn-group btn-group-md"><button class="btn btn-primary" mwl-date-modifier date="viewDate" decrement="calendarView"><span class="fa fa-caret-left"></span></button> <button class="btn btn-primary active" mwl-date-modifier date="viewDate" set-to-today><span class="fa fa-calendar"></span></button> <button class="btn btn-primary" mwl-date-modifier date="viewDate" increment="calendarView"><span class="fa fa-caret-right"></span></button></div></div><br class="visible-xs visible-sm"><div class="col-md-6 text-center"><div class="btn-group btn-group-md"><label class="btn btn-primary" ng-model="calendarView" uib-btn-radio="\'year\'">Ano</label> <label class="btn btn-primary" ng-model="calendarView" uib-btn-radio="\'month\'">M\xEAs</label> <label class="btn btn-primary" ng-model="calendarView" uib-btn-radio="\'week\'">Semana</label> <label class="btn btn-primary" ng-model="calendarView" uib-btn-radio="\'day\'">Dia</label></div></div></div><br><div class="row"><div class="col-sm-12"><mwl-calendar events="events" view="calendarView" view-title="calendarTitle" view-date="viewDate" cell-is-open="isCellOpen" day-view-start="06:00" day-view-end="22:00" day-view-split="30" cell-modifier="groupEvents(calendarCell)" class="col-sm-12"></mwl-calendar></div></div></div>');
$templateCache.put('directives/document/file.html','<div ng-if="!item[var]._id" class="form-group"><label>Carregar ficheiro</label> <input type="file" file-model ng-model="item.newFile[var]" class="form-control"></div><a ng-if="!!docid" ng-href="api/document/download/{{docid}}" target="_blank"><i class="fa fa-download"></i> Download ficheiro</a>');
$templateCache.put('directives/dynamicField/Boolean.html','<input type="checkbox" ng-model="model[key]" class="w3-check">');
$templateCache.put('directives/dynamicField/Date.html','<input name="model[key]" ng-model="model[key]" ng-model-options="{ updateOn: \'blur\' }" moment-picker="model[key]" today="true" locale="pt" format="YYYY-MM-DD" start-view="month" required placeholder="Selecione uma data..." class="form-control">');
$templateCache.put('directives/dynamicField/Number.html','<input type="number" ng-model="model[key]" class="form-control">');
$templateCache.put('directives/dynamicField/ObjectId.html','<select selector model="model[key]" options="lookup[field.ref]" multi="field.multi || false" placeholder="{{field.placeholder}}" ng-attr-label-attr="{{field.label || undefined}}" ng-attr-value-attr="{{field.value || undefined}}"></select>');
$templateCache.put('directives/dynamicField/String.html','<input type="text" ng-model="model[key]" class="form-control">');
$templateCache.put('directives/dynamicField/Unknown.html','<p>N\xE3o Dispon\xEDvel</p>');
$templateCache.put('directives/factoryDefaults/factoryDefaults.html','<a href ng-click="resetFactoryDefaults()" class="small"><i class="fa fa-bolt" aria-hidden="true"></i> Rep\xF4r pr\xE9-defini\xE7\xF5es</a>');
$templateCache.put('directives/entity/entity.array.html','<div class="panel panel-default" ng-init="collapse = (item[var] ? item[var].length > 0 : false)"><div class="panel-heading"><div class="row"><div class="col-sm-8"><h6>{{label}} <span class="badge" ng-if="item[var]">{{item[var].length}}</span></h6></div><div class="col-sm-4 text-right"><button type="button" ng-click="collapse = !collapse" class="btn btn-default btn-xs"><i class="fa fa-caret-{{collapse ? \'down\' : \'up\'}}"></i> {{collapse ? "Ver mais" : "Ver menos"}}</button></div></div></div><div class="panel-body" ng-show="!collapse"><div class="row" ng-if="!noInsert"><div class="col-sm-9"><div ng-include="\'container/\' + var + \'/\' + var + \'.new.html\'"></div></div><div class="col-sm-3 text-right"><console></console><button type="button" ng-show="!console" ng-click="append(newContainerItem)" ng-disabled="validate(newContainerItem)" class="btn btn-sm btn-primary" style="margin-top:30px;"><i class="fa fa-plus" aria-hidden="true"></i> Adicionar {{label}}</button></div></div><div class="row"><div ng-if="isVisible ? isVisible(containerItem) : true" ng-repeat="containerItem in item[var] track by $index" class="col-sm-3 col-xs-6 text-center"><div class="customitem well"><div ng-include="\'container/\' + var + \'/\' + var + \'.view.html\'"></div><button type="button" ng-if="isMovable" class="btn btn-xs btn-default" ng-disabled="$index === 0" ng-click="pushBack($index)"><span class="fa fa-arrow-left"></span></button> <button type="button" class="btn btn-danger btn-xs" ng-disabled="!removable" ng-click="remove(containerItem)"><i class="fa fa-trash-o" aria-hidden="true"></i></button> <button type="button" ng-if="isMovable" class="btn btn-xs btn-default" ng-disabled="$index === item[var].length - 1" ng-click="pushForward($index)"><span class="fa fa-arrow-right"></span></button></div></div><div class="col-sm-12" ng-if="(!item[var] || item[var].length === 0)"><p>N\xE3o existem {{label}}</p></div></div></div></div>');
$templateCache.put('directives/entity/entity.filter.html','<div class="input-group input-group-sm"><span class="input-group-addon"><i class="fa fa-search" aria-hidden="true"></i></span> <input type="text" ng-model="search.text" ng-keyup="applySearch(search)" placeholder="Pesquise em todos os campos" class="form-control"></div>');
$templateCache.put('directives/entity/entity.list.html','<div ng-if="!noTable && items.length !== 0"><entity-filter entity="{{entity}}" table="table" lookup="lookup"></entity-filter></div><div ng-if="items.length !== 0"><div ng-include src="contentUrl" include-replace></div></div><div ng-if="items.length === 0"><p class="text-info text-center strong"><i class="fa fa-info-circle" aria-hidden="true"></i> N\xE3o existem {{entityObj.title | translate}} em registo</p></div>');
$templateCache.put('directives/entity/entity.modal.html','<a ng-if="visible" ng-click="openModal()"><ng-transclude><button type="button" class="btn btn-{{color}} btn-xs"><i class="fa {{icon}}" aria-hidden="true"></i> {{text}}</button></ng-transclude></a>');
$templateCache.put('directives/entity/entity.remove.html','<a ng-click="remove(entity, item);"><ng-transclude><button type="button" class="btn btn-danger btn-xs"><i class="fa fa-trash" aria-hidden="true"></i> {{"global.delete" | translate}}</button></ng-transclude></a>');
$templateCache.put('directives/entity/entity.save.html','<button type="button" ng-click="save(entity, item);" ng-disabled="form.$invalid" class="btn btn-primary"><i class="fa fa-floppy-o" aria-hidden="true"></i> {{"global.save" | translate}}</button>');
$templateCache.put('directives/entity/entity.version.html','<button type="button" ng-click="viewHistory()" class="btn btn-xs btn-info"><i class="fa fa-history"></i></button>');
$templateCache.put('directives/entity/entity.xlsx.html','<a ng-if="entity.xlsx" ng-click="export()"><ng-transclude><button type="button" class="btn btn-info btn-xs">Exportar <i class="fa fa-file-excel-o" aria-hidden="true"></i></button></ng-transclude></a>');
$templateCache.put('directives/graph/graph.html','<div ng-if="!noPanel" class="panel panel-default"><div class="panel-heading"><h6>{{item.title}}</h6></div><div class="panel-body" block-ui="graphBlockUI"><canvas ng-if="(chart.data || []).length !== 0" class="chart-base" chart-type="item.type" chart-data="chart.data" chart-labels="chart.labels" chart-series="chart.series" chart-options="chart.options"></canvas><p ng-if="(chart.data || []).length === 0">N\xE3o existem dados para elaborar o gr\xE1fico</p></div><!--\n  <div class="panel-footer text-right">\n    <a ng-if="!noToggle" ng-click="toggle()"><i class="fa fa-arrow-right"></i> {{getNext()}}</a>\n  </div>\n  --></div><div ng-if="!!noPanel" block-ui="graphBlockUI"><canvas ng-if="(chart.data || []).length !== 0" class="chart-base" chart-type="item.type" chart-data="chart.data" chart-labels="chart.labels" chart-series="chart.series" chart-options="chart.options"></canvas><p ng-if="(chart.data || []).length === 0">N\xE3o existem dados para elaborar o gr\xE1fico</p></div>');
$templateCache.put('directives/list/list.html','<div><!--HEADER--><div class="row text-right"><div class="col-sm-12 list-filters" style="padding-top: 10px;"><!--LIST SELECTOR--><div class="list-filter"><select ng-model="list" ng-change="reset(list)" ng-options="list as list.caption for list in lists" class="form-control"></select></div><!--DATA COUNT--><div ng-if="list" class="list-filter"><span>{{items.length}} resultados</span></div><!-- FILTER SELECTOR --><div ng-if="list" class="list-filter"><button type="button" ng-if="list.parameters.length !== 0" ng-click="setParameters(list)" class="btn"><i class="fa fa-filter"></i>&nbsp;{{list.parameters.length}} Filtros</button></div><!-- GET LIST BUTTON --><div ng-if="list" class="list-filter"><button type="button" ng-click="get(list)" class="btn btn-primary"><i class="fa fa-desktop" aria-hidden="true"></i>&nbsp;Procurar</button></div><!--EXPORT EXCEL--><div ng-if="list && items.length !== 0" class="list-filter"><a ng-href="{{getExcelUrl(list)}}" target="_blank" class="btn btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>&nbsp;Exportar</a></div><!--EXPORT PDF--><div ng-if="list && items.length !== 0" class="list-filter"><a ng-href="{{getPdfUrl(list)}}" target="_blank" class="btn btn-info"><i class="fa fa-file-pdf-o" aria-hidden="true"></i>&nbsp;Exportar</a></div></div></div><!--SEARCH--><div class="row"><div class="col-sm-12"><div class="form-group"><div class="input-group"><span class="input-group-addon">{{search.inverted ? \'Excluindo\' : \'Incluindo\'}} <input type="checkbox" ng-model="search.inverted"> </span><input type="text" ng-model="search.text" ng-disabled="items.length === 0" placeholder="Procurar nos dados abaixo" class="form-control"> <span class="input-group-btn"><button type="button" ng-click="applySearch(search)" ng-disabled="!search.text || items.length === 0" class="btn btn-primary"><i class="fa fa-search"></i></button></span></div></div></div></div><!--BODY--><div class="row"><!--NO DATA--><div ng-show="items.length === 0" class="col-sm-12"><p class="text-info"><strong><i class="fa fa-info-circle" aria-hidden="true"></i> N\xE3o existem dados para a listagem efectuada</strong></p></div><!--TABLE--><div ng-show="items.length !== 0 && !list.group" class="col-sm-12"><div class="table-responsive"><table ng-table-dynamic="tableParams with list.cols" class="table table-bordered"><tr ng-repeat="row in $data" ng-class="{\'text-success\': row.color === \'success\', \'text-danger\': row.color === \'danger\'}"><td ng-repeat="col in $columns" ng-bind-html="col.getValue(this, row)"></td></tr></table></div></div><!--GROUP TABLE--><div ng-show="items.length !== 0 && list.group" class="col-sm-12"><div class="table-responsive"><table ng-table-dynamic="tableParams with list.cols" class="table table-bordered" show-group="isGroupHeaderRowVisible"><tr class="ng-table-group" ng-repeat-start="group in $groups"><td colspan="{{list.cols.length}}"><a ng-click="group.$hideRows = !group.$hideRows"><span class="fa" ng-class="{ \'fa-angle-right\': group.$hideRows, \'fa-angle-down\': !group.$hideRows }"></span> <strong ng-bind="group.value"></strong></a></td></tr><tr ng-hide="group.$hideRows" ng-repeat="row in group.data" ng-repeat-end><td ng-repeat="col in $columns" ng-bind-html="col.getValue(this, row)"></td></tr></table></div></div></div></div>');
$templateCache.put('directives/newsletter/newsletter.html','<ng-form name="_formNewsletter"><div class="input-group subnewsletter" ng-class="{\'has-error\': _formNewsletter.email.$touched && _formNewsletter.email.$invalid}"><input code="13" dl-key-code="saveEmail(newsItem);" ng-model="newsItem.email" name="email" type="email" placeholder="Endere\xE7o eletr\xF3nico" class="form-control" required> <span class="input-group-btn"><button ng-click="saveEmail(newsItem);" class="btn btn-primary" type="button"><i class="fa fa-paper-plane" aria-hidden="true"></i></button></span></div><div class="help-block" ng-messages="_formNewsletter.email.$error" ng-if="_formNewsletter.email.$touched"><div ng-messages-include="assets/validation/messages.html"></div></div></ng-form>');
$templateCache.put('directives/notification/entity.html','<span ng-show="visible" ng-click="openNotificationModal()"><ng-transclude><button type="button" class="btn btn-xs btn-warning"><i class="fa fa-bell-o"></i></button></ng-transclude></span>');
$templateCache.put('directives/notification/record.html','<span ng-show="visible" ng-click="openNotificationModal()"><ng-transclude><button type="button" class="btn btn-xs btn-warning"><i class="fa fa-bell-o"></i></button></ng-transclude></span>');
$templateCache.put('directives/report/report.html','<uib-tabset active="activeTab"><!-- LOAD/NEW --><uib-tab index="0"><uib-tab-heading><i class="fa fa-list"></i> As minhas listagens</uib-tab-heading><div class="container-fluid"><!--LIST WITH DATA--><ul class="api-list-item api-md list-unstyled"><li ng-repeat="savedItem in savedItems"><a ng-click="loadReport(savedItem, 4)" class="listlink" ng-bind="savedItem.name"></a> <a ng-click="removeReport(savedItem)" class="btn btn-danger btn-xs pull-right"><i class="fa fa-trash" aria-hidden="true"></i> apagar</a> <a ng-click="loadReport(savedItem, 1)" class="btn btn-primary btn-xs api-edit pull-right"><i class="fa fa-pencil" aria-hidden="true"></i> editar</a></li></ul><!--LIST WITHOUT DATA--><h6 ng-if="savedItems.length === 0" class="text-info"><i class="fa fa-exclamation-circle" aria-hidden="true"></i> Ainda n\xE3o guardou nenhuma listagem parametrizada</h6><!--NEW LIST ITEM--> <button type="button" ng-click="reset()" class="btn btn-primary btn-md pull-right" style="margin-top:20px;">Criar nova listagem <i class="fa fa-plus"></i></button></div></uib-tab><!-- INCLUDE --><uib-tab index="1"><uib-tab-heading><i class="fa fa-plus"></i> Dados a incluir na minha listagem</uib-tab-heading><div class="container-fluid"><uib-accordion close-others="false"><div uib-accordion-group class="panel-default" is-open="tab.isOpen" ng-repeat="tab in fieldTabs"><uib-accordion-heading>{{tab.name}} <i class="pull-right glyphicon" ng-class="{\'glyphicon-chevron-down\': tab.isOpen, \'glyphicon-chevron-right\': !tab.isOpen}"></i></uib-accordion-heading><div class="col-md-3 col-sm-4 col-xs-6" ng-repeat="field in fields | filter: {tab: tab.name}"><input type="checkbox" checklist-model="item.select" checklist-value="field.id" class="w3-check"> <label class="w3-validate" ng-bind="field.caption"></label></div></div></uib-accordion></div></uib-tab><!-- FILTER --><uib-tab index="2"><uib-tab-heading><i class="fa fa-filter"></i> Filtrar</uib-tab-heading><div class="container-fluid"><a class="pull-right btn btn-md btn-info" ng-click="appendQuery()" style="margin-bottom:15px;">Adicionar Linha <i class="fa fa-plus"></i> </a><select selector model="item.aggregator" options="lookup.aggregator" placeholder="Operador" class="pull-right"></select><table class="table table-bordered"><thead><tr><th>Informa\xE7\xE3o</th><th>Operador</th><th>Valor</th><th></th></tr></thead><tbody><tr ng-repeat="query in item.query track by $index"><td><select selector model="query.field" options="fields" label-attr="caption" placeholder="Indique o campo..."></select></td><td><div query-builder field="query.field" model="query" key="operator"></div></td><td><div dynamic-field field="query.field" model="query" key="value"></div></td><td class="text-right"><button type="button" ng-click="removeQuery($index)" class="btn btn-danger"><i class="fa fa-trash"></i></button></td></tr></tbody></table></div></uib-tab><!-- SORT --><uib-tab index="3"><uib-tab-heading><i class="fa fa-sort-alpha-asc"></i> Ordenar</uib-tab-heading><div class="container-fluid"><div class="col-sm-6 form-group"><label>Campo</label> <select ng-model="item.sort.field" ng-options="field.id as field.caption for field in fields" class="form-control"></select></div><div class="col-sm-6"><br><input type="radio" ng-model="item.sort.type" ng-value="1" class="w3-radio"> <label class="w3-validate">Ascendente</label>&nbsp;&nbsp; <input type="radio" ng-model="item.sort.type" ng-value="-1" class="w3-radio"> <label class="w3-validate">Descendente</label></div></div></uib-tab><!-- VIEW --><uib-tab index="4"><uib-tab-heading><i class="fa fa-eye"></i> Visualizar</uib-tab-heading><div class="container-fluid"><ul class="list-unstyled list-inline"><li><a ng-click="getReport(item)" class="btn btn-primary btn-md">Ver no Ecr\xE3 <i class="fa fa-desktop" aria-hidden="true"></i></a></li><li><a ng-href="{{getExcelUrl(item)}}" target="_blank" class="btn btn-primary btn-md">Ver em Excel <i class="fa fa-file-excel-o" aria-hidden="true"></i></a></li><li><a ng-href="{{getPdfUrl(item)}}" target="_blank" class="btn btn-primary btn-md">Ver em PDF <i class="fa fa-file-pdf-o" aria-hidden="true"></i></a></li><li ng-if="!!items">Resultados: {{items.length}}</li></ul><div ng-if="!!items" class="row"><!--SEARCH--><div class="col-sm-12" style="margin:20px 0;"><div class="input-group"><span class="input-group-addon">{{search.inverted ? \'Excluindo\' : \'Incluindo\'}} <input type="checkbox" ng-model="search.inverted"> </span><input type="text" class="form-control" placeholder="Criterio de Pesquisa" ng-model="search.text"> <span class="input-group-btn"><button class="btn btn-primary" type="button" ng-click="applySearch(search)" ng-disabled="!search.text"><i class="fa fa-search"></i></button></span></div></div><!--TABLE--><div class="col-sm-12 table-responsive"><table ng-table-dynamic="tableParams with cols" class="table table-bordered"><tr ng-repeat="row in $data"><td ng-repeat="col in $columns" ng-bind="row[col.field]"></td></tr></table></div></div></div></uib-tab><!-- SAVE --><uib-tab index="5"><uib-tab-heading><i class="fa fa-save"></i> Guardar</uib-tab-heading><div class="container-fluid"><div class="col-sm-12 form-group"><label>Nome</label><div class="input-group"><input type="text" ng-model="item.name" ng-disabled="!!item._id" class="form-control"><div class="input-group-btn"><button type="button" ng-click="saveReport(item)" class="btn btn-primary">Guardar <i class="fa fa-save"></i></button></div></div></div></div></uib-tab></uib-tabset>');
$templateCache.put('directives/role/role.edit.html','<div class="col-sm-12"><div class="row"><div class="col-sm-6"><div class="form-group"><label>Nome</label> <input type="text" ng-model="item.name" placeholder="ex: Veterin\xE1rio" class="form-control"></div></div><div class="col-sm-3"><div class="form-group"><label>N\xEDvel de Administrador</label><br><input type="checkbox" ng-model="item.admin" class="form-control w3-check"></div></div><div class="col-sm-3"><div class="form-group"><label>N\xEDvel de Aprova\xE7\xE3o</label> <input type="number" ng-model="item.approvalLevel" min="0" class="form-control"></div></div></div><!--NON ADMIN ONLY--><div ng-hide="item.admin"><div class="row"><div class="col-sm-12"><p><label>Permiss\xF5es</label> <a ng-click="togglePermissions(true)" class="btn btn-info">todas</a> - <a ng-click="togglePermissions(false)" class="btn btn-info">nenhuma</a></p></div></div><div class="row"><div class="col-sm-12"><div class="table-responsive"><table class="table table-striped table-bordered table-condensed"><tr ng-repeat="(entityName, entity) in permissions"><td>{{entity.label}}</td><td><p ng-repeat="(actionName, action) in entity" ng-if="actionName !== \'label\'"><input type="checkbox" ng-model="item.permissions[entityName][actionName]" class="w3-check"> {{action.label}}</p></td></tr></table></div></div></div></div></div>');
$templateCache.put('directives/user/user.edit.html','<div class="col-sm-12"><div class="row"><div class="col-sm-4"><div class="form-group"><label>Username</label> <input type="text" ng-model="item.username" placeholder="ex: Username" class="form-control"></div></div><div class="col-sm-4"><div class="form-group"><label>Email</label> <input type="email" ng-model="item.email" placeholder="ex: mail@mail.com" class="form-control"></div></div><div class="col-sm-4"><div class="form-group"><label>Perfil de Utilizador</label> <select selector model="item.role" options="lookup.role" disable="!isAdmin()" label-attr="name" placeholder="Selecione um perfil"></select></div></div></div></div>');
$templateCache.put('entity/activity/activity.list.html','<div class="table-responsive"><table ng-table="table.params" class="table table-striped table-condensed"><tr ng-repeat="item in $data"><td data-title="\'Data/Hora\'" sortable="\'created_at\'">{{item.created_at | date: \'yyyy.MM.dd HH:mm\'}}</td><td data-title="\'Utilizador\'" sortable="\'who\'"><entity-modal ng-if="item.who" entity="user" item="item.who"><a href><i class="fa fa-user"></i> {{item.who.username}}</a></entity-modal></td><td data-title="\'Ac\xE7\xE3o\'" sortable="\'action\'">{{item.action}}</td><td data-title="\'Objecto\'" sortable="\'what\'">{{item.where}} ({{item.what}})</td></tr></table></div>');
$templateCache.put('entity/alert/alert.edit.html','<div class="col-sm-12"><div class="row"><div class="col-sm-6"><div class="form-group"><label>Descritivo</label> <input type="text" ng-model="item.name" class="form-control"></div></div><div class="col-sm-4"><div class="form-group"><label>Template</label> <input type="text" ng-model="item.template" class="form-control"></div></div><div class="col-sm-2"><div class="form-group"><label>Ativo</label><br><input type="checkbox" ng-model="item.active" class="w3-check"></div></div></div><div class="row"><div class="col-sm-12"><div class="form-group"><label>T\xEDtulo do Email</label> <input type="text" ng-model="item.subject" class="form-control"></div></div></div><div class="row"><div class="col-sm-4"><div class="form-group"><legend style="margin-bottom:3px;"><strong>De</strong></legend><input type="checkbox" ng-model="item.fromSelf" class="w3-check"> <label>Pr\xF3prio</label><br><input type="checkbox" ng-model="item.fromCoordinator" class="w3-check"> <label>Chefia</label></div></div><div class="col-sm-4"><div class="form-group"><legend style="margin-bottom:3px;"><strong>Para</strong></legend><input type="checkbox" ng-model="item.toSelf" class="w3-check"> <label>Pr\xF3prio</label><br><input type="checkbox" ng-model="item.toCoordinator" class="w3-check"> <label>Chefia</label></div></div><div class="col-sm-4"><div class="form-group"><legend style="margin-bottom:3px;"><strong>CC</strong></legend><input type="checkbox" ng-model="item.ccSelf" class="w3-check"> <label>Pr\xF3prio</label><br><input type="checkbox" ng-model="item.ccCoordinator" class="w3-check"> <label>Chefia</label></div></div></div><div class="row"><div class="col-sm-12"><div class="form-group"><label>Endere\xE7o De</label> <input type="email" ng-model="item.from" required class="form-control"></div></div></div><div entity-array item="item" var="to" key="email" is-object="true" label="Endere\xE7os Para" removable="true"></div><div entity-array item="item" var="cc" key="email" is-object="true" label="Endere\xE7os CC" removable="true"></div><div entity-array item="item" var="attachments" key="cid" is-object="true" label="Anexos" removable="true"></div></div>');
$templateCache.put('entity/alert/alert.list.html','<div class="table-responsive"><table ng-table="table.params" class="table table-striped table-condensed"><tr ng-repeat="item in $data"><td data-title="\'Activo\'" sortable="\'active\'">{{item.active ? \'Sim\' : \'N\xE3o\'}}</td><td data-title="\'Alerta\'" sortable="\'name\'" filter="{name: \'text\'}">{{item.name}}</td><td data-title="\'De\'" filter="{from: \'text\'}"><small ng-if="item.fromSelf">Pr\xF3prio,&nbsp;</small> <small ng-if="item.fromCoordinator">Chefia,&nbsp;</small> <small>{{item.from}}</small></td><td data-title="\'Para\'" filter="{to: \'text\'}"><small ng-if="item.toSelf">Pr\xF3prio,&nbsp;</small> <small ng-if="item.toCoordinator">Chefia,&nbsp;</small> <small>{{formatEmails(item.to)}}</small></td><td data-title="\'CC\'" filter="{cc: \'text\'}"><small ng-if="item.ccSelf">Pr\xF3prio,&nbsp;</small> <small ng-if="item.ccCoordinator">Chefia,&nbsp;</small> <small>{{formatEmails(item.cc)}}</small></td><td data-title="\'Anexo(s)\'"><span class="badge"><i class="fa fa-paperclip"></i>&nbsp;{{item.attachments.length}}</span></td><td class="text-right"><button type="button" ng-click="testSend(item)" class="btn btn-xs btn-danger"><i class="fa fa-telegram"></i></button></td><td class="text-right"><entity-modal entity="alert" item="item" lookup="lookup"></entity-modal></td><td class="text-right"><entity-remove entity="alert" item="item"></entity-remove></td></tr></table></div>');
$templateCache.put('entity/error/error.list.html','<div class="table-responsive"><table ng-table="table.params" class="table table-striped table-condensed"><tr ng-repeat="item in $data"><td data-title="\'Data/Hora\'" sortable="\'created_at\'" class="text-nowrap">{{item.created_at | date: \'yyyy-MM-dd HH:mm\'}}</td><td data-title="\'Descri\xE7\xE3o\'" sortable="\'description\'" style="width: 100%;">{{item.description | limitTo: 150}}</td><td class="text-right text-nowrap"><button ng-click="openModal(\'stackTrace\', \'lg\', item)" type="button" class="btn btn-xs btn-primary"><i class="fa fa-eye"></i> Ver Mais</button></td></tr></table></div>');
$templateCache.put('entity/holiday/holiday.edit.html','<div class="col-sm-6"><div class="form-group"><label>Nome</label> <input type="text" ng-model="item.name" placeholder="ex: Ano Novo" class="form-control"></div></div><div class="col-sm-6"><div class="form-group"><label>Ocorr\xEAncia</label> <input type="radio" ng-model="item.format" value="dynamic" class="w3-radio"> M\xF3vel<br><input type="radio" ng-model="item.format" value="static" class="w3-radio"> Fixo</div></div><div class="col-sm-6"><div class="form-group"><label>Pa\xEDs</label> <select selector model="item.country" options="lookup.country" placeholder="Indique o pa\xEDs..."></select></div></div><div class="col-sm-6"><div class="form-group"><label>Municipal</label><br><input type="checkbox" ng-model="item.isLocal" class="w3-check"></div></div><div class="col-sm-12" ng-show="item.format === \'dynamic\'"><div class="form-group"><label>Formula</label> <textarea rows="4" ng-model="item.formula" placeholder="function(year){return new Date(year +\'-01-01T00:00:00\');}" class="form-control"></textarea></div></div><div class="col-sm-12" ng-show="item.format === \'static\'"><div class="form-group"><label>Data</label> <input type="text" ng-model="item.date" placeholder="ex: 01/01" class="form-control"></div></div><div class="col-sm-12" ng-if="item._id"><div class="form-group"><label>Pr\xF3xima Ocorr\xEAncia</label> <input type="text" readonly="readonly" ng-value="calculateNextOccurrence(item)" placeholder="N/A" class="form-control"></div></div>');
$templateCache.put('entity/holiday/holiday.list.html','<div class="table-responsive"><table ng-table="table.params" class="table table-striped table-condensed"><tr ng-repeat="item in $data"><td data-title="\'Nome\'" sortable="\'name\'">{{item.name}}</td><td data-title="\'Pr\xF3ximo\'">{{item.next | date: \'yyyy-MM-dd\'}}</td><td data-title="\'Pa\xEDs\'" sortable="\'country\'">{{item.country}}</td><td data-title="\'\xC2mbito\'" sortable="\'isLocal\'">{{item.isLocal ? \'Municipal\' : \'Nacional\'}}</td><td class="text-right"><entity-modal entity="holiday" item="item" lookup="lookup"></entity-modal></td><td class="text-right"><entity-remove entity="holiday" item="item"></entity-remove></td></tr></table></div>');
$templateCache.put('entity/license/license.edit.html','<div class="col-sm-4"><div ng-repeat="module in lookup.module | orderBy: \'name\'" class="form-group"><input type="checkbox" checklist-model="item.modules" checklist-value="module._id" class="w3-check"> <label class="w3-validate">{{module.name}}</label></div></div><div class="col-sm-8"><div class="row"><div class="col-sm-12"><div class="form-group"><label>Cliente</label> <select ng-model="item.customer" ng-options="owner._id as owner.username for owner in lookup.owner track by owner._id" class="form-control input-lg" required></select></div></div></div><div class="row"><div class="col-sm-6"><div class="form-group"><label>Data In\xEDcio</label> <input type="date" as-date ng-model="item.dateStart" required class="form-control input-lg"></div></div><div class="col-sm-6"><div class="form-group"><label>Data Fim</label> <input type="date" as-date ng-model="item.dateEnd" required class="form-control input-lg"></div></div></div><div class="row"><div class="col-sm-12"><div class="form-group"><label>Fatura</label> <input type="text" ng-model="item.invoice" class="form-control input-lg" required></div></div></div></div>');
$templateCache.put('entity/license/license.list.html','<div class="table-responsive"><table ng-table="table.params" class="table table-bordered table-hover"><tr ng-repeat="item in $data"><td data-title="\'Registado em\'" sortable="\'created_at\'" class="number">{{item.created_at | date: \'yyyy-MM-dd HH:mm\'}}</td><td data-title="\'Registado por\'" sortable="\'owner.username\'">{{item.owner.username}}</td><td data-title="\'Cliente\'" sortable="\'customer.username\'">{{item.customer.username}}</td><td data-title="\'# m\xF3dulos\'" sortable="\'modules.length\'">{{item.modules.length}}</td><td data-title="\'Fatura\'" sortable="\'invoice\'" class="number">{{item.invoice}}</td><td data-title="\'In\xEDcio\'" sortable="\'dateStart\'" class="number">{{item.dateStart | date: \'yyyy-MM-dd\'}}</td><td data-title="\'Fim\'" sortable="\'dateEnd\'" class="number">{{item.dateEnd | date: \'yyyy-MM-dd\'}}</td><td class="text-right"><entity-modal entity="license" item="item" lookup="lookup" view="{{!isAdmin() || \'\'}}"></entity-modal></td></tr></table></div>');
$templateCache.put('entity/maintenance/maintenance.edit.html','<div class="col-sm-12"><div class="col-sm-12"><div class="form-group"><label>Motivo</label> <textarea rows="4" ng-model="item.reason" class="form-control"></textarea></div></div></div>');
$templateCache.put('entity/maintenance/maintenance.list.html','<div class="table-responsive"><table ng-table="table.params" class="table table-striped table-condensed"><tr ng-repeat="item in $data"><td data-title="\'Data/Hora\'" sortable="\'created_at\'" class="text-nowrap">{{item.created_at | date: \'yyyy-MM-dd HH:mm\'}}</td><td data-title="\'Motivo\'" sortable="\'reason\'">{{item.reason | limitTo: 150}}</td></tr></table></div>');
$templateCache.put('entity/message/message.list.html','<div class="table-responsive"><table ng-table="table.params" class="table table-bordered table-hover table-condensed"><tr ng-repeat="item in $data"><td data-title="\'Data/Hora\'" sortable="\'created_at\'">{{item.created_at | date: \'yyyy-MM-dd HH:mm\'}}</td><td data-title="\'Tipo\'" sortable="\'template\'"><entity-modal entity="alert" item="item.template"><a href><i class="fa fa-envelope"></i> {{item.template.name}}</a></entity-modal></td><td class="text-right"><button ng-click="openModal(\'viewMsg\', \'md\', item)" type="button" class="btn btn-xs btn-primary"><i class="fa fa-eye"></i> Ver</button></td></tr></table></div>');
$templateCache.put('entity/module/module.edit.html','<div class="col-sm-12"><div class="row"><div class="col-sm-12"><div class="form-group"><label>Nome</label> <input type="text" ng-model="item.name" class="form-control input-lg"></div></div></div><div class="row"><div class="col-sm-12"><div class="form-group"><label>Descri\xE7\xE3o</label> <textarea rows="3" ng-model="item.description" class="form-control"></textarea></div></div></div><div class="row"><div class="col-sm-12"><input type="checkbox" ng-model="item.is_core" class="w3-check"> <label class="w3-validate">M\xF3dulo Principal</label></div></div><div class="row"><div class="col-sm-12 table-responsive"><table class="table table-striped table-condensed"><thead><tr><th>Escal\xE3o</th><th>Pre\xE7o</th><th></th></tr></thead><tbody><tr ng-repeat="price in (item.price | orderBy: \'index\') track by $index"><td>{{price.index}}</td><td><div class="input-group"><input type="number" ng-model="price.value" class="form-control"> <span class="input-group-addon">\u20AC</span></div></td><td class="text-right"><button ng-if="$index === item.price.length - 1" ng-click="removePrice(item)" class="btn btn-danger"><i class="fa fa-trash"></i></button></td></tr></tbody><tfoot><tr><td colspan="3"><button ng-click="appendPrice(item)" class="btn btn-xs btn-info"><i class="fa fa-plus"></i> Adicionar escal\xE3o</button></td></tr></tfoot></table></div></div></div>');
$templateCache.put('entity/module/module.list.html','<div class="table-responsive"><table ng-table="table.params" class="table table-bordered table-hover"><tr ng-repeat="item in $data"><td data-title="\'M\xF3dulo Pr\xEDncipal\'" sortable="\'is_core\'">{{item.is_core ? \'Sim\' : \'N\xE3o\'}}</td><td data-title="\'Nome\'" sortable="\'name\'">{{item.name}}</td><td data-title="\'Pre\xE7os/Escal\xE3o\'"><span ng-repeat="price in item.price"><strong>{{price.index}}:</strong> {{price.value}}\u20AC&nbsp;</span></td><td class="text-right"><entity-modal entity="module" item="item" lookup="lookup"></entity-modal></td></tr></table></div>');
$templateCache.put('entity/role/role.edit.html','<div edit-role item="item" lookup="lookup" form="_form"></div>');
$templateCache.put('entity/role/role.list.html','<div class="table-responsive"><table ng-table="table.params" class="table table-striped table-condensed"><tr ng-repeat="item in $data"><td data-title="\'name\'" sortable="\'name\'">{{item.name}}</td><td data-title="\'Administrador\'" sortable="\'admin\'"><i ng-class="item.admin ? \'fa fa-check\' : \'fa fa-times\'"></i></td><td data-title="\'N\xEDvel de Aprova\xE7\xE3o\'" sortable="\'approvalLevel\'"><span ng-bind="item.approvalLevel" class="badge"></span></td><td class="text-right"><entity-modal entity="role" item="item" lookup="lookup"></entity-modal></td><td class="text-right"><entity-remove entity="role" item="item"></entity-remove></td></tr></table></div>');
$templateCache.put('entity/run/run.list.html','<div class="table-responsive"><table ng-table="table.params" class="table table-striped table-condensed"><tr ng-repeat="item in $data"><td>{{item | json}}</td></tr></table></div>');
$templateCache.put('entity/task/task.edit.html','<div class="col-sm-4"><div class="row"><div class="col-sm-6"><label for="name">Nome</label> <input type="text" ng-model="item.name" placeholder="ex: Processamento di\xE1rio de assiduidade" class="form-control"></div><div class="col-sm-3"><label>Tipo</label> <select ng-model="item.type" ng-options="type as type for type in taskTypes" class="form-control"></select></div><div class="col-sm-3"><label>Ativo</label><br><input type="checkbox" ng-model="item.isActive" class="w3-check"></div></div><div class="row"><div class="col-sm-12"><div class="panel panel-default"><div class="panel-heading"><label>Crit\xE9rios de agendamento (CRON)</label></div><div class="panel-body"><div class="form-group"><label>M\xEAs</label> <input type="text" ng-model="item.criteria.month" class="form-control"></div><div class="form-group"><label>Dia do M\xEAs</label> <input type="text" ng-model="item.criteria.monthday" class="form-control"></div><div class="form-group"><label>Dia da Semana</label> <input type="text" ng-model="item.criteria.weekday" class="form-control"></div><div class="form-group"><label>Hora</label> <input type="text" ng-model="item.criteria.hour" class="form-control"></div><div class="form-group"><label>Minuto</label> <input type="text" ng-model="item.criteria.minute" class="form-control"></div></div></div></div></div></div><div class="col-sm-8"><label>Instru\xE7\xF5es</label><br><small class="text-muted"><label>S\xEDmbolos</label><ul><li><span><b>\xCDfen (-)</b> delimita intervalos de valores.<br>Exemplo (dia da semana): 1-5, executar\xE1 a tarefa todos os dias \xFAteis.</span></li><li><span><b>Virgula (,)</b> delimita conjuntos.<br>Exemplo (m\xEAs): 0-6,7-11, executar\xE1 a tarefa todos meses excepto Agosto.</span></li><li><span><b>Asterisco (*)</b> indica todos os valores poss\xEDveis.<br>Exemplo (dia do m\xEAs): *, executar\xE1 a tarefa todos os dias do m\xEAs.</span></li><li><span><b>Barra para a frente (/)</b> seguida de um n\xFAmero inteiro indica saltos.<br>Exemplo (dia do m\xEAs): */2, executar\xE1 a tarefa no 1\xBA dia do m\xEAs e dia sim dia n\xE3o da\xED em diante</span></li></ul><label>Valores inteiros</label><ul><li><span><b>M\xEAs</b>: 0(janeiro) a 11(dezembro)</span></li><li><span><b>Dia do m\xEAs</b>: 1 a 31</span></li><li><span><b>Dia da semana</b>: 0(domingo) a 6(s\xE1bado)</span></li><li><span><b>Hora</b>: 0 a 59</span></li><li><span><b>Minuto</b>: 0 a 59</span></li></ul></small></div>');
$templateCache.put('entity/task/task.list.html','<div class="table-responsive"><table ng-table="table.params" class="table table-striped table-condensed"><tr ng-repeat="item in $data"><td data-title="\'Nome\'" sortable="name" filter="{name: \'text\'}"><button ng-click="run(item);" ng-disabled="item.runs.length > 0 ? item.runs[0].isRunning : false" type="button" class="btn btn-default btn-xs"><span class="fa fa-play"></span></button> {{item.name}}</td><td data-title="\'Estado\'" sortable="isActive" filter="{isActive: \'text\'}"><button ng-click="toggleState(item);" type="button" class="btn btn-default btn-xs"><span class="fa fa-refresh"></span></button> {{item.isActive ? "Ativo" : "Inativo"}}</td><td>{{item.criteria.month}}</td><td>{{item.criteria.weekday}}</td><td>{{item.criteria.hour}}</td><td>{{item.criteria.minute}}</td><td class="text-right"><entity-modal entity="task" item="item" lookup="lookup"></entity-modal></td><td class="text-right"><entity-remove entity="task" item="item"></entity-remove></td></tr></table></div>');
$templateCache.put('entity/user/user.edit.html','<div edit-user item="item" lookup="lookup" form="_form"></div>');
$templateCache.put('entity/user/user.list.html','<div class="table-responsive"><table ng-table="table.params" class="table table-bordered table-hover"><tr ng-repeat="item in $data"><td data-title="\'Utilizador\'" sortable="\'username\'">{{item.username}}</td><td data-title="\'Email\'" sortable="\'email\'">{{item.email}}</td><td data-title="\'Perfil\'" sortable="\'role.name\'">{{item.role.name}} - n\xEDvel {{item.role.approvalLevel}} {{item.role.admin ? \'(administrador)\' : \'\'}}</td><td class="text-right"><button type="button" ng-if="item._id === login._id" ng-click="openModal(\'changePassword\', \'sm\')" class="btn btn-xs"><i class="fa fa-lock"></i> Password</button></td><td class="text-right"><entity-modal entity="user" item="item" lookup="lookup"></entity-modal></td><td class="text-right"><entity-remove entity="user" item="item" ng-if="item.role.approvalLevel < login.role.approvalLevel"></entity-remove></td></tr></table></div>');
$templateCache.put('modal/changePassword/changePassword.html','<div class="modal-header"><button ng-click="cancel();" class="close">&times;</button><h3 class="modal-title">Alterar password</h3></div><div class="modal-body row"><div auth-change-password></div></div><div class="modal-footer hidden-xs hidden-sm"><div class="text-right"><span class="text-muted"><kbd>Esc</kbd> para cancelar.</span></div></div>');
$templateCache.put('modal/entityNotification/entityNotification.html','<style type="text/css">strong {\n    font-weight: bold !important;\n  }</style><div class="modal-header"><button ng-click="cancel(item);" class="close">&times;</button><h3 class="modal-title">Configurar subscri\xE7\xE3o a notifica\xE7\xE3o ({{ \'entity.\' + entity + \'.title\' | translate }})</h3></div><div class="modal-body row"><div class="col-sm-12"><p><strong>Quero receber uma notifica\xE7\xE3o:</strong></p><ul><li><input type="checkbox" ng-change="setNotification(notification.entityEvent)" ng-model="notification.entityEvent.eventAdd" class="w3-check">&nbsp; quando qualquer registo de <strong>{{ \'entity.\' + entity + \'.title\' | translate }}</strong>&nbsp;\xE9 criado</li><li><input type="checkbox" ng-change="setNotification(notification.entityEvent)" ng-model="notification.entityEvent.eventEdit" class="w3-check">&nbsp; quando qualquer registo de <strong>{{ \'entity.\' + entity + \'.title\' | translate }}</strong>&nbsp;\xE9 alterado</li><li><input type="checkbox" ng-change="setNotification(notification.entityEvent)" ng-model="notification.entityEvent.eventRemove" class="w3-check">&nbsp; quando qualquer registo de <strong>{{ \'entity.\' + entity + \'.title\' | translate }}</strong>&nbsp;\xE9 apagado</li><li ng-repeat="dateNotification in notification.entityDate"><input type="checkbox" ng-change="setNotification(dateNotification)" ng-model="dateNotification.active" class="w3-check">&nbsp;<input type="number" ng-model="dateNotification.daysNotice" ng-change="setNotification(dateNotification)" step="1" class="form-control" style="width: 80px; display: inline;">&nbsp; dias {{ dateNotification.daysNotice > 0 ? \'depois\' : \'antes\' }} do campo <strong>{{ dateNotification.fieldLabel }}</strong>.</li></ul><hr><p class="text-info"><i class="fa fa-info-circle fa-2x"></i> Aqui pode escolher configurar a sua subscri\xE7\xE3o a notifica\xE7\xF5es de qualquer registo de <strong style="white-space: nowrap;">{{ \'entity.\' + entity + \'.title\' | translate }}</strong>. A grava\xE7\xE3o \xE9 autom\xE1tica.</p></div></div><div class="modal-footer hidden-xs hidden-sm"><div class="text-right"><span class="text-muted"><kbd>Esc</kbd> para fechar.</span></div></div>');
$templateCache.put('modal/predefinedListParameters/predefinedListParameters.html','<div class="modal-header"><button ng-click="cancel();" class="close">&times;</button><h3 class="modal-title">Escolher Parametros</h3></div><div class="modal-body"><!-- PARAMETER SELECTOR --><div class="row"><div class="col-sm-12"><div class="form-group" ng-repeat="parameter in list.parameters"><label ng-bind="parameter.label"></label><div dynamic-field field="parameter.field" model="list.values" key="{{parameter.field.name}}"></div></div></div></div><div class="row"><div class="col-sm-12 pull-right"><button type="button" ng-click="submit()" class="btn btn-primary">Submeter</button></div></div></div><div class="modal-footer hidden-xs hidden-sm"><div class="text-right"><span class="text-muted"><kbd>Esc</kbd> para cancelar.</span></div></div>');
$templateCache.put('modal/recordNotification/recordNotification.html','<style type="text/css">strong {\n    font-weight: bold !important;\n  }</style><div class="modal-header"><button ng-click="cancel(item);" class="close">&times;</button><h3 class="modal-title">Configurar subscri\xE7\xE3o a notifica\xE7\xE3o ({{ \'entity.\' + entity + \'.title\' | translate }})</h3></div><div class="modal-body row"><div class="col-sm-12"><p><strong>Quero receber uma notifica\xE7\xE3o:</strong></p><ul><li><input type="checkbox" ng-change="setNotification(notification.recordEvent)" ng-model="notification.recordEvent.eventEdit" class="w3-check">&nbsp; quando este registo <strong>{{ record[config.fields.label] }}</strong>&nbsp;\xE9 alterado</li><li><input type="checkbox" ng-change="setNotification(notification.recordEvent)" ng-model="notification.recordEvent.eventRemove" class="w3-check">&nbsp; quando este registo <strong>{{ record[config.fields.label] }}</strong>&nbsp;\xE9 apagado</li><li ng-repeat="dateNotification in notification.recordDate"><input type="checkbox" ng-change="setNotification(dateNotification)" ng-model="dateNotification.active" class="w3-check">&nbsp;<input type="number" ng-model="dateNotification.daysNotice" ng-change="setNotification(dateNotification)" step="1" class="form-control" style="width: 80px; display: inline;">&nbsp; dias {{ dateNotification.daysNotice > 0 ? \'depois\' : \'antes\' }} do campo <strong>{{ dateNotification.fieldLabel }}</strong>&nbsp;(neste registo \xE9 <strong>{{ record[dateNotification.field] | date: \'yyyy-MM-dd\' }}</strong>).</li></ul><hr><p class="text-info"><i class="fa fa-info-circle fa-2x"></i> Aqui pode escolher configurar a sua subscri\xE7\xE3o a notifica\xE7\xF5es deste registo <strong style="white-space: nowrap;">{{ record[config.fields.label] }}</strong>&nbsp;de <strong style="white-space: nowrap;">{{ \'entity.\' + entity + \'.title\' | translate }}</strong>. A grava\xE7\xE3o \xE9 autom\xE1tica.</p></div></div><div class="modal-footer hidden-xs hidden-sm"><div class="text-right"><span class="text-muted"><kbd>Esc</kbd> para cancelar.</span></div></div>');
$templateCache.put('modal/reset/reset.html','<div class="modal-header"><button ng-click="cancel();" class="close">&times;</button><h3 class="modal-title">Recupera\xE7\xE3o de conta</h3></div><div class="modal-body row"><div class="col-sm-12"><div class="col-sm-12"><div auth-reset item="item"></div></div></div></div><div class="modal-footer hidden-xs hidden-sm"><div class="text-right"><span class="text-muted"><kbd>Esc</kbd> para cancelar.</span></div></div>');
$templateCache.put('modal/resetFactoryDefaults/resetFactoryDefaults.html','<div class="modal-header"><button ng-click="cancel();" class="close">&times;</button><h3 class="modal-title">Reposi\xE7\xE3o de Configura\xE7\xF5es</h3></div><div class="modal-body row"><div class="col-sm-12"><p class="strong">{{text}}</p><uib-progressbar class="progress-striped active" max="100" value="progress" type="danger"><i>{{progress | number:0}}%</i></uib-progressbar></div></div><div class="modal-footer hidden-xs hidden-sm"><div class="text-right"><span class="text-muted"><kbd>Esc</kbd> para cancelar.</span></div></div>');
$templateCache.put('modal/stackTrace/stackTrace.html','<div class="row"><div class="col-sm-12"><pre style="margin: 6px;">{{item.description}}</pre></div></div>');
$templateCache.put('modal/unlicensed/unlicensed.html','<div class="modal-header"><button ng-click="cancel();" class="close">&times;</button><h3 class="modal-title" style="color:#777;">Este m\xF3dulo n\xE3o est\xE1 inclu\xEDdo no seu plano</h3></div><div class="modal-body row"><div class="col-sm-12"><h3>Aten\xE7\xE3o! <small>o seu plano de licenciamento n\xE3o permite aceder a este m\xF3dulo.</small></h3></div></div><div class="modal-footer hidden-xs hidden-sm"><div class="text-right"><span class="text-muted"><kbd>Esc</kbd> para cancelar.</span></div></div>');
$templateCache.put('modal/versionHistory/versionHistory.html','<div class="modal-header"><button ng-click="cancel();" class="close">&times;</button><h3 class="modal-title">Altera\xE7\xF5es a {{data.item[data.labelField]}}</h3></div><div class="modal-body"><table class="table table-striped table-condensed"><thead><tr><th>Vers\xE3o</th><th>Criada a</th><th>Alterada a</th><th>Editado por</th><th>Supervisor</th></tr></thead><tbody><tr ng-repeat="version in data.versions | orderBy: \'updated_at\'"><td><span ng-bind="$index"></span></td><td>{{version.created_at|date:\'yyyy-MM-dd HH:mm:ss\'}}</td><td>{{version.updated_at|date:\'yyyy-MM-dd HH:mm:ss\'}}</td><td><span ng-bind="version.user"></span></td><td><span ng-bind="version.owner"></span></td></tr></tbody></table></div>');
$templateCache.put('modal/viewMsg/viewMsg.html','<div class="modal-header"><button ng-click="cancel();" class="close">&times;</button><h3 class="modal-title">Email autom\xE1tico enviado \xE0s {{item.created_at | date: \'yyyy-MM-dd HH:mm\'}}</h3></div><div class="modal-body row"><div class="row"><div class="col-sm-12"><h2>{{item.subject}}</h2><div style="border: solid 1px black;" ng-bind-html="item.html"></div></div></div><div class="row"><div class="col-sm-12"><p>Por <strong>{{item.from}}</strong> \xE0s <strong></strong></p></div></div><div class="row"><div class="col-sm-12"><div class="form-group"><label>Para</label> <select multi="true" selector model="item.to" options="item.to" disable="true"></select></div></div></div><div class="row"><div class="col-sm-12"><div class="form-group"><label>CC</label> <select multi="true" selector model="item.cc" options="item.cc" disable="true"></select></div></div></div></div>');
$templateCache.put('directives/_to_remove/console/console.html','<div class="col-sm-12"><div ng-if="console" class="alert alert-warning" role="alert"><p><span class="fa fa-exclamation-triangle"></span> <strong>Aten\xE7\xE3o!</strong> {{console}}</p></div></div>');
$templateCache.put('directives/auth/activation/activation.html','<div class="row"><div ng-show="!user"><h4><span class="fa fa-exclamation"></span> {{\'api.directives.activation.activationFail\' | translate}}</h4></div><div ng-show="!!user"><h1><strong>{{user.username}},</strong> {{\'api.directives.activation.title\' | translate}}</h1><p class="lead">{{\'api.directives.activation.subtitle\' | translate}}</p><div class="form-group"><label>{{\'api.directives.activation.password\' | translate}}</label> <input type="password" ng-model="item.password" placeholder="{{\'api.directives.activation.passwordPlaceholder\' | translate}}" class="form-control"></div><div class="form-group"><label>{{\'api.directives.activation.repeatPassword\' | translate}}</label> <input type="password" ng-model="item.repeat" code="13" dl-key-code="changePassword(item)" placeholder="{{\'api.directives.activation.repeatPasswordPlaceholder\' | translate }}" class="form-control"></div><div password-meter password="item.password"></div><button type="button" ng-click="changePassword(item)" class="btn btn-primary btn-block"><i class="fa fa-key" aria-hidden="true"></i> {{\'api.directives.activation.confirm\' | translate}}</button></div></div>');
$templateCache.put('directives/auth/changePassword/changePassword.html','<div class="col-sm-12"><div class="row"><div class="col-sm-12"><div class="form-group"><label>{{\'api.directives.activation.password\' | translate}}</label> <input type="password" ng-model="item.password" placeholder="{{\'api.directives.activation.passwordPlaceholder\' | translate}}" class="form-control"></div></div></div><div class="row"><div class="col-sm-12"><div class="form-group"><label>{{\'api.directives.activation.repeatPassword\' | translate}}</label> <input type="password" ng-model="item.repeat" code="13" dl-key-code="changePassword(item)" placeholder="{{\'api.directives.activation.repeatPasswordPlaceholder\' | translate }}" class="form-control"></div></div></div><div class="row"><div class="col-sm-12"><div password-meter password="item.password"></div></div></div><div class="row"><div class="col-sm-12"><button type="button" ng-click="changePassword(item)" class="btn btn-sm btn-primary"><i class="fa fa-key" aria-hidden="true"></i> {{\'api.directives.activation.confirm\' | translate}}</button></div></div></div>');
$templateCache.put('directives/auth/login/login.html','<ng-transclude><div class="row"><div class="form-group"><label class="sr-only">{{\'api.directives.login.username\' | translate}}</label> <input type="text" name="username" code="13" dl-key-code="login()" placeholder="{{\'api.directives.login.usernamePlaceholder\' | translate }}" ng-model="item.username" class="form-control" autocapitalize="none"></div><div class="form-group"><label class="sr-only">{{\'api.directives.login.password\' | translate}}</label> <input type="password" name="password" placeholder="{{\'api.directives.login.passwordPlaceholder\' | translate }}" code="13" dl-key-code="login()" ng-model="item.password" class="form-control"></div><button type="button" class="btn btn-primary btn-block" ng-disabled="validateLogin()" ng-click="login()">{{\'api.directives.login.btnLogin\' | translate}} <i class="fa fa-sign-in"></i></button></div></ng-transclude>');
$templateCache.put('directives/auth/passwordMeter/passwordMeter.html','<div class="pass-meter {{masterClass}}"><div class="{{colClass}} pass-meter-col {{first}}"><div class="indicator"></div></div><div class="{{colClass}} pass-meter-col {{second}}"><div class="indicator"></div></div><div class="{{colClass}} pass-meter-col {{third}}"><div class="indicator"></div></div><div class="{{colClass}} pass-meter-col {{fourth}}"><div class="indicator"></div></div><div class="pass-meter-message">{{message}}</div></div>');
$templateCache.put('directives/auth/reset/reset.html','<ng-transclude><div class="col-sm-12"><div class="row"><div class="col-sm-12"><div class="form-group"><label>Nome do Utilizador</label> <input type="text" name="username" ng-model="item.username" placeholder="Nome de Utilizador" class="form-control"></div></div></div><div class="row"><div class="col-sm-12"><div class="form-group"><label>Email</label> <input type="email" name="email" ng-model="item.email" code="13" dl-key-code="reset(item)" placeholder="Email" class="form-control"></div></div></div><div class="row"><div class="col-sm-12 text-right"><button ng-click="reset(item)" ng-disabled="validateReset(item)" class="btn"><i class="fa fa-unlock"></i> Recuperar</button></div></div></div></ng-transclude>');
$templateCache.put('directives/auth/signup/signup.html','<ng-transclude><div class="row"><div class="form-group"><label>Nome do Utilizador</label> <input ng-model="item.username" name="username" type="text" placeholder="Nome do utilizador" class="form-control" autocapitalize="none"></div><div class="form-group"><label>Email</label> <input ng-model="item.email" name="email" type="email" code="13" dl-key-code="signup(item)" placeholder="Email" class="form-control"></div><button type="button" ng-click="signup(item)" ng-disabled="validateSignup(item)" class="btn btn-primary btn-block">Criar <i class="fa fa-pencil-square-o"></i></button></div></ng-transclude>');
$templateCache.put('directives/document/image/upload.html','<div class="col-sm-12"><div class="row"><div class="col-sm-12"><!--WITHOUT IMAGE--><div ng-if="!item[key]" class="form-group"><label ng-bind="label">Imagem</label><div class="input-group"><input type="file" accept="image/*" file-model="tmp.newFile[key]" class="form-control" ng-disabled="!isEditable"><div class="input-group-btn"><button type="button" ng-click="upload(key, tmp)" ng-disabled="!tmp.newFile[key] || !isEditable" class="btn"><i class="fa fa-upload"></i></button></div></div></div><!--WITH IMAGE--><div ng-if="item[key]" class="form-group"><label ng-bind="label">Imagem</label><div class="input-group"><input type="text" ng-model="item[key]" disabled="true" class="form-control"><div class="input-group-btn"><button type="button" ng-click="item[key] = \'\'" ng-disabled="!isEditable" class="btn btn-danger"><i class="fa fa-trash"></i></button></div></div></div></div></div><div ng-if="item[key]" class="row"><div class="col-sm-12"><img ng-src="{{item[key]}}" class="img-thumbnail img-responsive"></div></div></div>');
$templateCache.put('directives/report/queryBuilder/Date.html','<select ng-model="model[key]" class="form-control"><option value="equals">&#61;</option><option value="greaterThanOrEquals">&ge;</option><option value="lesserThanOrEquals">&le;</option><option value="notExists">inexistente</option></select>');
$templateCache.put('directives/report/queryBuilder/Number.html','<select ng-model="model[key]" class="form-control"><option value="equals">&#61;</option><option value="greaterThan">&gt;</option><option value="greaterThanOrEquals">&ge;</option><option value="lesserThan">&lt;</option><option value="lesserThanOrEquals">&le;</option><option value="notEquals">&#8800;</option><option value="notExists">inexistente</option></select>');
$templateCache.put('directives/report/queryBuilder/String.html','<select ng-model="model[key]" class="form-control"><option value="equals">igual a</option><option value="endsWith">acaba em</option><option value="startsWith">come\xE7a por</option><option value="contains">contem</option><option value="notEquals">diferente de</option><option value="notExists">inexistente</option></select>');}]);
angular.module('zapi').run(['gettextCatalog', function (gettextCatalog) {
/* jshint -W100 */
    gettextCatalog.setStrings('pt', {"api.containers.attachments.new.cid":"CID","api.containers.attachments.new.file":"Ficheiro","api.containers.attachments.new.name":"Nome","api.containers.attachments.view.since":"Registado em","api.containers.cc.new.email":"CC","api.containers.from.new.email":"De","api.containers.to.new.email":"Para","api.directives.activation.activationFail":"Não foi possível activar a sua conta. Código errado ou já utilizado.","api.directives.activation.confirm":"Alterar password","api.directives.activation.password":"Password","api.directives.activation.passwordPlaceholder":"Escreva a password","api.directives.activation.repeatPassword":"Repita a password","api.directives.activation.repeatPasswordPlaceholder":"Rescreva a password","api.directives.activation.subtitle":"Escolha uma password segura","api.directives.activation.title":"Obrigado por ativar a sua conta por email!","api.directives.login.btnLogin":"Entrar","api.directives.login.password":"Password","api.directives.login.passwordPlaceholder":"Escreva a password","api.directives.login.username":"Username","api.directives.login.usernamePlaceholder":"Escreva o username","api.entity.checkRemove":"A verificar elegibilidade de remoção...","api.entity.deleteRecordSuccess":"Registo removido com sucesso!","api.entity.editRecordSuccess":"Dados gravados com sucesso!","api.entity.errorData":"Não foi possível processar o seu pedido, por favor tente novamente mais tarde","api.entity.getData":"A obter dados, por favor aguarde...","api.entity.newRecordSuccess":"Dados gravados com sucesso!","api.entity.sendData":"A enviar dados, por favor aguarde...","api.menu.system.activityLog":"Logs de Atividade","api.menu.system.countries":"Países","api.menu.system.holidays":"Feriados","api.menu.system.maintenance":"Logs de Atualizações","api.menu.system.manageUsers":"Gerir Acessos","api.menu.system.name":"Sistema","api.menu.system.newUser":"Novo Acesso","api.menu.system.profiles":"Perfis de Utilização","api.menu.system.sendEmails":"Logs de Email","api.menu.system.systemLog":"Logs Técnicos","api.menu.system.tasks":"Tarefas","api.menu.system.templatesEmails":"Templates de Email","api.passwordMeter.good":"Forte","api.passwordMeter.poor":"Fraca","api.passwordMeter.strong":"Muito forte","api.passwordMeter.weak":"Muito fraca","api.services.auth.activateAccountLoad":"A verificar código de ativação...","api.services.auth.changepasswordErrorTitle":"Não foi possível alterar password","api.services.auth.changepasswordLoad":"A alterar password, por favor aguarde...","api.services.auth.changepasswordSuccessBtnOk":"Concluir","api.services.auth.changepasswordSuccessContent":"Alteração de password efetuada com sucesso!","api.services.auth.changepasswordSuccessTitle":"Nova password","api.services.auth.changepasswordWrongPasswordContent":"Não foi possível alterar password","api.services.auth.changepasswordWrongPasswordTitle":"Nova password","api.services.auth.loginErrorContent":"Utilizador e password inválidos","api.services.auth.loginErrorTitle":"Acesso não autorizado","api.services.auth.loginLoad":"A autenticar credenciais, por favor aguarde...","api.services.auth.resetPasswordErrorTitle":"Não foi possível recuperar password","api.services.auth.resetPasswordLoad":"A recuperar password, por favor aguarde...","api.services.auth.resetPasswordSuccessContent":"A sua password antiga foi invalidada. Consulte o seu email para designar uma password nova.","api.services.auth.resetPasswordSuccessTitle":"Email de recuperação enviado","global.add":"Adicionar","global.clone":"Copiar","global.delete":"Apagar","global.edit":"Alterar","global.save":"Guardar","global.view":"Ver"});
/* jshint +W100 */
}]);
app.constant('apiEntityMap', {
  activity: {
    key: "activity",
    title: "api.pages.activity.title",
    list: { admin: false }
  },
  alert: {
    key: "alert",
    title: "api.pages.alert.title",
    list: { admin: true },
    edit: { admin: true },
    modal: true
  },
  document: { //todo
    key: "document",
    title: "api.pages.document.title",
    list: { admin: true }
  },
  error: {
    key: "error",
    title: "api.pages.error.title",
    list: { admin: true }
  },
  holiday: {
    key: "holiday",
    title: "api.pages.holiday.title",
    list: { admin: true },
    edit: { admin: true },
    modal: true,
    beforeSave: function (item, callback) {
      if (!item.name) return callback("Introduza um nome do feriado");
      if (!item.date && !item.formula) return callback("Impossivel calcular próxima ocorrência para este feriado");

      if (item.date) {
        var pattern = /^(?:(?:[12][0-9]|0[1-9])\/(02)|(?:30|[12][0-9]|0[1-9])\/(?:(?:0[469]|11))|(?:3[01]|[12][0-9]|0[1-9])\/(?:(?:0[13578]|1[02])))$/;
        if (!pattern.test(item.date)) return callback("A data deve ser no formato dd/mm");
      } else if (item.formula) {
        try {
          var currentYear = new Date().getFullYear();
          eval('my_function = ' + item.formula);
          var d = my_function(currentYear);
          if (Object.prototype.toString.call(d) !== "[object Date]") return callback("Data inválida");
          //it is a date
          if (isNaN(d.getTime())) return callback("Data inválida");
        } catch (e) {
          return callback("A formula que introduziu contém um erro: " + e);
        }
      }
      callback();
    }
  },
  license: {
    key: "license",
    title: "api.pages.license.title",
    lookup: ['module'],
    list: { admin: false },
    edit: { admin: true },
    modal: true
  },
  maintenance: {
    key: "maintenance",
    title: "api.pages.maintenance.title",
    list: { admin: true },
    edit: { admin: true },
    modal: true
  },
  message: {
    key: "message",
    title: "api.pages.message.title",
    list: { admin: false }
  },
  module: {
    key: "module",
    title: "api.pages.module.title",
    list: { admin: false },
    edit: { admin: true },
    modal: true,
    blank: function () {
      return {
        price: []
      };
    }
  },
  newsletter: { //todo
    key: "newsletter",
    title: "api.pages.newsletter.title",
    list: { admin: true }
  },
  report: {
    key: "report"
  },
  role: {
    key: "role",
    title: "api.pages.role.title",
    list: { admin: true },
    edit: { admin: true },
    modal: true
  },
  run: { //todo
    key: "run",
    title: "api.pages.run.title",
    list: { admin: true }
  },
  support: { //todo
    key: "support",
    title: "api.pages.support.title",
    list: { admin: true },
    modal: true
  },
  task: {
    key: "task",
    title: "api.pages.task.title",
    list: { admin: true },
    edit: { admin: true },
    modal: true,
    beforeSave: function (item, callback) {
      if (!item.name) return callback("Indique um nome para a tarefa");
      if (item.name.trim() === "") return callback("Indique um nome para a tarefa");
      if (!item.type) return callback("Escolha um tipo de tarefa");
      if (!item.criteria) return callback("Complete o critério de periodicidade");
      if (!item.criteria.month) return callback("Complete o critério de periodicidade");
      if (!item.criteria.monthday) return callback("Complete o critério de periodicidade");
      if (!item.criteria.weekday) return callback("Complete o critério de periodicidade");
      if (!item.criteria.hour) return callback("Complete o critério de periodicidade");
      if (!item.criteria.minute) return callback("Complete o critério de periodicidade");
      callback();
    }
  },
  user: {
    key: "user",
    title: "api.pages.user.title",
    lookup: ['role'],
    list: { admin: false },
    edit: { clearance: 1 },
    modal: true,
    beforeSave: function (item, callback) {
      if (!item.username) return callback("Introduza um username");
      if (item.username.trim() === "") return callback("Introduza um username");
      if (!item.email) return callback("Introduza um email");
      if (item.email.trim() === "") return callback("Introduza um email");
      callback();
    }
  }
});
app.constant('apiError', {
  "timeout": "O servidor excedeu o tempo limite de resposta, por favor tente novamente"
});
app.constant('chartTypes', [
  ['bar', 'doughnut', 'pie', 'horizontalBar'],
  ['line', 'radar'],
  ['bubble', 'polar-area']
]);

app.constant('graphOptions', {
  responsive: true,
  responsiveAnimationDuration: 1500,
  tooltip: { enabled: true },
  elements: {
    line: { tension: 0.4, stepped: false }
  }
});
app.constant("lookup", {
  nationality: [
    "Português",
    "Afegão",
    "Alemão",
    "Americano",
    "Angolano",
    "Antiguano",
    "Árabe, emiratense",
    "Argélia",
    "Argentino",
    "Armeno",
    "Australiano",
    "Austríaco",
    "Bahamense",
    "Bangladesh",
    "Barbadiano",
    "Bechuano",
    "Belga",
    "Belizenho",
    "Boliviano",
    "Brasileiro",
    "Britânico",
    "Camaronense",
    "Canadense",
    "Chileno",
    "Chinês",
    "Cingalês",
    "Colombiano",
    "Comorense",
    "Costarriquenho",
    "Croata",
    "Cubano",
    "Dinamarquês",
    "Dominicana",
    "Dominicano",
    "Egípcio",
    "Equatoriano",
    "Escocês",
    "Eslovaco",
    "Esloveno",
    "Espanhol",
    "Francês",
    "Galês",
    "Ganés",
    "Granadino",
    "Grego",
    "Guatemalteco",
    "Guianense",
    "Guianês",
    "Haitiano",
    "Holandês",
    "Hondurenho",
    "Húngaro",
    "Iemenita",
    "Indiano",
    "Indonésio",
    "Inglês",
    "Iraniano",
    "Iraquiano",
    "Irlandês",
    "Israelita",
    "Italiano",
    "Jamaicano",
    "Japonês",
    "Líbio",
    "Malaio",
    "Marfinense",
    "Marroquino",
    "Mexicano",
    "Moçambicano",
    "Neozelandês",
    "Nepalês",
    "Nicaraguense",
    "Nigeriano",
    "Norte-coreano",
    "Noruego",
    "Omanense",
    "Palestino",
    "Panamenho",
    "Paquistanês",
    "Paraguaio",
    "Peruano",
    "Polonês",
    "Portorriquenho",
    "Qatarense",
    "Queniano",
    "Romeno",
    "Ruandês",
    "Russo",
    "Salvadorenho",
    "Santa-lucense",
    "São-cristovense",
    "São-vicentino",
    "Saudita",
    "Sérvio",
    "Sírio",
    "Somali",
    "Sueco",
    "Suíço",
    "Sul-africano",
    "Sul-coreano",
    "Surinamês",
    "Tailandês",
    "Timorense, maubere",
    "Trindadense",
    "Turco",
    "Ucraniano",
    "Ugandense",
    "Uruguaio",
    "Venezuelano",
    "Vietnamita",
    "Zimbabuense"
  ],
  country: [
    "Portugal",
    "Antígua e Barbuda",
    "Afeganistão",
    "África do Sul",
    "Alemanha",
    "Angola",
    "Arábia Saudita",
    "Argélia",
    "Argentina",
    "Armênia",
    "Armeno",
    "Austrália",
    "Áustria",
    "Bahamas",
    "Barbados",
    "Bélgica",
    "Belize",
    "Bolívia",
    "Botsuana",
    "Brasil",
    "Camarões",
    "Canadá",
    "Chile",
    "China",
    "Colômbia",
    "Comores",
    "Coréia do Norte",
    "Coréia do Sul",
    "Costa do Marfim",
    "Costa Rica",
    "Croácia",
    "Cuba",
    "Dinamarca",
    "Dominica",
    "Egito",
    "El Salvador",
    "Emirados Árabes Unidos",
    "Equador",
    "Escócia",
    "Eslováquia",
    "Eslovênia",
    "Espanha",
    "Estados Unidos",
    "França",
    "Gana",
    "Granada",
    "Grécia",
    "Guatemala",
    "Guiana",
    "Guiana Francesa",
    "Haiti",
    "Honduras",
    "Hungria",
    "Iêmen",
    "Índia",
    "Indonésia",
    "Inglaterra",
    "Irã",
    "Iraque",
    "Irlanda",
    "Israel",
    "Itália",
    "Jamaica",
    "Japão",
    "Líbia",
    "Malásia",
    "Marrocos",
    "México",
    "Moçambique",
    "Nepal",
    "Nicarágua",
    "Nigéria",
    "Noruega",
    "Nova Zelândia",
    "Omã",
    "País de Gales",
    "Países Baixos",
    "Palestina",
    "Panamá",
    "Paquistão",
    "Paraguai",
    "Peru",
    "Polônia",
    "Porto Rico",
    "Qatar",
    "Quênia",
    "Reino Unido",
    "República Dominicana",
    "Romênia",
    "Ruanda",
    "Rússia",
    "Santa Lúcia",
    "São Cristóvão e Nevis",
    "São Vicente e Granadinas",
    "Sérvio",
    "Síria",
    "Somália",
    "Sri Lanka",
    "Suécia",
    "Suíça",
    "Suriname",
    "Tailândia",
    "Timor-Leste",
    "Trinidad e Tobago",
    "Turquia",
    "Ucrânia",
    "Uganda",
    "Uruguai",
    "Venezuela",
    "Vietnã",
    "Zimbabue"
  ]
});
app.controller('entityCtrl', ["$scope", "$stateParams", "$page", "$interpolate", "$auth", "zapi", function ($scope, $stateParams, $page, $interpolate, $auth, zapi) {
  $scope.entity = zapi.entityMap[$stateParams.entity];
  if (!$scope.entity) return $page.setTitle("404");
  $page.setTitle($interpolate("{{ '" + $scope.entity.title + "' | translate }}")($scope));

  $scope.isAdmin = $auth.isAdmin;
  $scope.hasClearance = $auth.hasClearance;
}]);
app.controller('entityModalCtrl', ["$uibModalInstance", "$scope", "$auth", "data", function ($uibModalInstance, $scope, $auth, data) {
  $scope.entity = data.entity;
  $scope.item = data.item;
  //$scope.lookup = data.lookup;
  $scope.view = data.view || false;

  $scope.isAdmin = $auth.isAdmin;
  $scope.hasClearance = $auth.hasClearance;

  $scope.ok = $uibModalInstance.close;
  $scope.cancel = function () {
    if (!$scope.entity.preventDirtyRedirect) return $uibModalInstance.dismiss();
    if (!$scope._form.$dirty) return $uibModalInstance.dismiss();

    swal({
      title: "Existem alterações não guardadas, pretende fechar a janela na mesma?",
      showConfirmButton: true,
      confirmButtonText: "Sim",
      showCancelButton: true,
      cancelButtonText: "Ainda não!",
      type: "warning"
    }).then(function (result) {
      if (result && result.dismiss) return;
      $uibModalInstance.dismiss();
    }).catch(function (err) {
      console.error(err);
    });
  };
}]);
app.filter("dateFilter", function () {
  return function (items, key, from, to) {
    if (typeof items === 'undefined') return;
    if (!(items instanceof Array)) return;

    from = typeof from === 'undefined' ? new Date('1999-01-01') : new Date(from);
    to = typeof to === 'undefined' ? new Date() : new Date(to);

    var result = [];
    items.forEach(function (item) {
      var value = new Date(item[key]);
      if (value >= from && value <= to) result.push(item);
    });
    return result;
  };
});
app.filter('makePositive', function () {
    return function (num) {
        if (typeof num === 'undefined') return;
        return Math.abs(num);
    };
});
app.filter('orderObjectBy', function () {
  return function (items, field, reverse) {
    var filtered = [];
    angular.forEach(items, function (item) {
      filtered.push(item);
    });
    filtered.sort(function (a, b) {
      return (a[field] > b[field] ? 1 : -1);
    });
    if (reverse) filtered.reverse();
    return filtered;
  };
});

app.provider('zapi', ["apiEntityMap", function (apiEntityMap) {
  var map = {};
  var idle = false;
  var serverUrl = '';
  var websocketUrl;

  return {
    getRoutes: function (param) {
      if (typeof map[param.entity] === 'undefined') return 'entity/entity.notfound.html';
      if (typeof map[param.entity][param.action] === 'undefined') return 'entity/entity.notfound.html';

      switch (param.action) {
        case 'edit':
          return 'entity/entity.edit.html';

        case 'view':
          if (typeof param.id === 'undefined') return 'entity/entity.notfound.html';

          return 'entity/entity.view.html';

        case 'list':
          if (typeof param.id !== 'undefined') return 'entity/entity.notfound.html';

          return 'entity/entity.list.html';

        default:
          return 'entity/entity.notfound.html';
      }
    },

    setMap: function (entityMap) {
      map = apiEntityMap;
      for (var key in entityMap) {
        map[key] = entityMap[key];
      }
    },

    setServerUrl: function (url) {
      serverUrl = url || '';
    },

    setWebsocket: function (url) {
      websocketUrl = url || undefined;
    },

    setIdle: function (state) {
      idle = state;
    },

    $get: function () {
      return {
        entityMap: map,
        idle: idle,
        serverUrl: serverUrl,
        websocketUrl: websocketUrl,
      };
    }
  };
}]);
app.service('$address', ["$http", "blockUI", "zapi", "apiError", function ($http, blockUI, zapi, apiError) {
  this.getAddressPT = function (zipcode, callback) {
    if (this.validateZipcode(zipcode)) return callback("Código postal inválido");

    blockUI.start('A procurar arruamento...');
    $http.get(zapi.serverUrl + "/api/address/pt/" + zipcode).then(function (response) {
      callback(null, response.data);
    }).catch(function (response) {
      callback(response.data || apiError.timeout);
    }).finally(function () {
      blockUI.stop();
    });
  };

  this.validateZipcode = function (zipcode) {
    if (!zipcode) return true;
    if (typeof zipcode !== 'string') zipcode = zipcode + '';

    var cps = zipcode.split('-');
    if (cps.length < 1 || cps.length > 2) return true;
    if (isNaN(cps[0])) return true;
    return cps.length > 1 && isNaN(cps[1]);
  };

  this.getCoordinates = function (zipcode, callback) {
    try {
      var geocoder = new google.maps.Geocoder();
      geocoder.geocode({ 'address': zipcode }, function (results, status) {
        if (status !== google.maps.GeocoderStatus.OK) {
          console.error(status);
          return callback(status);
        }

        callback(null, {
          lat: results[0].geometry.location.lat(),
          lng: results[0].geometry.location.lng()
        });
      });
    } catch (error) {
      console.error(error);
      callback(error);
    }
  };
}]);
app.factory('$auth', ["$http", "$crypto", "$location", "anonymousPages", "$uibModalStack", "customPages", "routeDepth", "$rootScope", "Idle", "zapi", "$license", "blockUI", "apiError", function ($http, $crypto, $location, anonymousPages, $uibModalStack, customPages, routeDepth, $rootScope, Idle, zapi, $license, blockUI, apiError) {
  var separator = '#/';

  function getUrlPaths(url) {
    var start = url.indexOf(separator) + separator.length;
    var end = getUrlEnd(url, start);
    var shortURL = start >= separator.length ? (end >= 0 ? url.substring(start, end) : url.substring(start)) : "";
    var urlPaths = shortURL.split('/');
    if (!(urlPaths instanceof Array)) urlPaths = [];
    return urlPaths;
  }

  function getUrlEnd(url, start) {
    var querystring = url.indexOf('?');
    if (querystring >= 0) {
      //using querystring
      return querystring;
    }
    else {
      //not using querystring
      var anchor = url.lastIndexOf('#');
      if (anchor === start - separator.length) {
        //not using anchor
        return -1;
      }
      else {
        //using anchor
        return anchor;
      }
    }
  }

  var service = {
    currentUser: null,

    login: function (username, password) {
      return $http.post(zapi.serverUrl + '/api/session/login/', {
        username: username,
        password: $crypto.isMd5(password) ? password : $crypto.md5(password)
      }).then(function (response) {
        if (zapi.idle) Idle.watch();
        service.currentUser = response.data.user;
      });
    },

    logout: function (callback) {
      return $http.get(zapi.serverUrl + '/api/session/logout').then(function (response) {
        //logout user
        service.currentUser = null;
        $rootScope.login = {};
        //unwatch idle
        if (zapi.idle) Idle.unwatch();
        //close all swal
        swal.close();
        //close all modals
        $uibModalStack.dismissAll();
        //close all blockUI
        blockUI.reset();
        //redirect to root path
        $location.path('/');

        if (typeof callback === 'function') callback();
      });
    },

    requestCurrentUser: function (callback) {
      if (zapi.idle) Idle.watch();
      if (service.isAuthenticated()) return callback(null, service.currentUser);

      $http.get(zapi.serverUrl + '/api/session/currentuser').then(function (response) {
        service.currentUser = response.data.user;
        callback(null, service.currentUser);
      }).catch(function (response) {
        service.currentUser = null;
        $rootScope.login = {};
        callback(response.data || apiError.timeout);
      });
    },

    isAuthenticated: function () {
      return !!service.currentUser;
    },

    activateAccount: function (codes) {
      return $http.post(zapi.serverUrl + '/api/user/activate/', { email: codes[0], code: codes[1] });
    },

    resetPassword: function (email, username) {
      return $http.post(zapi.serverUrl + '/api/user/resetpassword/', { email: email, username: username });
    },

    changePassword: function (user, newPassword1, newPassword2) {
      user.newPassword = $crypto.md5(newPassword1);
      return $http.post(zapi.serverUrl + '/api/user/changepassword/', user);
    },

    isPageAnonymous: function (urlPaths) {
      if (!urlPaths) urlPaths = getUrlPaths($location.path());

      return anonymousPages.some(function (anonymousPage) {
        return anonymousPage === urlPaths[0];
      });
    },

    isPageCustom: function (urlPaths) {
      if (!urlPaths) urlPaths = getUrlPaths($location.path());

      return customPages.find(function (customPage) {
        if (customPage.urlParts.length < urlPaths.length) return false;
        return !customPage.urlParts.some(function (part, i) {
          //ignore url wildcards by configuring the custom page with %
          if (part === '%') return false;
          return part !== urlPaths[i];
        });
      });
    },

    getNextRoute: function (callback) {
      return function (event, next, current) {
        var urlPaths = getUrlPaths(next);
        if (urlPaths.length === 0) return callback(undefined, undefined, event, next, current);

        if (service.isPageAnonymous(urlPaths)) return callback(undefined, undefined, event, next, current);

        //service.currentUser = null;
        service.requestCurrentUser(function (err, user) {
          $rootScope.login = (err ? {} : user) || {};

          if (!$rootScope.login._id) return callback("Sem sessão iniciada. Isto pode ocorrer por motivos de inactividade, aceder à mesma conta noutro computador ou actualização recente ao servidor.", user, event, next, current);

          if (urlPaths[0] === 'profile') return callback(undefined, user, event, next, current);

          //authenticate and authorize custom pages
          var customPage = service.isPageCustom(urlPaths);
          if (customPage) {
            //check license
            if (typeof customPage.license !== 'undefined') {
              if (!$license.isLicensed(customPage.license, service.currentUser)) $license.notify(customPage.license);
            }

            return callback(undefined, user, event, next, current);
          }

          //authenticate and authorize entity pages
          var entity = zapi.entityMap[urlPaths[routeDepth]];
          if (!entity) return callback("A página que está a tentar consultar não existe", user, event, next, current);
          if (urlPaths.length <= routeDepth + 1) return callback("A página que está a tentar consultar não existe", user, event, next, current);
          var action = entity[urlPaths[routeDepth + 1]];
          if (!action) return callback("A página que está a tentar consultar não existe", user, event, next, current);
          if (user.role.admin) return callback(undefined, user, event, next, current);
          if (action.admin) return callback("A página que está a tentar consultar não existe", user, event, next, current);

          //check license
          if (typeof entity.license !== 'undefined') {
            if (!$license.isLicensed(entity.license, service.currentUser)) $license.notify(entity.license);
          }
          return callback(undefined, user, event, next, current);
        });
      };
    },

    isAnonymous: function () {
      return !service.isLoggedIn();
    },

    isLoggedIn: function () {
      if (!service.currentUser) return false;
      return !!service.currentUser._id;
    },

    isAdmin: function () {
      if (service.isLoggedIn()) return service.currentUser.role.admin;
      return false;
    },

    hasClearance: function (level) {
      level = level || 0;
      if (!service.currentUser) return false;
      if (!service.currentUser.role) return false;
      return service.currentUser.role.approvalLevel >= level;
    }
  };

  return service;
}]);
app.service('$crypto', function() {
    function md5cycle(x, k) {
        var a = x[0],
            b = x[1],
            c = x[2],
            d = x[3];

        a = ff(a, b, c, d, k[0], 7, -680876936);
        d = ff(d, a, b, c, k[1], 12, -389564586);
        c = ff(c, d, a, b, k[2], 17, 606105819);
        b = ff(b, c, d, a, k[3], 22, -1044525330);
        a = ff(a, b, c, d, k[4], 7, -176418897);
        d = ff(d, a, b, c, k[5], 12, 1200080426);
        c = ff(c, d, a, b, k[6], 17, -1473231341);
        b = ff(b, c, d, a, k[7], 22, -45705983);
        a = ff(a, b, c, d, k[8], 7, 1770035416);
        d = ff(d, a, b, c, k[9], 12, -1958414417);
        c = ff(c, d, a, b, k[10], 17, -42063);
        b = ff(b, c, d, a, k[11], 22, -1990404162);
        a = ff(a, b, c, d, k[12], 7, 1804603682);
        d = ff(d, a, b, c, k[13], 12, -40341101);
        c = ff(c, d, a, b, k[14], 17, -1502002290);
        b = ff(b, c, d, a, k[15], 22, 1236535329);

        a = gg(a, b, c, d, k[1], 5, -165796510);
        d = gg(d, a, b, c, k[6], 9, -1069501632);
        c = gg(c, d, a, b, k[11], 14, 643717713);
        b = gg(b, c, d, a, k[0], 20, -373897302);
        a = gg(a, b, c, d, k[5], 5, -701558691);
        d = gg(d, a, b, c, k[10], 9, 38016083);
        c = gg(c, d, a, b, k[15], 14, -660478335);
        b = gg(b, c, d, a, k[4], 20, -405537848);
        a = gg(a, b, c, d, k[9], 5, 568446438);
        d = gg(d, a, b, c, k[14], 9, -1019803690);
        c = gg(c, d, a, b, k[3], 14, -187363961);
        b = gg(b, c, d, a, k[8], 20, 1163531501);
        a = gg(a, b, c, d, k[13], 5, -1444681467);
        d = gg(d, a, b, c, k[2], 9, -51403784);
        c = gg(c, d, a, b, k[7], 14, 1735328473);
        b = gg(b, c, d, a, k[12], 20, -1926607734);

        a = hh(a, b, c, d, k[5], 4, -378558);
        d = hh(d, a, b, c, k[8], 11, -2022574463);
        c = hh(c, d, a, b, k[11], 16, 1839030562);
        b = hh(b, c, d, a, k[14], 23, -35309556);
        a = hh(a, b, c, d, k[1], 4, -1530992060);
        d = hh(d, a, b, c, k[4], 11, 1272893353);
        c = hh(c, d, a, b, k[7], 16, -155497632);
        b = hh(b, c, d, a, k[10], 23, -1094730640);
        a = hh(a, b, c, d, k[13], 4, 681279174);
        d = hh(d, a, b, c, k[0], 11, -358537222);
        c = hh(c, d, a, b, k[3], 16, -722521979);
        b = hh(b, c, d, a, k[6], 23, 76029189);
        a = hh(a, b, c, d, k[9], 4, -640364487);
        d = hh(d, a, b, c, k[12], 11, -421815835);
        c = hh(c, d, a, b, k[15], 16, 530742520);
        b = hh(b, c, d, a, k[2], 23, -995338651);

        a = ii(a, b, c, d, k[0], 6, -198630844);
        d = ii(d, a, b, c, k[7], 10, 1126891415);
        c = ii(c, d, a, b, k[14], 15, -1416354905);
        b = ii(b, c, d, a, k[5], 21, -57434055);
        a = ii(a, b, c, d, k[12], 6, 1700485571);
        d = ii(d, a, b, c, k[3], 10, -1894986606);
        c = ii(c, d, a, b, k[10], 15, -1051523);
        b = ii(b, c, d, a, k[1], 21, -2054922799);
        a = ii(a, b, c, d, k[8], 6, 1873313359);
        d = ii(d, a, b, c, k[15], 10, -30611744);
        c = ii(c, d, a, b, k[6], 15, -1560198380);
        b = ii(b, c, d, a, k[13], 21, 1309151649);
        a = ii(a, b, c, d, k[4], 6, -145523070);
        d = ii(d, a, b, c, k[11], 10, -1120210379);
        c = ii(c, d, a, b, k[2], 15, 718787259);
        b = ii(b, c, d, a, k[9], 21, -343485551);

        x[0] = add32(a, x[0]);
        x[1] = add32(b, x[1]);
        x[2] = add32(c, x[2]);
        x[3] = add32(d, x[3]);

    }

    function cmn(q, a, b, x, s, t) {
        a = add32(add32(a, q), add32(x, t));
        return add32((a << s) | (a >>> (32 - s)), b);
    }

    function ff(a, b, c, d, x, s, t) {
        return cmn((b & c) | ((~b) & d), a, b, x, s, t);
    }

    function gg(a, b, c, d, x, s, t) {
        return cmn((b & d) | (c & (~d)), a, b, x, s, t);
    }

    function hh(a, b, c, d, x, s, t) {
        return cmn(b ^ c ^ d, a, b, x, s, t);
    }

    function ii(a, b, c, d, x, s, t) {
        return cmn(c ^ (b | (~d)), a, b, x, s, t);
    }

    function md51(s) {
        txt = '';
        var n = s.length,
            state = [1732584193, -271733879, -1732584194, 271733878],
            i;
        for (i = 64; i <= s.length; i += 64) {
            md5cycle(state, md5blk(s.substring(i - 64, i)));
        }
        s = s.substring(i - 64);
        var tail = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        for (i = 0; i < s.length; i++)
            tail[i >> 2] |= s.charCodeAt(i) << ((i % 4) << 3);
        tail[i >> 2] |= 0x80 << ((i % 4) << 3);
        if (i > 55) {
            md5cycle(state, tail);
            for (i = 0; i < 16; i++) tail[i] = 0;
        }
        tail[14] = n * 8;
        md5cycle(state, tail);
        return state;
    }

    /* there needs to be support for Unicode here,
     * unless we pretend that we can redefine the MD-5
     * algorithm for multi-byte characters (perhaps
     * by adding every four 16-bit characters and
     * shortening the sum to 32 bits). Otherwise
     * I suggest performing MD-5 as if every character
     * was two bytes--e.g., 0040 0025 = @%--but then
     * how will an ordinary MD-5 sum be matched?
     * There is no way to standardize text to something
     * like UTF-8 before transformation; speed cost is
     * utterly prohibitive. The JavaScript standard
     * itself needs to look at this: it should start
     * providing access to strings as preformed UTF-8
     * 8-bit unsigned value arrays.
     */
    function md5blk(s) { /* I figured global was faster.   */
        var md5blks = [],
            i; /* Andy King said do it this way. */
        for (i = 0; i < 64; i += 4) {
            md5blks[i >> 2] = s.charCodeAt(i) + (s.charCodeAt(i + 1) << 8) + (s.charCodeAt(i + 2) << 16) + (s.charCodeAt(i + 3) << 24);
        }
        return md5blks;
    }

    var hex_chr = '0123456789abcdef'.split('');

    function rhex(n) {
        var s = '',
            j = 0;
        for (; j < 4; j++)
            s += hex_chr[(n >> (j * 8 + 4)) & 0x0F] + hex_chr[(n >> (j * 8)) & 0x0F];
        return s;
    }

    function hex(x) {
        for (var i = 0; i < x.length; i++)
            x[i] = rhex(x[i]);
        return x.join('');
    }

    this.md5 = function(s) {
        return hex(md51(s));
    };

    this.isMd5 = function(s) {
        return /^[a-fA-F0-9]{32}$/.test(s);
    };

    /* this function is much faster,
    so if possible we use it. Some IEs
    are the only ones I know of that
    need the idiotic second function,
    generated by an if clause.  */
    var add32 = function(a, b) {
        return (a + b) & 0xFFFFFFFF;
    };

    if (this.md5('hello') != '5d41402abc4b2a76b9719d911017c592') {
        add32 = function(x, y) {
            var lsw = (x & 0xFFFF) + (y & 0xFFFF),
                msw = (x >> 16) + (y >> 16) + (lsw >> 16);
            return (msw << 16) | (lsw & 0xFFFF);
        };
    }
});
app.factory('$date', ["moment", function (moment) {
  var factory = {};

  factory.collisionDetection = function (start, end, events) {
    start = moment(start).format('YYYY-MM-DD');
    end = end ? moment(end).format('YYYY-MM-DD') : start;

    if (end < start) {
      return null;
    }

    for (var i = 0; i < events.length; i++) {
      /*
      if (events[i].approval) {
        if (events[i].approval.cancelled) {
          continue;
        }

        if (events[i].approval.level < events[i].approval.maxLevel) {
          continue;
        }
      }
      */

      var eventStart = moment(events[i].dateStart).format('YYYY-MM-DD');
      var eventEnd = eventStart;
      if (events[i].dateEnd) {
        eventEnd = moment(events[i].dateEnd).format('YYYY-MM-DD');
      }

      // $    |__$__|
      if (eventEnd > start && eventEnd <= end) {
        return true;
      }
      // |__$__|    $
      if (eventStart >= start && eventStart < end) {
        return true;
      }
      // $   |____|    $
      if (eventStart <= start && eventEnd >= end) {
        return true;
      }
      // |___$___$____|
      if (eventStart >= start && eventEnd <= end) {
        return true;
      }
    }

    return false;
  };

  factory.calculateTimespan = function (startTimestamp, endTimestamp) {
    var end;
    if (endTimestamp) {
      end = moment(endTimestamp);
    }
    else {
      end = moment();
    }

    var start = new Date(startTimestamp);

    var duration = moment.duration(end.diff(start));
    return duration.asMinutes().toFixed(2);
  };

  factory.totalMinutes = function (timeString) {
    var HourMinutes = timeString.split(':');
    if (HourMinutes.length == 1) {
      HourMinutes.push(0);
    }

    var hours = parseInt(HourMinutes[0]);
    var minutes = parseInt(HourMinutes[1]);

    return hours * 60 + minutes;
  };

  factory.pad = function (number, count) {
    var res = number + "";
    count = count || 2;
    while (res.length < count) {
      res = "0" + res;
    }
    return res;
  };

  factory.getTotalMinutes = function (time) {
    var HourMinutes = time.split(':');
    if (HourMinutes.length === 0 || HourMinutes.length > 2) {
      return null;
    }
    if (HourMinutes.length == 1) {
      HourMinutes.push(0);
    }

    var hours = parseInt(HourMinutes[0]);
    if (hours < 0 || hours > 23) {
      return null;
    }
    var minutes = parseInt(HourMinutes[1]);
    if (minutes < 0 || minutes > 59) {
      return null;
    }

    return hours * 60 + minutes;
  };

  factory.getWeekNumber = function (d) {
    // Copy date so don't modify original
    d = new Date(+d);
    d.setHours(0, 0, 0);
    // Set to nearest Thursday: current date + 4 - current day number
    // Make Sunday's day number 7
    d.setDate(d.getDate() + 4 - (d.getDay() || 7));
    // Get first day of year
    var yearStart = new Date(d.getFullYear(), 0, 1);
    // Calculate full weeks to nearest Thursday
    var weekNo = Math.ceil((((d - yearStart) / 86400000) + 1) / 7);
    // Return array of year and week number
    return [d.getFullYear(), weekNo];
  };

  factory.weeksInYear = function (year) {
    var month = 11, day = 31, week;

    // Find week that 31 Dec is in. If is first week, reduce date until
    // get previous week.
    do {
      d = new Date(year, month, day--);
      week = factory.getWeekNumber(d)[1];
    } while (week == 1);

    return week;
  };

  factory.getDateOfISOWeek = function (w, y) {
    var simple = new Date(y, 0, 1 + (w - 1) * 7);
    var dow = simple.getDay();
    var ISOweekStart = simple;
    if (dow <= 4)
      ISOweekStart.setDate(simple.getDate() - simple.getDay() + 1);
    else
      ISOweekStart.setDate(simple.getDate() + 8 - simple.getDay());
    return ISOweekStart;
  };

  return factory;
}]);

app.service('$entity', ["$http", "$q", "mySocket", "$rootScope", "$stateParams", "$timeout", "$util", "$interpolate", "$location", "$httpParamSerializer", "blockUI", "zapi", "apiError", function ($http, $q, mySocket, $rootScope, $stateParams, $timeout, $util, $interpolate, $location, $httpParamSerializer, blockUI, zapi, apiError) {
  var listeners = {};
  var self = this;

  this.get = function (entity, id) {
    var entityObj = zapi.entityMap[entity];

    var db = typeof entityObj.db === "function" ? entityObj.db($stateParams) : (entity.db || "common");
    var url = zapi.serverUrl + '/api/' + entity + '/list/' + db + (id ? '/' + id : '');

    if (!listeners[entity]) {
      listeners[entity] = true;
      $timeout(function () {
        var websocket;
        if (typeof entityObj.websocket !== 'function') websocket = entity;
        else websocket = entityObj.websocket($rootScope, $stateParams) + "." + entity;

        mySocket.forward(websocket + '.remove');
        mySocket.forward(websocket + '.new');
        mySocket.forward(websocket + '.edit');
        mySocket.forward(websocket + '.list.new');
        mySocket.forward(websocket + '.list.edit');
      });
    }

    return $http.get(url + '?' + $httpParamSerializer($location.search()));
  };

  this.getMany = function (entityKeys, callback) {
    //validate
    if (typeof entityKeys === 'string') entityKeys = [entityKeys];
    if (!(entityKeys instanceof Array)) return callback(undefined, {});
    if (entityKeys.length === 0) return callback(undefined, {});
    try {
      entityKeys.some(function (entityKey) {
        if (typeof entityKey !== 'string') throw "Não é possível obter dados de " + entityKey;
      });
    } catch (err) {
      return callback(err, {});
    }

    //assemble promises
    var promises = entityKeys.map(function (entityKey) {
      if (!listeners[entityKey]) {
        var entityObj = zapi.entityMap[entityKey];
        listeners[entityKey] = true;
        $timeout(function () {
          var websocket;
          if (typeof entityObj.websocket !== 'function') websocket = entityKey;
          else websocket = entityObj.websocket($rootScope, $stateParams) + "." + entityKey;

          mySocket.forward(websocket + '.remove');
          mySocket.forward(websocket + '.new');
          mySocket.forward(websocket + '.edit');
          mySocket.forward(websocket + '.list.new');
          mySocket.forward(websocket + '.list.edit');
        });
      }

      return self.get(entityKey);
    });

    //resolve promises
    $q.all(promises).then(function (results) {
      //todo return from cache
      var lookups = {};
      results.forEach(function (result, i) {
        lookups[entityKeys[i]] = result.data;
      });

      callback(null, lookups);
    }).catch(function (response) {
      callback(response.data || apiError.timeout);
    });
  };

  this.add = function (entity, item, scope) {
    return $q(function (resolve, reject) {
      var entityObj = zapi.entityMap[entity];

      var beforeSave = typeof entityObj.beforeSave === 'function' ? entityObj.beforeSave : $util.skip;
      beforeSave(item, function (err) {
        if (err) {
          swal("Antes de gravar...", err, "info");
          return reject(err);
        }

        var db = typeof entityObj.db === "function" ? entityObj.db($stateParams) : (entity.db || "common");
        var id = entityObj.id || "_id";
        var url = zapi.serverUrl + '/api/' + entity + '/add/' + db + (item[id] ? '/' + item[id] : '');

        blockUI.start($interpolate("{{'api.entity.sendData' | translate}}")(scope));
        var fd = new FormData();
        $util.setFormFiles(fd, item);
        fd.append('item', angular.toJson(item));

        $http.post(url, fd, { transformRequest: angular.identity, headers: { 'Content-Type': undefined } }).then(function (response) {
          if (item[id]) swal("Alterado", $interpolate("{{'api.entity.newRecordSuccess'|translate}}")(scope), "success");
          else swal("Criado", $interpolate("{{'api.entity.editRecordSuccess' | translate}}")(scope), "success");

          var afterSave = typeof entityObj.afterSave === 'function' ? entityObj.afterSave : $util.skip;
          afterSave($location, $rootScope);

          resolve(response);
        }).catch(function (response) {
          swal("Erro ao Guardar", response.data || apiError.timeout, "error");

          reject(response);
        }).finally(function () {
          blockUI.stop();
        });
      });
    });
  };

  this.update = function (entity, id, fieldsToSet) {
    var entityObj = zapi.entityMap[entity];

    var db = typeof entityObj.db === "function" ? entityObj.db($stateParams) : (entity.db || "common");
    var url = zapi.serverUrl + "/api/" + entity + "/update/" + db + '/' + id;

    return $http.post(url, fieldsToSet);
  };

  this.remove = function (entity, item, scope) {
    var deferred = $q.defer();
    var entityObj = zapi.entityMap[entity];

    blockUI.start($interpolate("{{'api.entity.checkRemove' | translate}}")(scope));

    var db = typeof entityObj.db === "function" ? entityObj.db($stateParams) : (entity.db || "common");
    var id = entityObj.id || "_id";
    var url = zapi.serverUrl + '/api/' + entity + '/remove/' + db + '/' + item[id];

    $http.get(url).then(function (response) {
      swal("Removido", $interpolate("{{'" + entityObj.title + "'|translate}}")(scope) + " - " + $interpolate("{{'api.entity.deleteRecordSuccess' | translate}}")(scope), "success");

      deferred.resolve(response);
    }).catch(function (response) {
      swal("Erro ao Remover", response.data || apiError.timeout, "warning");

      deferred.reject(response);
    }).finally(function () {
      blockUI.stop();
    });

    return deferred.promise;
  };

  this.lookup = function (entity) {
    var entityObj = zapi.entityMap[entity];

    var db = typeof entityObj.db === "function" ? entityObj.db($stateParams) : (entity.db || "common");
    var url = zapi.serverUrl + '/api/' + entity + '/lookup/' + db;

    return $http.get(url + '?' + $httpParamSerializer($location.search()));
  };

  this.lookupMany = function (entityKeys, callback) {
    //validate
    if (typeof entityKeys === 'string') entityKeys = [entityKeys];
    if (!(entityKeys instanceof Array)) return callback(undefined, {});
    if (entityKeys.length === 0) return callback(undefined, {});
    try {
      entityKeys.some(function (entityKey) {
        if (typeof entityKey !== 'string') throw "Não é possível obter dados de " + entityKey;
      });
    } catch (err) {
      return callback(err, {});
    }

    //assemble promises
    var promises = entityKeys.map(function (entityKey) {
      return self.lookup(entityKey);
    });

    //resolve promises
    $q.all(promises).then(function (results) {
      //todo return from cache
      var lookups = {};
      results.forEach(function (result, i) {
        lookups[entityKeys[i]] = result.data;
      });

      callback(null, lookups);
    }).catch(function (response) {
      callback(response.data || apiError.timeout);
    });
  };
}]);
app.service('ErrorSvc', function() {
  this.validationArgs = function(disabled, tooltip) {
    return {
      disabled: disabled,
      tooltip: tooltip
    };
  };
});

app.service('$factoryDefaults', ["$http", "$crypto", function ($http, $crypto) {
  this.reset = function (password, callback) {
    var md5 = $crypto.md5(password);
    $http.post('/api/factorydefaults/reset', { password: md5 }).then(function (response) {
      callback(undefined, response.data);
    }).catch(function (response) {
      callback(response.data);
    });
  };
}]);
app.service('$graph', ["$http", "graphOptions", "zapi", "apiError", function ($http, graphOptions, zapi, apiError) {
  this.get = function (driver, namespace, db, collection, query, obj, seriesKey, dataKey, labelsKey, callback) {
    var params = {
      query: query,
      obj: obj,
      seriesKey: seriesKey,
      dataKey: dataKey,
      labelsKey: labelsKey
    };
    if (typeof driver === 'undefined') driver = 'mongo';
    var url = zapi.serverUrl + '/api/graph/auto/' + namespace + '/' + db + '/' + collection + '/' + driver;

    $http.post(url, params).then(function (response) {
      response.data.options = angular.copy(graphOptions);
      if (response.data.series.length > 0) response.data.options.legend = { display: true };
      callback(response.data);
    }).catch(function (response) {
      swal("Não foi possível desenhar o gráfico", response.data || apiError.timeout, "warning");
      callback();
    });
  };

  this.custom = function (driver, namespace, db, graph, callback) {
    if (typeof driver === 'undefined') driver = 'mongo';
    var url = zapi.serverUrl + '/api/graph/custom/' + namespace + '/' + db + '/' + graph + '/' + driver;

    $http.get(url, { cache: true }).then(function (response) {
      response.data.options = angular.copy(graphOptions);
      if (typeof response.data.series !== 'undefined') {
        if (response.data.series.length > 0) response.data.options.legend = { display: true };
      }
      callback(response.data);
    }).catch(function (response) {
      swal("Não foi possível desenhar o gráfico", response.data || apiError.timeout, "warning");
      callback();
    });
  };
}]);
app.service('$holiday', function () {
  this.getDayHolidays = function (holidays, day) {
    var holidaysToday = [];

    for (var i = 0; i < holidays.length; i++) {
      if (!this.dayMatch(holidays[i].holiday, day)) continue;
      holidaysToday.push(holidays[i].holiday);
    }

    return holidaysToday;
  };

  this.dayMatch = function (holiday, thisDay) {
    if (!(thisDay instanceof Date)) {
      thisDay = new Date(thisDay);
    }
    var dayToday = thisDay.getDate();
    var monthToday = thisDay.getMonth() + 1;

    var date = calculateNextOccurrence(holiday);
    return (dayToday === date.getDate() && monthToday === date.getMonth() + 1);
  };

  this.calculateNextOccurrence = function (holiday) {
    return moment(calculateNextOccurrence(holiday)).format('YYYY-MM-DD');
  };

  function calculateNextOccurrence(holiday) {
    var date;
    var currentYear = new Date().getFullYear();

    switch (holiday.format) {
      case 'static':
        var day = holiday.date.split('/')[0];
        var month = holiday.date.split('/')[1];
        date = new Date(currentYear + '/' + month + '/' + day);

        if (new Date() >= date) {
          date = new Date((currentYear + 1) + '/' + month + '/' + day);
        }

        break;

      case 'dynamic':
        eval('my_function = ' + holiday.formula);
        if (typeof my_function !== 'function') {
          return;
        }
        date = my_function(currentYear);
        if (date < new Date()) {
          date = my_function(currentYear + 1);
        }
        break;
    }

    return date;
  }
});

app.service('$license', ["$modal", "$uibModalStack", "$location", "$timeout", function ($modal, $uibModalStack, $location, $timeout) {
  this.isLicensed = function (moduleId, user) {
    var isAllowed = false;
    if (typeof moduleId === 'undefined') isAllowed = true;
    else if (!user) isAllowed = false;
    else if (!user.license) isAllowed = false;
    else if (!(user.license.modules instanceof Array)) isAllowed = false;
    else isAllowed = user.license.modules.find(function (_moduleId) {
      return moduleId === _moduleId;
    }) || false;
    console.log('ngClick license', moduleId, 'allowed', isAllowed);
    return isAllowed;
  };

  this.notify = function (moduleId) {
    if (typeof moduleId === 'undefined') return;
    $timeout(function () {
      console.log('unlicensed notification', moduleId);
      $modal.open('unlicensed', 'md', { moduleId: moduleId }, redirectToProfile, redirectToProfile);
    });
  };

  function redirectToProfile() {
    $uibModalStack.dismissAll();
    $location.path("/profile");
  }
}]);
app.service('$list', ["$http", "blockUI", "zapi", function ($http, blockUI, zapi) {
  this.getMetadata = function (callback) {
    blockUI.start("A obter listagens disponíveis...");
    $http.get(zapi.serverUrl + '/api/list/getall').then(function (response) {
      response.data.forEach(function (list) {
        list.values = {};
      });
      callback(response.data);
    }).catch(function (response) {
      swal("Atenção", "Não foi possível obter as listagens disponíveis, por favor actualize a página", "warning");
      callback([]);
    }).finally(function () {
      blockUI.stop();
    });
  };

  this.get = function (list, db, callback) {
    blockUI.start("A obter " + list.caption);
    $http.get(zapi.serverUrl + '/api/list/values/' + db + '/' + list.name, {
      params: {
        query: list.values
      }
    }).then(function (response) {
      var items, cols;
      if (response.data instanceof Array) items = response.data;
      else {
        items = response.data.items;
        cols = response.data.cols;
      }
      callback(items, cols);
    }).catch(function (response) {
      swal("Ocorreu um erro", response.data, "warning");
      callback([]);
    }).finally(function () {
      blockUI.stop();
    });
  };
}]);
app.service('$lookup', ["zapi", "mySocket", "$rootScope", "$stateParams", function (zapi, mySocket, $rootScope, $stateParams) {
  var lookup = {};
  var listeners = {};

  this.get = function (entity) {
    if (entity) {
      if (!lookup[entity]) lookup[entity] = [];
      return lookup[entity];
    }

    return lookup;
  };

  this.set = function (entity, data) {
    if (!entity) return console.log("$lookup.set failed for entity " + entity);

    var entityObj = zapi.entityMap[entity];
    if (!lookup[entity]) lookup[entity] = [];

    if (data instanceof Array) lookup[entity] = data;
    else {
      if (typeof data !== 'object') return console.log("$lookup.set failed for entity " + entity + " because data is not an object", data);

      var finder = function (entityObj) {
        if (entityObj) {
          var idField = entityObj.id || "_id";
          return function (item) {
            return item[idField] === data[idField];
          };
        }
        else {
          return function (item) {
            return item === data;
          };
        }
      };
      var index = lookup[entity].findIndex(finder(entityObj));
      if (index === -1) lookup[entity].push(data);
      else lookup[entity].splice(index, 1, data);
    }

    if (entityObj && !listeners[entity]) {
      listeners[entity] = true;
      var websocket;
      if (typeof entityObj.websocket !== 'function') websocket = entity;
      else websocket = entityObj.websocket($rootScope, $stateParams) + "." + entity;

      mySocket.forward(websocket + '.remove');
      mySocket.forward(websocket + '.new');
      mySocket.forward(websocket + '.edit');
      mySocket.forward(websocket + '.list.new');
        mySocket.forward(websocket + '.list.edit');
    }

    return lookup[entity];
  };

  this.unset = function (entity, id) {
    var entityObj = zapi.entityMap[entity];
    var idField = entityObj ? (entityObj.id || "_id") : undefined;

    if (!lookup[entity]) lookup[entity] = [];
    var index = lookup[entity].findIndex(function (item) {
      return (idField ? item[idField] : item) == id;
    });

    if (index === -1) return lookup[entity];
    lookup[entity].splice(index, 1);

    return lookup[entity];
  };
}]);
app.service('$modal', ["$uibModal", "zapi", function ($uibModal, zapi) {
  this.open = function (name, size, data, okCallback, dismissCallback) {
    var entityObj = zapi.entityMap[name];

    var modalInstance = $uibModal.open({
      animation: true,
      templateUrl: entityObj ? 'entity/entity.modal.html' : 'modal/' + name + '/' + name + '.html',
      controller: entityObj ? 'entityModalCtrl' : name + 'Ctrl',
      size: size,
      backdrop: 'static',
      resolve: {
        data: function () {
          return data;
        }
      }
    });

    okCallback = okCallback || function () { };
    dismissCallback = dismissCallback || function () { };
    modalInstance.result.then(okCallback, dismissCallback);
  };
}]);
app.service('$newsletter', ["$entity", "blockUI", function ($entity, blockUI) {
    this.subscribe = function (item) {
        if (!item) return;

        blockUI.start("A gravar email...");
        $entity.add('newsletter', item, $scope).then(function (response) {
            swal("Newsletter", 'Email gravado com sucesso', 'success');
        }).catch(function (response) {
            swal("Newsletter", 'Não foi possível registar o seu email de momento por favor tente novamente', 'warning');
        }).finally(function () {
            callback();
            blockUI.stop();
        });
    };
}]);

app.service('$owner', ["$http", "blockUI", function ($http, blockUI) {
  this.getOwners = function (callback) {
    blockUI.start('A obter dados dos clientes...');
    $http.get('/api/user/owners').then(function (response) {
      callback(response.data);
    }).catch(function (response) {
      console.error(response.data);
      callback();
    }).finally(function () {
      blockUI.stop();
    });
  };
}]);
app.factory('$page', ["projectTitle", function(projectTitle) {
  var scaffold = " - " + projectTitle;
  var title = "";
  return {
    title: function() {
      return title + scaffold;
    },
    setTitle: function(newTitle) {
      title = newTitle;
    }
  };
}]);

app.service('$report', ["$http", "blockUI", "$httpParamSerializer", "zapi", "apiError", function ($http, blockUI, $httpParamSerializer, zapi, apiError) {
  this.getMetadata = function (reportKey, callback) {
    var url = zapi.serverUrl + '/api/report/metadata/' + reportKey;

    blockUI.start('A obter meta dados...');
    $http.get(url).then(function (response) {
      callback(null, response.data);
    }).catch(function (response) {
      callback(response.data || apiError.timeout);
    }).finally(function () {
      blockUI.stop();
    });
  };

  this.getReport = function (namespace, db, reportKey, item, callback) {
    var url = zapi.serverUrl + '/api/report/get/' + namespace + '/' + db + '/' + reportKey + '?' + $httpParamSerializer(item);

    blockUI.start('A obter dados...');
    $http.get(url).then(function (response) {
      callback(null, response.data);
    }).catch(function (response) {
      callback(response.data || apiError.timeout);
    }).finally(function () {
      blockUI.stop();
    });
  };
}]);
app.service('$role', ["$http", "zapi", function($http, zapi) {
    this.getPermissions = function() {
        return $http.get(zapi.serverUrl + "/api/role/permissions");
    };
}]);
app.service('$task', ["$http", "blockUI", "zapi", "apiError", function ($http, blockUI, zapi, apiError) {
  this.toggleState = function (task) {
    blockUI.start('A executar...');
    $http.get(zapi.serverUrl + '/api/task/toggle/' + task._id).then(function (response) {
      //todo $route.reload();
    }).catch(function (response) {
      swal("Ocorreu um erro ao alternar o estado da tarefa", response.data || apiError.timeout, 'error');
    }).finally(function () {
      blockUI.stop();
    });
  };

  this.run = function (task) {
    return $http.get(zapi.serverUrl + '/api/task/run/' + task._id);
  };

  this.getTypes = function (callback) {
    blockUI.start('A obter dados...');
    $http.get(zapi.serverUrl + '/api/task/types').then(function (response) {
      callback(response.data);
    }).catch(function (response) {
      swal("Não foi possível atualizar a lista de tarefas", response.data || apiError.timeout, 'error');
      callback([]);
    }).finally(function () {
      blockUI.stop();
    });
  };
}]);
app.service('$util', function () {
  this.flattenArray = function (items, json) {
    var table = [],
      keys = [],
      key, data = [];
    items.forEach(function (item) {
      var row = flatten(item);
      for (key in row) {
        if (keys.indexOf(key) !== -1) continue;
        keys.push(key);
      }
      table.push(row);
    });

    if (!json) data.push(keys);

    table.forEach(function (row) {
      var datum;
      if (json) {
        datum = row;
      } else {
        datum = [];
        keys.forEach(function (key) {
          if (typeof row[key] === 'undefined') datum.push("");
          else datum.push(row[key]);
        });
      }
      data.push(datum);
    });

    return data;
  };

  this.setFormFiles = setFormFiles;

  this.skip = function () {
    var callback;
    for (var i = arguments.length - 1; i >= 0; i--) {
      if (typeof arguments[i] !== 'function') continue;
      callback = arguments[i];
      break;
    }
    if (typeof callback === 'function') return callback();
  };

  function setFormFiles(fd, item, parent) {
    //ignore if current object has nothing or is a string
    if (!item || typeof item === 'string') return;

    //array
    if (item.length) {
      for (var i = 0; i < item.length; i++) {
        setFormFiles(fd, item[i], parent + '[' + i + ']');
      }
    }
    //not array
    else {
      //for each nested object
      for (var property in item) {
        if (typeof item[property] !== 'object') continue;

        //file object
        if (property === 'newFile') {
          for (var file in item[property]) {
            var filePath = parent ? parent + '.' + file : file;
            fd.append(filePath, item[property][file]);
          }
        }
        //non file object
        else {
          setFormFiles(fd, item[property], parent ? parent + '.' + property : property);
        }
      }
    }
  }

  function flatten(data) {
    var result = {};

    function recurse(cur, prop) {
      if (Object(cur) !== cur) {
        result[prop] = cur;
      } else if (Array.isArray(cur)) {
        for (var i = 0, l = cur.length; i < l; i++)
          recurse(cur[i], prop + "[" + i + "]");
        if (l === 0)
          result[prop] = [];
      } else {
        var isEmpty = true;
        for (var p in cur) {
          isEmpty = false;
          recurse(cur[p], prop ? prop + "." + p : p);
        }
        if (isEmpty && prop)
          result[prop] = {};
      }
    }
    recurse(data, "");
    return result;
  }
});
app.service('$validate', function() {
  function getNumberFromChar(letter) {
    switch (letter) {
      case '0': return 0;
      case '1': return 1;
      case '2': return 2;
      case '3': return 3;
      case '4': return 4;
      case '5': return 5;
      case '6': return 6;
      case '7': return 7;
      case '8': return 8;
      case '9': return 9;
      case 'A': return 10;
      case 'B': return 11;
      case 'C': return 12;
      case 'D': return 13;
      case 'E': return 14;
      case 'F': return 15;
      case 'G': return 16;
      case 'H': return 17;
      case 'I': return 18;
      case 'J': return 19;
      case 'K': return 20;
      case 'L': return 21;
      case 'M': return 22;
      case 'N': return 23;
      case 'O': return 24;
      case 'P': return 25;
      case 'Q': return 26;
      case 'R': return 27;
      case 'S': return 28;
      case 'T': return 29;
      case 'U': return 30;
      case 'V': return 31;
      case 'W': return 32;
      case 'X': return 33;
      case 'Y': return 34;
      case 'Z': return 35;
      default: return -1;
    }
  }

  function isValidString(v) {
    if (!v) {
      return false;
    }

    return (typeof v == 'string' || v instanceof String);
  }

  this.nif = function(value) {
    if (!isValidString(value)) {
      return false;
    }

    //Qualquer sequencia de 9 digitos iniciada por 1,2,5,6,7,8,9
    var re = new RegExp("[1,2,5,6,7,8,9]\\d{8}");
    if (!value.match(re)) {
      return false;
    }

    //calculo do total, de cada numero do contribuinte
    var total = 0;
    for (i = 0; i < 8; i++) {
      total += parseInt(value[i]) * (9 - i);
    }

    var check = 11 - (total % 11);
    if (check >= 10) {
      check = 0;
    }
    if(check !== parseInt(value[8])) {
      return false;
    }
    else {
      return true;
    }
  };

  this.niss = function(input) {
    if (!isValidString(input)) {
      return false;
    }

    input = input.replace(/\s+/g, '');
    if(input.length !== 11) {
      return false;
    }

    var factor =  [ 29, 23, 19, 17, 13, 11, 7, 5, 3, 2 ];
    var totalSum = 0;
    for (var i = 0; i<input.length-1; i++) {
      totalSum += parseInt(input[i] * factor[i]);
    }

    totalSum = 9-parseInt(totalSum % 10);
    var checkSum = parseInt(input[input.length-1]);

    return (totalSum === checkSum);
  };

  this.cc = function(input) {
    if (!isValidString(input)) {
      return false;
    }

    var sum = 0;
    var secondDigit = false;
    if(input.length !== 12) {
      return false;
    }
    for (var i = input.length-1; i >= 0; --i) {
      var valor = getNumberFromChar(input[i]);
      if (valor === -1) {
        return false;
      }
      if (secondDigit) {
        valor *= 2;
        if (valor > 9) {
          valor -= 9;
        }
      }
      sum += valor;
      secondDigit = !secondDigit;
    }
    return (sum % 10) === 0;
  };

  this.nib = function(value) {
    if (!isValidString(value)) {
      return false;
    }

    var re = new RegExp("^\\d{21}$");
    if (!value.match(re)) {
      return false;
    }

    var result = 0;
    for (var i = 0; i < 19; i++) {
      result += parseInt(value[i]);
      result *= 10;
      result %= 97;
    }
    result = 98 - ((result * 10) % 97);
    return parseInt(value.substring(19, 21)) === result;
  };
});

app.factory('mySocket', ["zapi", "socketFactory", function (zapi, socketFactory) {
  if (typeof zapi.websocketUrl === 'undefined') return socketFactory();

  var ioSocket = io.connect(zapi.websocketUrl);
  return socketFactory({
    ioSocket: ioSocket
  });
}]);

app.controller('ccCtrl', function () {
});
app.controller('attachmentsCtrl', function () {
});
app.controller('toCtrl', function() {
});
app.directive('addressEdit', function () {
  return {
    restrict: 'A',
    scope: {
      item: '='
    },
    templateUrl: 'directives/address/addressEdit.html',
    controller: ["$scope", "$address", "lookup", function ($scope, $address, lookup) {
      $scope.validateZipcode = $address.validateZipcode;
      $scope.lookup = lookup;

      $scope.getAddressPT = function (zipcode) {
        $address.getAddressPT(zipcode, function (err, data) {
          if (err) return swal("Atenção", "Não foi possível completar o arruamento", "warning");

          $scope.item.address = data.address;
          $scope.item.city = data.city;
          $scope.item.locality = data.locality;
          $scope.item.county = data.county;
          $scope.item.country = "Portugal";
        });
      };
    }]
  };
});
app.directive('addressView', function () {
  return {
    restrict: 'A',
    scope: {
      item: '=',
      prefix: '@?',
    },
    replace: false,
    templateUrl: 'directives/address/addressView.html',
    controller: ["$scope", function ($scope) {
      $scope.prefix = $scope.prefix || "";
    }]
  };
});
/*
$scope.calendarView = null;

$scope.events = [{
  title: 'chazinho com a avo',
  type: 'important',
  startsAt: new Date('2016-02-25T10:00:00.000Z'),
  endsAt: new Date('2016-02-25T12:00:00.000Z'),
  draggable: true,
  resizable: true
}];
*/

app.directive('apiCalendar', function () {
  return {
    restrict: 'A',
    scope: {
      calendarView: '=',
      events: '=',
      calendarTitle: '='
    },
    templateUrl: 'directives/calendar/calendar.html',
    controller: ["$scope", "$window", "calendarConfig", "moment", function ($scope, $window, calendarConfig, moment) {
      calendarConfig.templates.calendarMonthCell = 'groupedMonthEvents.html';
      calendarConfig.dateFormatter = 'moment';
      calendarConfig.allDateFormats.moment.title.week = "Semana {week} de {year}";
      calendarConfig.allDateFormats.moment.date.hour = 'HH:mm';
      calendarConfig.allDateFormats.moment.date.time = 'D MMMM';
      calendarConfig.allDateFormats.moment.date.datetime = "YYYY.MMM.D";
      calendarConfig.displayEventEndTimes = true;
      $scope.$on('$destroy', function () {
        calendarConfig.templates.calendarMonthCell = 'mwl/calendarMonthCell.html';
      });

      $window.moment = $window.moment || moment;

      if (!$scope.calendarView) {
        $scope.calendarView = 'month';
      }
      $scope.viewDate = new Date();

      $scope.isCellOpen = true;

      $scope.toggle = function ($event, field, event) {
        $event.preventDefault();
        $event.stopPropagation();
        event[field] = !event[field];
      };

      $scope.groupEvents = function (cell) {
        cell.groups = {};
        (cell.events || []).forEach(function (event) {
          cell.groups[event.type] = cell.groups[event.type] || [];
          cell.groups[event.type].push(event);
        });
      };
    }]
  };
});

app.directive('apiFile', ["zapi", function (zapi) {
  return {
    restrict: 'A',
    scope: {
      item: '=',
      var: '=',
      docid: '='
    },
    replace: false,
    link: function (scope, element, attrs) {
      if (scope.docid && scope.docid._id) scope.docid = scope.docid._id;
    },
    templateUrl: 'directives/document/file.html'
  };
}]);
app.directive('fileModel', ["$parse", function ($parse) {
  return {
    restrict: 'A',
    replace: false,
    link: function(scope, element, attrs) {
      var model = $parse(attrs.fileModel);
      var modelSetter = model.assign;

      element.bind('change', function() {
        scope.$apply(function() {
          modelSetter(scope, element[0].files[0]);
        });
      });
    }
  };
}]);

app.directive('dynamicField', function () {
  return {
    restrict: 'A',
    scope: {
      field: '=',
      model: '=',
      key: '@',
      lookup: '=?'
    },
    template: '<div ng-include src="contentUrl" include-replace></div>',
    controller: ["$scope", "$entity", function ($scope, $entity) {
      if (typeof $scope.lookup === 'undefined') $scope.lookup = {};
      $scope.$watch('field.type', onFieldChange);

      function onFieldChange(newField) {
        if (!newField) return;
        var type = $scope.field.type || 'Unknown';
        if (type === 'ObjectId') {
          var ref = $scope.field.ref;
          if (typeof ref === 'undefined') type = "String";
          else {
            if ($scope.lookup[ref]) return;
            else $scope.lookup[ref] = [];

            $entity.lookup(ref).then(function (response) {
              $scope.lookup[ref] = response.data;
            });
          }
        }
        $scope.contentUrl = "directives/dynamicField/" + type + ".html";
      }
    }]
  };
});
app.controller('factoryDefaultsCtrl', ["$scope", "blockUI", "$factoryDefaults", "$modal", function ($scope, blockUI, $factoryDefaults, $modal) {
  $scope.resetFactoryDefaults = function () {
    swal({
      type: "warning",
      title: "Esta operação é irreversível",
      text: "Tem a certeza que deseja restaurar configurações de fábrica?",
      input: 'password',
      showCloseButton: true,
      showCancelButton: true,
      focusConfirm: false,
      confirmButtonText: "Sim",
      cancelButtonText: "Não"
    }).then(function (result) {
      if (result && result.dismiss) return;
      blockUI.start("A verificar credenciais...");
      $factoryDefaults.reset(result.value, function (err, token) {
        blockUI.stop();
        if (err) return swal("Credenciais inválidas", err, "error");
        $modal.open('resetFactoryDefaults', 'md', token);
      });
    }).catch(function (err) {
      console.error(err);
    });
  };
}]);
app.directive('factoryDefaults', function () {
  return {
    restrict: 'A',
    scope: false,
    transclude: true,
    templateUrl: 'directives/factoryDefaults/factoryDefaults.html',
    controller: 'factoryDefaultsCtrl'
  };
});
app.directive('apiGraph', function() {
  return {
    restrict: 'A',
    scope: {
      item: '=',
      namespace: '@',
      db: '@',
      driver: '@?',
      custom: '@?',
      noToggle: '@?',
      noPanel: '@?'
    },
    replace: false,
    templateUrl: 'directives/graph/graph.html',
    controller: ["$scope", "blockUI", "$graph", "chartTypes", function($scope, blockUI, $graph, chartTypes) {
      if (typeof $scope.driver === 'undefined') $scope.driver = 'mongo';
      var graphBlockUI = blockUI.instances.get('graphBlockUI');
      $scope.chart = {};

      initialize();

      $scope.getNext = function() {
        var index = chartTypes[$scope.item.dimension].indexOf($scope.item.type) + 1;
        return chartTypes[$scope.item.dimension][index === chartTypes[$scope.item.dimension].length ? 0 : index];
      };

      $scope.toggle = function() {
        $scope.item.type = $scope.getNext();
      };

      function initialize() {
        graphBlockUI.start("A criar gráfico...");

        if (typeof $scope.custom === 'string') {
          $graph.custom($scope.driver, $scope.namespace, $scope.db, $scope.custom, finished);
        } else {
          $graph.get(
            $scope.driver,
            $scope.namespace,
            $scope.db,
            $scope.item.collection,
            $scope.item.query,
            $scope.item.obj,
            $scope.item.seriesKey,
            $scope.item.dataKey,
            $scope.item.labelsKey,
            finished
          );
        }
      }

      function finished(chart) {
        $scope.chart = chart;
        graphBlockUI.stop();
      }
    }]
  };
});
app.directive('predefinedList', function () {
  return {
    restrict: 'A',
    scope: {
      listname: '@?',
      db: '@?'
    },
    replace: false,
    templateUrl: 'directives/list/list.html',
    controller: ["$scope", "$list", "$page", "NgTableParams", "$stateParams", "$httpParamSerializer", "$timeout", "$location", "$interpolate", "$modal", "zapi", function ($scope, $list, $page, NgTableParams, $stateParams, $httpParamSerializer, $timeout, $location, $interpolate, $modal, zapi) {
      var db = $scope.db || $stateParams.db || "common";

      $scope.lists = [];
      $scope.list = { name: "", parameters: [], values: {} };
      $scope.tableParams = null;
      $scope.items = [];
      $scope.isGroupHeaderRowVisible = true;

      $scope.get = function (list) {
        if (!list) return;

        $list.get(list, db, function (items, cols) {
          //set columns
          if (typeof cols !== 'undefined') list.cols = cols;
          list.cols = setColumns(list.cols);

          var initialParams = {};
          if (list.group) {
            if (list.group.multi === true) {
              var groupByCustom = function (item) {
                for (var i = 0; i < list.group.items.length; i++) {
                  list.group.formatGroup = list.group.formatGroup.replace('{' + i + '}', item[list.group.items[i]]);
                }
                return list.group.formatGroup;
              };
              groupByCustom.title = list.group.title;
              groupByCustom.sortDirection = list.group.sort;
              initialParams.group = groupByCustom;
              $scope.isGroupHeaderRowVisible = (list.group.showGroupHeader === true);
            } else { initialParams.group = list.group; }
          }

          var params = { dataset: items };
          if (typeof list.groupOptions !== 'undefined') params.groupOptions = list.groupOptions;

          $scope.items = items;
          $scope.tableParams = new NgTableParams(initialParams, params);
        });
      };

      $scope.reset = function (list) {
        if (!list) return;

        $scope.items = [];
        $scope.tableParams = null;
        var currentLocation = $location.url().replace($scope.listname, "");
        if (!currentLocation.endsWith('/')) currentLocation += '/';
        $location.url(currentLocation + list.name);
      };

      $scope.setParameters = function (list) {
        if (!list) return;

        $modal.open('predefinedListParameters', 'md', list, function (list) {
          $scope.list = list;
          $scope.get(list);
        }, function (cancelReason) {
          //dismissed
        });
      };

      $scope.applySearch = function (search) {
        if (!search) return;

        var criteria = angular.copy(search.text);
        if (search.inverted) criteria = "!" + criteria;
        $scope.tableParams.filter({ $: criteria });
      };

      $scope.getExcelUrl = function (list) {
        if (!list) return;

        return '/api/list/values/' + db + '/' + list.name + '?xls=1&' + $httpParamSerializer({ query: list.values, dbs: $scope.selectedDbs });
      };

      $scope.getPdfUrl = function (list) {
        if (!list) return;

        return '/api/list/values/' + db + '/' + list.name + '?pdf=1&' + $httpParamSerializer({ query: list.values, dbs: $scope.selectedDbs });
      };

      $timeout(initialize);

      function initialize() {
        //selecionar automáticamente caso seja apenas 1 db
        $list.getMetadata(function (lists) {
          $scope.lists = lists;

          //selecionar automáticamente a lista no URL
          if (typeof $scope.listname === 'undefined') return;
          var list = lists.find(function (list) {
            return list.name === $scope.listname;
          });
          if (!list) return;

          //set columns
          list.cols = setColumns(list.cols);

          $scope.list = list;
          $page.setTitle(list.caption);
          if (list.parameters.length === 0) $scope.get(list);
          else $scope.setParameters(list);
        });
      }

      function setColumns(cols) {
        return cols.map(function (col) {
          col.getValue = interpolatedValue;
          if (col.interpolateExpr) {
            col.interpolateExpr = $interpolate(col.interpolateExpr);
          } else {
            col.interpolateExpr = $interpolate("{{row." + col.field + "}}");
          }
          return col;
        });
      }

      function interpolatedValue($scope, row) {
        return this.interpolateExpr({ row: row });
      }
    }]
  };
});
app.directive('entityArray', function () {
  return {
    restrict: 'A',
    templateUrl: 'directives/entity/entity.array.html',
    scope: {
      item: '=',
      var: '@',

      key: '@',
      isObject: '@',
      allowDuplicates: '@',

      lookup: '=',

      label: '@',

      isVisible: '&?',
      isMovable: '@',
      noInsert: '@',
      removable: '@',

      approvalMaxLevel: '@'
    },
    controller: ["$scope", "$rootScope", "$controller", "$timeout", function ($scope, $rootScope, $controller, $timeout) {
      $scope.newContainerItem = $scope.isObject ? {} : "";

      $scope.append = function (newContainerItem) {
        append(newContainerItem, function (err) {
          if (err) return swal("Atenção", err, "warning");

          //clear new container item fields
          $scope.newContainerItem = $scope.isObject ? {} : "";
        });
      };

      $scope.remove = function (containerItem) {
        var index = $scope.item[$scope.var].indexOf(containerItem);
        if (index === -1) return;
        $scope.item[$scope.var].splice(index, 1);
      };

      $scope.validate = function (newContainerItem) {
        $scope.console = null;
        if (typeof $scope.getError !== 'function') return false;

        if (!newContainerItem) return true;
        if ($scope.isObject) {
          if (Object.keys(newContainerItem).length === 0 && JSON.stringify(newContainerItem) === JSON.stringify({})) return true;
        }

        var response = $scope.getError(newContainerItem, $scope.item[$scope.var]);
        $scope.console = response.disabled ? response.tooltip : null;
        return !!$scope.console;
      };

      $scope.pushBack = function (index) {
        var _containerItem = $scope.item[$scope.var].splice(index, 1);
        $scope.item[$scope.var].splice(index - 1, 0, _containerItem[0]);
      };

      $scope.pushForward = function (index) {
        var _containerItem = $scope.item[$scope.var].splice(index, 1);
        $scope.item[$scope.var].splice(index + 1, 0, _containerItem[0]);
      };

      //$timeout is only ready after directive has fully loaded
      //this way when the controller loads, $scope will be fully populated
      $timeout(initialize);

      function initialize() {
        $controller($scope.var + 'Ctrl', { $scope: $scope });
      }

      function append(newContainerItem, callback) {
        if (!newContainerItem) return callback("Registo inválido");

        if (!$scope.item[$scope.var]) $scope.item[$scope.var] = [];

        //check if containerItem is not empty
        if ($scope.isObject) {
          var key = {
            property: null,
            key: null
          };
          if (newContainerItem[$scope.key]) {
            key.key = newContainerItem[$scope.key];
          } else {
            for (var property in newContainerItem) {
              if (newContainerItem[property][$scope.key]) {
                key.property = property;
                key.key = newContainerItem[property][$scope.key];
                break;
              }
            }
          }

          if (key.key) {
            //check if containerItem already exists in container
            var duplicateKey = $scope.item[$scope.var].forEach(function (subitem) {
              var obj = key.property ? subitem[key.property] : subitem;
              return (obj[$scope.key] === key.key && typeof $scope.allowDuplicates === 'undefined');
            });
            if (duplicateKey) return callback('Registo duplicado em ' + $scope.label);
          }
        } else {
          var duplicateValue = $scope.item[$scope.var].forEach(function (subitem) {
            return (subitem === newContainerItem && typeof $scope.allowDuplicates === 'undefined');
          });
          if (duplicateValue) return callback('Registo duplicado em ' + $scope.label);
        }

        //approvable containers only
        if ($scope.approvalMaxLevel) {
          newContainerItem.approval = {
            level: $rootScope.login.role.approvalLevel,
            maxLevel: $scope.approvalMaxLevel
          };
        }

        //append item to container
        $scope.item[$scope.var].unshift(newContainerItem);

        callback();
      }
    }]
  };
});
app.directive('entityEdit', function () {
  return {
    restrict: 'EA',
    scope: {
      entity: '@',
      item: '=?',
      lookup: '=?',
      form: '=',
      fetch: '@'
    },
    template: '<div ng-include src="contentUrl" include-replace></div>',
    controller: ["$scope", "zapi", "$interpolate", "$controller", "$entity", "$rootScope", "$stateParams", "$timeout", "blockUI", "apiError", function ($scope, zapi, $interpolate, $controller, $entity, $rootScope, $stateParams, $timeout, blockUI, apiError) {
      //validate
      $scope.entity = $scope.entity || $stateParams.entity;
      var entityObj = zapi.entityMap[$scope.entity];
      if (!entityObj) return;
      if (!entityObj.edit) return;

      //defaults
      $scope.item = $scope.item || undefined;
      if (typeof $scope.lookup === 'undefined') $scope.lookup = {};
      $scope.fetch = $scope.fetch ? true : false;
      $scope._form = $scope.form;
      $scope.contentUrl = 'entity/' + $scope.entity + '/' + $scope.entity + '.edit.html';

      var idField = entityObj.id || "_id";
      var idValue;
      if ($scope.item) idValue = $scope.item[idField];
      else if ($stateParams.entity === $scope.entity && $stateParams.id) idValue = $stateParams.id;
      if (!idValue && Object.keys($scope.item || {}).length === 0) {
        if (typeof entityObj.blank === 'function') $scope.item = entityObj.blank($rootScope);
        else $scope.item = {};
      }

      //main
      if ($scope.fetch) initialize(loadFinished);
      else loadFinished();

      //private functions
      function initialize(callback) {
        if (!idValue) get($scope.entity, null, callback);
        else get($scope.entity, idValue, callback);
      }

      function get(entity, id, callback) {
        blockUI.start($interpolate("{{'api.entity.getData' | translate}}")($scope));
        $entity.lookupMany(entityObj.lookup, function (err, lookups) {
          if (err) {
            blockUI.stop();
            callback();
            return swal("Não foi possível obter os dados", err, 'warning');
          }

          for (var key in lookups) $scope.lookup[key] = lookups[key];

          //if user is creating a new record
          if (!id) {
            blockUI.stop();
            return callback();
          }

          $entity.get(entity, id).then(function (response) {
            $scope.item = response.data;

            //todo
            //$scope.lookup[$scope.entity] = $lookup.set($scope.entity, response.data);
          }).catch(function (response) {
            swal("Não foi possível obter os dados necessários", response.data || apiError.timeout, "warning");
          }).finally(function () {
            blockUI.stop();
            callback();
          });
        });
      }

      function loadFinished() {
        $timeout(function () {
          var entityKeys = (entityObj.lookup || []).concat($scope.entity);
          entityKeys.forEach(function (entityKey) {
            var entity = zapi.entityMap[entityKey];
            var websocket;
            if (typeof entity.websocket !== 'function') websocket = entity.key;
            else websocket = entity.websocket($rootScope, $stateParams) + "." + entity.key;

            $scope.$on('socket:' + websocket + '.remove', onThisEntityRemove);
            $scope.$on('socket:' + websocket + '.new', onThisEntityEdit);
            $scope.$on('socket:' + websocket + '.edit', onThisEntityEdit);
          });

          //inject child controller
          try {
            if ($scope.fetch) $controller($scope.entity + 'Ctrl', { $scope: $scope });
          } catch (err) {
            console.log(err);
          }
        });
      }

      function onThisEntityEdit(ev, data) {
        var matches = /socket\:(\w+)\./.exec(ev.name) || [];
        if (matches.length !== 2) return console.log('unexpected socket forwarding', ev, data);
        var entity = matches[1];

        //todo
        //$scope.lookup[entity] = $lookup.set(entity, data);
        if (idValue != data[idField]) return;

        //$scope.item = data;
      }

      function onThisEntityRemove(ev, id) {
        var matches = /socket\:(\w+)\./.exec(ev.name) || [];
        if (matches.length !== 2) return console.log('unexpected socket forwarding', ev, data);
        var entity = matches[1];

        //todo
        //$scope.lookup[$scope.entity] = $lookup.unset(entity, id);
        if (idValue != id) return;

        swal("Outro utilizador apagou este registo", "Actualize a página para ver reflitadas as alterações", "info");
      }
    }]
  };
});
app.directive('entityFilter', function () {
  return {
    restrict: 'E',
    scope: {
      entity: '@',
      table: '=',
      lookup: '='
    },
    transclude: true,
    templateUrl: 'directives/entity/entity.filter.html',
    controller: ["$scope", "zapi", function ($scope, zapi) {
      var entityObj = zapi.entityMap[$scope.entity];

      $scope.applySearch = function (search) {
        var criteria = angular.copy(search.text);

        var key = {};
        if (entityObj && typeof entityObj.searchAttr === 'string') key = entityObj.searchAttr;
        else key = "$";

        var filter = $scope.table.params._params.filter || {};
        filter[key] = criteria;

        $scope.table.params.filter(filter);
      };
    }]
  };
});
app.directive('entityList', function () {
  return {
    restrict: 'E',
    scope: {
      entity: '@',
      items: '=?',
      lookup: '=?',
      noTable: '@'
    },
    templateUrl: 'directives/entity/entity.list.html',
    controller: ["$scope", "$interpolate", "$controller", "$entity", "$stateParams", "$rootScope", "$interval", "zapi", "blockUI", "NgTableParams", function ($scope, $interpolate, $controller, $entity, $stateParams, $rootScope, $interval, zapi, blockUI, NgTableParams) {
      //validate
      $scope.entity = $scope.entity || $stateParams.entity;
      $scope.entityObj = zapi.entityMap[$scope.entity];
      if (!$scope.entityObj) return;
      if (!$scope.entityObj.list) return;

      //defaults
      var idField = $scope.entityObj.id || "_id";
      $scope.items = $scope.items || [];
      if (typeof $scope.lookup === 'undefined') $scope.lookup = {};
      $scope.noTable = $scope.noTable || false;
      if (!$scope.noTable) $scope.table = { params: null };
      $scope.contentUrl = 'entity/' + $scope.entity + '/' + $scope.entity + '.list.html';

      //main
      initialize(loadFinished);

      //private functions
      function initialize(callback) {
        blockUI.start($interpolate("{{'api.entity.getData' | translate}}")($scope));
        //get main entity
        $entity.get($scope.entity).then(function (response) {
          $scope.items = response.data;
          if (!$scope.noTable) $scope.table.params = new NgTableParams({}, { dataset: $scope.items });

          //get lookup entities
          var entities = ($scope.entityObj.lookup || []);
          $entity.lookupMany(entities, function (err, lookups) {
            blockUI.stop();
            callback();
            if (err) return swal("Não foi possível obter os dados", err, 'warning');

            if (typeof $scope.lookup === 'undefined') $scope.lookup = {};
            for (var key in lookups) $scope.lookup[key] = lookups[key];
          });
        }).catch(function (response) {
          console.error(response);
        });
      }

      function loadFinished() {
        var intervalId = $interval(function () {
          //get websocket channel
          var websocket;
          try {
            if (typeof $scope.entityObj.websocket !== 'function') websocket = $scope.entity;
            else websocket = $scope.entityObj.websocket($rootScope, $stateParams) + "." + $scope.entity;

            if (typeof websocket !== 'string') return;
          } catch (err) {
            return;
          }
          $interval.cancel(intervalId);

          //listen to websocket channel
          $scope.$on('socket:' + websocket + '.remove', onThisEntityRemove);
          $scope.$on('socket:' + websocket + '.list.new', onThisEntityNew);
          $scope.$on('socket:' + websocket + '.list.edit', onThisEntityEdit);

          //inject child controller
          try {
            $controller($scope.entity + 'Ctrl', { $scope: $scope });
          } catch (err) {
            console.log(err);
          }
        }, 100);
      }

      function onThisEntityNew(ev, data) {
        //todo
        //$scope.lookup[$scope.entity] = $lookup.set($scope.entity, data);
        //$scope.items = angular.copy($lookup.get($scope.entity));
        $scope.items.unshift(data);
        if ($scope.noTable) return;

        $scope.table.params.total($scope.items.length);
        $scope.table.params.reload();
        //$scope.table.params = new NgTableParams({}, { dataset: $scope.items });
      }

      function onThisEntityEdit(ev, data) {
        //todo
        //$scope.lookup[$scope.entity] = $lookup.set($scope.entity, data);
        //$scope.items = angular.copy($lookup.get($scope.entity));
        var index = $scope.items.findIndex(function (item) {
          return data[idField] == item[idField];
        });
        if (index === -1) return;
        $scope.items[index] = data;

        if ($scope.noTable) return;

        $scope.table.params.total($scope.items.length);
        $scope.table.params.reload();
        //$scope.table.params = new NgTableParams({}, { dataset: $scope.items });
      }

      function onThisEntityRemove(ev, id) {
        //todo
        //$scope.lookup[$scope.entity] = $lookup.unset($scope.entity, id);
        //$scope.items = angular.copy($lookup.get($scope.entity));

        var index = $scope.items.findIndex(function (item) {
          return item[idField] == id;
        });
        if (index !== -1) $scope.items.splice(index, 1);
        if ($scope.noTable) return;

        $scope.table.params.total($scope.items.length);
        $scope.table.params.reload();
        //$scope.table.params = new NgTableParams({}, { dataset: $scope.items });
      }
    }]
  };
});
app.directive('entityModal', ["$modal", "$rootScope", "$interpolate", "zapi", function ($modal, $rootScope, $interpolate, zapi) {
  return {
    restrict: 'E',
    scope: {
      entity: "@",
      item: "=?",
      lookup: "=?",
      view: "@?",
      clone: "@?",
      onOpen: "&?"
    },
    transclude: true,
    templateUrl: "directives/entity/entity.modal.html",
    link: function (scope) {
      //defaults
      scope.item = scope.item || {};
      scope.view = scope.view ? true : false;
      scope.clone = scope.clone ? true : false;
      scope.visible = false;

      //validate
      var isAdmin = $rootScope.login && $rootScope.login.role && $rootScope.login.role.admin;
      var entityObj = zapi.entityMap[scope.entity];
      if (!entityObj) return;

      //assign template
      var idField = entityObj.id || "_id";
      var size = typeof entityObj.modal === 'string' ? entityObj.modal : 'lg';
      if (scope.view) {
        //view
        scope.icon = 'fa-eye';
        scope.text = $interpolate("{{'global.view' | translate}}")(scope);
        scope.color = 'primary';
        scope.visible = entityObj.view && (entityObj.view.admin && isAdmin || !entityObj.view.admin);
      }
      else if (scope.clone) {
        //clone
        scope.icon = 'fa-clone';
        scope.text = $interpolate("{{'global.clone' | translate}}")(scope);
        scope.color = 'info';
        scope.visible = entityObj.edit && (entityObj.edit.admin && isAdmin || !entityObj.edit.admin);
      }
      else if (scope.item && scope.item[idField]) {
        //edit
        scope.icon = 'fa-pencil';
        scope.text = $interpolate("{{'global.edit' | translate}}")(scope);
        scope.color = 'primary';
        scope.visible = entityObj.edit && (entityObj.edit.admin && isAdmin || !entityObj.edit.admin);
      }
      else {
        //add
        scope.icon = 'fa-plus';
        scope.text = $interpolate("{{'global.add' | translate}}")(scope);
        scope.color = 'primary';
        scope.visible = entityObj.edit && (entityObj.edit.admin && isAdmin || !entityObj.edit.admin) && !entityObj.noAdd;
      }

      scope.openModal = function () {
        var state, item;
        if (scope.view) {
          state = "view";
          item = angular.copy(scope.item);
        }
        else if (scope.clone) {
          state = "clone";
          if (typeof entityObj.clone === 'function') item = entityObj.clone(angular.copy(scope.item));
          else {
            item = angular.copy(scope.item);
            delete item._id;
          }
        }
        else if (scope.item && scope.item[idField]) {
          state = "edit";
          item = angular.copy(scope.item);
        }
        else {
          state = "new";
          if (typeof entityObj.blank === 'function') item = entityObj.blank($rootScope);
          else item = {};
        }

        var next = typeof scope.onOpen === 'function' ? scope.onOpen() : function (item, cb, state) { return cb(null, item); };
        next(item, function (err, item) {
          if (err) return swal("Não foi possível abrir esta janela", err, "warning");

          var lookup = /*$lookup.get() ||*/ scope.lookup;
          var data = {
            item: item,
            entity: entityObj,
            lookup: lookup,
            view: scope.view
          };

          $modal.open(scope.entity, size, data);
        });
      };
    }
  };
}]);
app.directive('entityRemove', function () {
  return {
    restrict: 'E',
    scope: {
      entity: "@",
      item: "="
    },
    transclude: true,
    templateUrl: 'directives/entity/entity.remove.html',
    controller: ["$scope", "$entity", "zapi", function ($scope, $entity, zapi) {
      var entityObj = zapi.entityMap[$scope.entity];
      if (!entityObj) return;

      $scope.remove = function (entity, item) {
        swal({
          title: "Esta ação é irreversível",
          type: "info",
          text: "Está prestes a apagar um registo, deseja continuar?",
          showCancelButton: true,
          cancelButtonText: "Cancelar",
          confirmButtonText: "OK"
        }).then(function (result) {
          if (result && result.dismiss) return;
          $entity.remove(entity, item, $scope);
        }).catch(function (err) {
          console.error(err);
        });
      };
    }]
  };
});
app.directive('entitySave', function () {
  return {
    restrict: 'E',
    scope: {
      entity: "@",
      item: "=",
      form: "=",
      afterSave: '&'
    },
    templateUrl: 'directives/entity/entity.save.html',
    controller: ["$scope", "$entity", "$rootScope", "$location", "$stateParams", "zapi", function ($scope, $entity, $rootScope, $location, $stateParams, zapi) {
      //validate
      $scope.entity = $scope.entity || $stateParams.entity;
      var entityObj = zapi.entityMap[$scope.entity];
      if (!entityObj) return;

      var isSaving = false;
      if (entityObj.preventDirtyRedirect && !entityObj.modal) $rootScope.$on("$locationChangeStart", preventDirtyRedirect);

      $scope.save = function (entity, item) {
        isSaving = true;

        $entity.add(entity, item, $scope).then(function (response) {
          if (typeof $scope.afterSave === 'function') $scope.afterSave();
        });
      };

      function preventDirtyRedirect(event, url) {
        if (isSaving) return;
        if (!$scope.form.$dirty) return;
        event.preventDefault();
        swal({
          title: "Existem alterações não guardadas, pretende sair na mesma?",
          showConfirmButton: true,
          confirmButtonText: "Sim",
          showCancelButton: true,
          cancelButtonText: "Ainda não!",
          type: "warning"
        }).then(function (result) {
          if (result && result.dismiss) return;
          $scope.form.$setPristine();
          var locationPath = url.substring(url.indexOf('#') + 1);
          $location.path(locationPath);
          $scope.$apply();
        }).catch(function (err) {
          console.error(err);
        });
      }
    }]
  };
});
app.directive('entityVersion', function () {
  return {
    restrict: 'E',
    scope: {
      entity: "@",
      item: "=",
    },
    templateUrl: 'directives/entity/entity.version.html',
    controller: ["$scope", "$http", "$modal", "zapi", "blockUI", function ($scope, $http, $modal, zapi, blockUI) {
      //validate
      $scope.entity = $scope.entity || $stateParams.entity;
      var entityObj = zapi.entityMap[$scope.entity];
      if (!entityObj) return;
      
      $scope.viewHistory = function () {
        if (!$scope.item._id) return;
      
        blockUI.start("A obter alterações...");
        $http.get('/api/application/versions/common/' + $scope.item._id, { cache: true }).then(function (response) {
          $modal.open('versionHistory', 'lg', { labelField: "name", item: $scope.item, versions: response.data });
        }).catch(function (response) {
          swal("Não foi possível obter as alterações", response.data, "warning");
        }).finally(function () {
          blockUI.stop();
        });
      };
    }]
  };
});
app.directive('entityView', function () {
  return {
    restrict: 'EA',
    scope: {
      entity: '@',
      item: '=?',
      lookup: '=?',
      form: '=',
      fetch: '@'
    },
    template: '<div ng-include src="contentUrl" include-replace></div>',
    controller: ["$scope", "zapi", "$interpolate", "$controller", "$entity", "$rootScope", "$stateParams", "$timeout", "blockUI", "apiError", function ($scope, zapi, $interpolate, $controller, $entity, $rootScope, $stateParams, $timeout, blockUI, apiError) {
      //validate
      $scope.entity = $scope.entity || $stateParams.entity;
      var entityObj = zapi.entityMap[$scope.entity];
      if (!entityObj) return;
      if (!entityObj.view) return;

      //defaults
      var idField = entityObj.id || "_id";
      var idValue = $scope.item ? $scope.item[idField] : undefined;
      $scope.item = $scope.item || {};
      if (typeof $scope.lookup === 'undefined') $scope.lookup = {};
      $scope.fetch = $scope.fetch ? true : false;
      $scope._form = $scope.form;
      $scope.contentUrl = 'entity/' + $scope.entity + '/' + $scope.entity + '.view.html';

      //main
      if ($scope.fetch) initialize(loadFinished);
      else loadFinished();

      //private functions
      function initialize(callback) {
        blockUI.start($interpolate("{{'api.entity.getData' | translate}}")($scope));
        $entity.lookupMany(entityObj.lookup, function (err, lookups) {
          if (err) {
            blockUI.stop();
            callback();
            return swal("Não foi possível obter os dados", err, 'warning');
          }

          if (typeof $scope.lookup === 'undefined') $scope.lookup = {};
          for (var key in lookups) $scope.lookup[key] = lookups[key];
          if (!idValue) return;

          $entity.get($scope.entity, idValue).then(function (response) {
            $scope.item = response.data;

            //todo
            //$scope.lookup = $lookup.set($scope.entity, response.data);
          }).catch(function (response) {
            swal("Não foi possível obter os dados necessários", response.data || apiError.timeout, 'warning');
          }).finally(function () {
            blockUI.stop();
            callback();
          });
        });
      }

      function loadFinished() {
        $timeout(function () {
          var websocket;
          if (typeof entityObj.websocket !== 'function') websocket = $scope.entity;
          else websocket = entityObj.websocket($rootScope, $stateParams) + "." + $scope.entity;
          $scope.$on('socket:' + websocket + '.remove', onThisEntityRemove);
          $scope.$on('socket:' + websocket + '.edit', onThisEntityEdit);

          //inject child controller
          try {
            if ($scope.fetch) $controller($scope.entity + 'Ctrl', { $scope: $scope });
          } catch (err) {
            console.log(err);
          }
        });
      }

      function onThisEntityEdit(ev, data) {
        //todo
        //$scope.lookup = $lookup.set($scope.entity, data);
        if (idValue != data[idField]) return;

        $scope.item = data;
      }

      function onThisEntityRemove(ev, id) {
        //todo
        //$scope.lookup = $lookup.unset($scope.entity, id);
        if (idValue != id) return;

        swal("Outro utilizador apagou este registo", "Actualize a página para ver reflitadas as alterações", "info");
      }
    }]
  };
});
app.directive('entityXlsx', ["$interpolate", function ($interpolate) {
  return {
    restrict: 'E',
    scope: {
      entity: "=",
      items: '='
    },
    transclude: true,
    templateUrl: 'directives/entity/entity.xlsx.html',
    controller: ["$scope", "ngXlsx", function ($scope, ngXlsx) {
      function s2ab(s) {
        var buf = new ArrayBuffer(s.length);
        var view = new Uint8Array(buf);
        for (var i = 0; i != s.length; ++i) view[i] = s.charCodeAt(i) & 0xFF;
        return buf;
      }

      $scope.export = function () {
        var data = $scope.entity.xlsx($scope.items);
        var result = ngXlsx.writeXlsx(data);
        var filename = $interpolate("{{ '" + $scope.entity.title + "' | translate }}")($scope) + ".xlsx";
        saveAs(new Blob([s2ab(result)], { type: "application/octet-stream" }), filename);
      };
    }]
  };
}]);
app.directive('apiNewsletter', function () {
  return {
    restrict: 'A',
    scope: false,
    templateUrl: 'directives/newsletter/newsletter.html',
    controller: ["$scope", "$newsletter", function ($scope, $newsletter) {
      $scope.saveEmail = function (item) {
        $newsletter.subscribe(item, function () {
          $scope.newsItem = {};
        });
      };

    }]
  };
});
app.directive('entityNotification', function () {
  return {
    restrict: 'A',
    scope: {
      entity: "@",
    },
    transclude: true,
    replace: true,
    templateUrl: "directives/notification/entity.html",
    controller: ["$scope", "$modal", "$http", "blockUI", "zapi", function ($scope, $modal, $http, blockUI, zapi) {
      var config = zapi.entityMap[$scope.entity] && zapi.entityMap[$scope.entity].notification;
      $scope.visible = !!config;
      var url = '/api/notification/' + $scope.entity + '/entity';

      $scope.openNotificationModal = function () {
        blockUI.start("A obter configurações de notificação...");
        $http.get(url).then(function (response) {
          var data = { notifications: response.data, entity: $scope.entity, type: 'entityEvent' };
          $modal.open('entityNotification', 'md', data, function (result) {
            //
          }, function (result) {
            //
          });
        }).catch(function (response) {
          swal("Não foi possível obter as suas configurações para esta notificação", response.data, "warning");
        }).finally(function () {
          blockUI.stop();
        });
      };
    }]
  };
});
app.directive('recordNotification', function () {
  return {
    restrict: 'A',
    scope: {
      entity: "@",
      item: '='
    },
    transclude: true,
    replace: true,
    templateUrl: "directives/notification/record.html",
    controller: ["$scope", "$modal", "$http", "blockUI", "zapi", function ($scope, $modal, $http, blockUI, zapi) {
      var config = zapi.entityMap[$scope.entity] && zapi.entityMap[$scope.entity].notification;
      $scope.visible = !!config;
      var url = '/api/notification/' + $scope.entity + '/record/' + $scope.item[config.fields.docId];

      $scope.openNotificationModal = function () {
        blockUI.start("A obter configurações de notificação...");
        $http.get(url).then(function (response) {
          var data = { notifications: response.data, record: $scope.item, entity: $scope.entity, type: 'recordEvent' };
          $modal.open('recordNotification', 'md', data, function (result) {
            //
          }, function (result) {
            //
          });
        }).catch(function (response) {
          swal("Não foi possível obter as suas configurações para esta notificação", response.data, "warning");
        }).finally(function () {
          blockUI.stop();
        });
      };
    }]
  };
});
app.directive('dynamicReport', function () {
  return {
    restrict: 'A',
    scope: {
      reportKey: '@',
      namespace: '@',
      db: '@'
    },
    replace: false,
    templateUrl: 'directives/report/report.html',
    controller: ["$scope", "$entity", "$util", "$report", "$httpParamSerializer", "$location", "NgTableParams", "moment", "blockUI", "apiError", function ($scope, $entity, $util, $report, $httpParamSerializer, $location, NgTableParams, moment, blockUI, apiError) {
      $scope.savedItems = [];
      $scope.fields = [];
      $scope.fieldTabs = [];
      $scope.activeTab = 0;
      $scope.lookup = { aggregator: [{ label: "E", value: "$and" }, { label: "OU", value: "$or" }] };

      reset();
      initialize();

      $scope.reset = reset;

      $scope.appendQuery = function () {
        $scope.item.query.push({});
      };

      $scope.removeQuery = function (index) {
        $scope.item.query.splice(index, 1);
      };

      $scope.getReport = function (item) {
        var map = {};
        $scope.cols = [];
        item.select.forEach(function (fieldId) {
          var field = $scope.fields.find(function (field) {
            return field.id == fieldId;
          });
          var key = typeof field.name === 'undefined' ? field.invoke : field.name;

          if (["Date", "Boolean"].indexOf(field.type) !== -1) map[key] = field.type;
          $scope.cols.push({
            field: key,
            title: field.caption,
            sortable: "'" + key + "'",
            show: true
          });
        });

        $report.getReport($scope.namespace, $scope.db, $scope.reportKey, item, function (err, data) {
          if (err) return swal("Não foi possível obter os dados necessários", err || apiError.timeout, "error");

          var items = $util.flattenArray(data, true);
          items.forEach(function (item) {
            for (var key in item) {
              if (map[key] === "Date") item[key] = item[key] ? moment(item[key]).format('YYYY-MM-DD') : '';
              else if (map[key] === "Boolean") item[key] = item[key] ? "Sim" : "Não";
            }
          });
          $scope.items = items;
          $scope.tableParams = new NgTableParams({}, { dataset: items });
        });
      };

      $scope.loadReport = function (item, index) {
        $scope.item = item;
        $scope.activeTab = index;
      };

      $scope.saveReport = function (item) {
        item.key = $scope.reportKey;

        blockUI.start("A guardar listagem...");
        $entity.add('report', item, $scope).then(function (response) {
          swal("Guardado", "A listagem foi guardada com sucesso. Poderá reutiliza-la no futuro a partir do separador 'Minhas listagens'", "success");
          //todo $route.reload();
        }).catch(function (response) {
          swal("Não foi possível guardar a sua listagem", response.data || apiError.timeout, "warning");
        }).finally(function () {
          blockUI.stop();
        });
      };

      $scope.removeReport = function (item) {
        blockUI.start("A apagar listagem...");
        $entity.remove('report', item, $scope).then(function (response) {
          swal("Apagado", "A listagem foi apagada com sucesso", "success");
          //todo $route.reload();
        }).catch(function (response) {
          swal("Não foi possível apagar a sua listagem", response.data || apiError.timeout, "warning");
        }).finally(function () {
          blockUI.stop();
        });
      };

      $scope.getExcelUrl = function (item) {
        return '/api/report/get/' + $scope.namespace + '/' + $scope.db + '/' + $scope.reportKey + '?xls=1&' + $httpParamSerializer(item);
      };

      $scope.getPdfUrl = function (item) {
        return '/api/report/get/' + $scope.namespace + '/' + $scope.db + '/' + $scope.reportKey + '?pdf=1&' + $httpParamSerializer(item);
      };

      $scope.applySearch = function (search) {
        var criteria = angular.copy(search.text);
        if (search.inverted) {
          criteria = "!" + criteria;
        }
        $scope.tableParams.filter({ $: criteria });
      };

      function reset() {
        $scope.tableParams = null;
        $scope.cols = [];

        $scope.item = {
          select: [],
          query: [],
          sort: {}
        };

        $scope.activeTab = 1;
      }

      function initialize() {
        $report.getMetadata($scope.reportKey, function (err, metadata) {
          if (err) return swal("Atenção", err, "error");

          $scope.fieldTabs = [];
          metadata.fields.forEach(function (field) {
            field.tab = field.tab || "Outros campos";
            var index = $scope.fieldTabs.findIndex(function (fieldTab) {
              return fieldTab.name === field.tab;
            });
            if (index !== -1) return;
            $scope.fieldTabs.push({
              name: field.tab,
              isOpen: false
            });
          });
          $scope.fields = metadata.fields;
        });

        blockUI.start("A obter listagens guardadas...");
        $location.search({
          db: $scope.db,
          reportKey: $scope.reportKey
        });
        $entity.get('report').then(function (response) {
          $scope.savedItems = response.data;
        }).catch(function (response) {
          swal("Não foi possível obter os dados necessários", response.data || apiError.timeout, "error");
        }).finally(function () {
          blockUI.stop();
        });
      }
    }]
  };
});
app.directive('editRole', function () {
  return {
    restrict: 'A',
    scope: {
      item: '=',
      lookup: '=',
      form: '='
    },
    templateUrl: 'directives/role/role.edit.html',
    controller: ["$scope", "$auth", "$role", function ($scope, $auth, $role) {
      //get role permissions
      $role.getPermissions().then(function (response) {
        $scope.permissions = response.data;

        //if new user set permissions object
        $scope.item = $scope.item || {};
        if (Object.keys($scope.item.permissions).length > 0) return;
        var permissions = {};
        for (var entity in $scope.permissions) {
          permissions[entity] = {};
          for (var action in $scope.permissions[entity]) {
            if (action === 'label') continue;
            permissions[entity][action] = true;
          }
        }
        $scope.item.permissions = permissions;
      });

      $scope.togglePermissions = function (value) {
        if (!$scope.item.permissions) $scope.item.permissions = {};

        for (var entity in $scope.permissions) {
          if (!$scope.item.permissions[entity]) $scope.item.permissions[entity] = {};

          for (var action in $scope.permissions[entity]) {
            if (action === 'label') continue;

            $scope.item.permissions[entity][action] = value;
          }
        }
      };
    }]
  };
});
app.controller('editUserCtrl', ["$scope", "$auth", "lookup", function ($scope, $auth, lookup) {
  $scope.ready = false;
  $scope.item = $scope.item || {};
  $scope.lookup = $scope.lookup || {};
  $scope._form = $scope.form;
  $scope.isAdmin = $auth.isAdmin;

  for (var key in lookup) $scope.lookup[key] = lookup[key];
  $scope.ready = true;
}]);
app.directive('editUser', function () {
  return {
    restrict: 'A',
    scope: {
      item: '=',
      lookup: '=',
      form: '='
    },
    templateUrl: 'directives/user/user.edit.html',
    controller: 'editUserCtrl'
  };
});
app.controller('activityCtrl', function() {});
app.controller('alertCtrl', ["$scope", "$http", "blockUI", function ($scope, $http, blockUI) {
  $scope.formatEmails = function (emailArray) {
    return (emailArray || []).map(function (set) {
      return set.email;
    }).join();
  };

  $scope.testSend = function (item) {
    swal({
      title: "Email de teste endereçado a...",
      input: 'email',
      inputPlaceholder: 'email@exemplo.pt',
      showConfirmButton: true,
      confirmButtonText: "Enviar",
      showCancelButton: true,
      cancelButtonText: "Cancelar",
      type: "info"
    }).then(function (result) {
      if (result && result.dismiss) return;

      blockUI.start("A enviar email...");
      $http.post('/api/message/test', { template: item.template, email: result.value }).then(function (response) {
        swal("Email de teste", "Enviado", "success");
      }).catch(function (response) {
        swal("Não foi possível enviar teste", response.data, "warning");
      }).finally(function () {
        blockUI.stop();
      });
    }).catch(function (err) {
      console.error(err);
    });
  };
}]);
app.controller('errorCtrl', ["$scope", "$modal", function($scope, $modal) {
  $scope.openModal = $modal.open;
}]);
app.controller('holidayCtrl', ["$scope", "$holiday", "$timeout", "lookup", function ($scope, $holiday, $timeout, lookup) {
  $scope.lookup = $scope.lookup || {};
  $scope.lookup.country = lookup.country;

  $timeout(function () {
    ($scope.items || []).forEach(function (item) {
      item.next = $holiday.calculateNextOccurrence(item);
    });
  });
}]);
app.controller('licenseCtrl', ["$scope", "$owner", "$rootScope", "$timeout", function ($scope, $owner, $rootScope, $timeout) {
  $scope.lookup.owner = [];

  $timeout(getOwners);

  function getOwners() {
    if (!$rootScope.login.role.admin) {
      $scope.lookup.owner = [$rootScope.login];
      return;
    }

    $owner.getOwners(function (owners) {
      $scope.lookup.owner = owners;
    });
  }
}]);
app.controller('maintenanceCtrl', function() {
});
app.controller('messageCtrl', ["$scope", "$modal", function($scope, $modal) {
  $scope.openModal = $modal.open;
}]);
app.controller('moduleCtrl', ["$scope", function ($scope) {
  $scope.appendPrice = function (item) {
    if (!(item.price instanceof Array)) item.price = [];
    item.price.push({ index: item.price.length, value: 0 });
  };

  $scope.removePrice = function (item) {
    var l = item.price.length;
    if (l === 0) return;
    item.price.splice(l - 1, 1);
  };
}]);
app.controller('roleCtrl', function () {});
app.controller('runCtrl', function () {
});
//manage tasks Controller
app.controller('taskCtrl', ["$scope", "$rootScope", "$date", "$task", "$timeout", "mySocket", "blockUI", "apiError", function ($scope, $rootScope, $date, $task, $timeout, mySocket, blockUI, apiError) {
  $scope.taskTypes = [];

  $scope.formatDatetime = $date.formatDatetime;

  $scope.calculateTimespan = $date.calculateTimespan;

  $scope.toggleState = $task.toggleState;

  $scope.run = function (task) {
    $task.run(task).then(function (response) {
      blockUI.start('A executar...');
    }).catch(function (response) {
      swal('Ocorreu um erro ao iniciar a tarefa manualmente.', response.data || apiError.timeout, 'error');
    });
  };

  $timeout(initialize);

  function initialize() {
    mySocket.on($rootScope.login._id, function (data) {
      swal('Tarefa executada com sucesso.', null, 'success');
      blockUI.stop();
    });

    $task.getTypes(function (types) {
      $scope.taskTypes = types;
    });
  }
}]);
app.controller('userCtrl', ["$scope", "$rootScope", "$modal", function ($scope, $rootScope, $modal) {
  $scope.login = $rootScope.login;

  $scope.openModal = $modal.open;
}]);
app.controller('changePasswordCtrl', ["$scope", "$uibModalInstance", function ($scope, $uibModalInstance) {
  $scope.cancel = $uibModalInstance.dismiss;
}]);

app.controller('entityNotificationCtrl', ["$scope", "$uibModalInstance", "$http", "zapi", "toastr", "data", function ($scope, $uibModalInstance, $http, zapi, toastr, data) {
  var config = zapi.entityMap[data.entity] && zapi.entityMap[data.entity].notification;
  if (!config) return $uibModalInstance.dismiss();
  $scope.config = config;

  $scope.cancel = $uibModalInstance.dismiss;
  $scope.ok = $uibModalInstance.close;

  $scope.entity = data.entity;
  $scope.record = data.record;

  $scope.notification = {
    entityEvent: data.notifications.find(function (n) {
      return n.type === 'entityEvent' && n.entity === data.entity;
    }) || {
        type: 'entityEvent',
        entity: data.entity,
      },

    entityDate: config.fields.dates.map(function (date) {
      var entityDate = data.notifications.find(function (n) {
        return n.type === 'entityDate' && n.entity === data.entity && n.field === date.field;
      });
      if (entityDate) entityDate.active = true;
      else entityDate = {
        type: 'entityDate',
        entity: data.entity,
        active: false,

        field: date.field,
        fieldLabel: date.label,
        daysNotice: -10,
      };
      return entityDate;
    }),
  };

  $scope.setNotification = function (notification) {
    var url = '/api/notification/set';
    if (notification.type === 'entityDate' && !notification.active) url = '/api/notification/unset';

    $http.post(url, notification).then(function (response) {
      var method;
      var message;
      switch (notification.type) {
        case "entityEvent":
          if (!notification.eventAdd && !notification.eventEdit && !notification.eventRemove) {
            method = 'error';
            message = "Subscrição anulada";
          }
          else {
            method = 'success';
            message = 'Subscrição por evento registada';
          }
          break;

        case "entityDate":
          if (notification.active) {
            method = 'success';
            message = 'Subscrição por data registada';
          }
          else {
            method = 'error';
            message = 'Subscrição anulada';
          }
          break;

        default:
          console.error('unknown notification type', notification.type);
      }

      toastr[method]('Notificação', message);
    }).catch(function (response) {
      swal("Não foi possível guardar a subscrição", response.data, "warning");
    });
  };
}]);
app.controller('predefinedListParametersCtrl', ["$scope", "$uibModalInstance", "data", function ($scope, $uibModalInstance, data) {
  $scope.list = data;

  $scope.cancel = $uibModalInstance.dismiss;
  $scope.submit = function () {
    $uibModalInstance.close($scope.list);
  };
}]);
app.controller('recordNotificationCtrl', ["$scope", "$uibModalInstance", "$http", "zapi", "toastr", "data", function ($scope, $uibModalInstance, $http, zapi, toastr, data) {
  var config = zapi.entityMap[data.entity] && zapi.entityMap[data.entity].notification;
  if (!config) return $uibModalInstance.dismiss();
  $scope.config = config;

  $scope.cancel = $uibModalInstance.dismiss;
  $scope.ok = $uibModalInstance.close;

  $scope.entity = data.entity;
  $scope.record = data.record;

  $scope.notification = {
    recordEvent: data.notifications.find(function (n) {
      return n.type === 'recordEvent' && n.entity === data.entity && n.docId === data.record[config.fields.docId];
    }) || {
        type: 'recordEvent',
        entity: data.entity,

        label: data.record[config.fields.label],
        docId: data.record[config.fields.docId],
      },

    recordDate: config.fields.dates.map(function (date) {
      var recordDate = data.notifications.find(function (n) {
        return n.type === 'recordDate' && n.entity === data.entity && n.docId === data.record[config.fields.docId] && n.field === date.field;
      });
      if (recordDate) recordDate.active = true;
      else recordDate = {
        type: 'recordDate',
        entity: data.entity,
        active: false,

        label: data.record[config.fields.label],
        docId: data.record[config.fields.docId],

        fieldLabel: date.label,
        field: date.field,
        daysNotice: -10,
      };
      return recordDate;
    }),
  };

  $scope.setNotification = function (notification) {
    var url = '/api/notification/set';
    if (notification.type === 'recordDate' && !notification.active) url = '/api/notification/unset';

    $http.post(url, notification).then(function (response) {
      var method;
      var message;
      switch (notification.type) {
        case "recordEvent":
          if (!notification.eventAdd && !notification.eventEdit && !notification.eventRemove) {
            method = 'error';
            message = "Subscrição anulada";
          }
          else {
            method = 'success';
            message = 'Subscrição por evento registada';
          }
          break;

        case "recordDate":
          if (notification.active) {
            method = 'success';
            message = 'Subscrição por data registada';
          }
          else {
            method = 'error';
            message = 'Subscrição anulada';
          }
          break;

        default:
          console.error('unknown notification type', notification.type);
      }

      toastr[method]('Notificação', message);
    }).catch(function (response) {
      swal("Não foi possível guardar a subscrição", response.data, "warning");
    });
  };
}]);
app.controller('resetCtrl', ["$scope", "$uibModalInstance", function($scope, $uibModalInstance) {
  $scope.cancel = $uibModalInstance.dismiss;
  $scope.ok = $uibModalInstance.close;
}]);
app.controller('resetFactoryDefaultsCtrl', ["$scope", "$uibModalInstance", "mySocket", "data", function ($scope, $uibModalInstance, mySocket, data) {
  $scope.cancel = $uibModalInstance.dismiss;

  $scope.progress = 0;
  $scope.text = "A conectar ao servidor...";
  var token = data;
  mySocket.on(token, function (data) {
    switch (data.type) {
      case "progress":
        $scope.progress = data.content;
        $scope.text = "Em progresso...";
        break;
      case "error":
        $scope.text = "Erro";
        swal("Não foi possível finalizar a reposição", data.content, "error");
        $uibModalInstance.close();
        break;
      case "end":
        $scope.text = "Concluído";
        $scope.progress = 100;
        swal("Já está", "As configurações foram repostas", "success");
        $uibModalInstance.close();
        break;
      default:
        console.log('unexpected packet', data);
    }
  });
}]);

app.controller('stackTraceCtrl', ["$scope", "$uibModalInstance", "data", function($scope, $uibModalInstance, data) {
  $scope.item = data;

  $scope.cancel = $uibModalInstance.dismiss;
  $scope.ok = $uibModalInstance.close;
}]);
app.controller('unlicensedCtrl', ["$scope", "$uibModalInstance", "data", function ($scope, $uibModalInstance, data) {
    $scope.data = data;

    $scope.cancel = $uibModalInstance.dismiss;
    $scope.ok = $uibModalInstance.close;
}]);
app.controller('versionHistoryCtrl', ["$scope", "$uibModalInstance", "data", function ($scope, $uibModalInstance, data) {
  $scope.cancel = $uibModalInstance.dismiss;

  $scope.data = data;
}]);
app.controller('viewMsgCtrl', ["$scope", "$uibModalInstance", "data", function($scope, $uibModalInstance, data) {
  $scope.item = data;

  $scope.cancel = $uibModalInstance.dismiss;
  $scope.ok = $uibModalInstance.close;
}]);
app.directive('console', function() {
    return {
        restrict: 'E',
        scope: true,
        replace: false,
        templateUrl: 'directives/_to_remove/console/console.html'
    };
});
app.directive('authActivation', function () {
  return {
    restrict: 'A',
    scope: {
      onComplete: '&?',
    },
    templateUrl: 'directives/auth/activation/activation.html',
    controller: ["$scope", "$auth", "$location", "$stateParams", "$interpolate", "blockUI", "zapi", "apiError", function ($scope, $auth, $location, $stateParams, $interpolate, blockUI, zapi, apiError) {
      $scope.user = null;

      $scope.changePassword = function (item) {
        if (!item.password) {
          return swal(
            $interpolate("{{'api.services.auth.changepasswordWrongPasswordTitle' | translate}}")($scope),
            $interpolate("{{'api.services.auth.changepasswordWrongPasswordContent' | translate}}")($scope),
            "error"
          );
        }
        if (item.password !== item.repeat) {
          return swal(
            $interpolate("{{'api.services.auth.changepasswordWrongPasswordTitle' | translate}}")($scope),
            $interpolate("{{'api.services.auth.changepasswordWrongPasswordContent' | translate}}")($scope),
            "error"
          );
        }

        blockUI.start($interpolate("{{'api.services.auth.changepasswordLoad' | translate}}")($scope));
        $auth.changePassword($scope.user, item.password, item.repeat).then(function (response) {
          if ($scope.onComplete && typeof $scope.onComplete() === 'function') return $scope.onComplete()(response.data);

          swal(
            $interpolate("{{'api.services.auth.changepasswordSuccessTitle' | translate}}")($scope),
            $interpolate("{{'api.services.auth.changepasswordSuccessContent' | translate}}")($scope),
            "info"
          );
          $location.path('/');
        }).catch(function (response) {
          swal($interpolate("{{'api.services.auth.changepasswordErrorTitle' | translate}}")($scope), response.data || apiError.timeout, "error");
        }).finally(function (response) {
          blockUI.stop();
        });
      };

      initialize();

      function initialize() {
        if (!$stateParams.code) return swal("Código de ativação inválido", "Certifique-se que seguiu o endereço exactamente como enviado no email", "warning");
        var codes = $stateParams.code.split('&');
        if (codes.length !== 2) return swal("Código de ativação inválido", "Certifique-se que seguiu o endereço exactamente como enviado no email", "warning");

        blockUI.start($interpolate("{{'api.services.auth.activateAccountLoad' | translate}}")($scope));
        $auth.activateAccount(codes).then(function (response) {
          $scope.user = response.data;
        }).catch(function (response) {
          swal("Atenção", response.data || apiError.timeout, "warning");
        }).finally(function () {
          blockUI.stop();
        });
      }
    }]
  };
});
app.directive('sessionIdle', function() {
  return {
    restrict: 'A',
    scope: true,
    controller: ["$scope", "$auth", function($scope, $auth) {
      $scope.$on('IdleStart', function() {
        swal("Atenção", "Devido à sua inactividade irá ser disconectado em 5 segundos", "info");
      });

      $scope.$on('IdleTimeout', function() {
        $auth.logout();
      });
    }]
  };
});
app.directive('authChangePassword', function () {
  return {
    restrict: 'A',
    scope: false,
    templateUrl: 'directives/auth/changePassword/changePassword.html',
    controller: ["$scope", "$auth", "$rootScope", "blockUI", "apiError", function ($scope, $auth, $rootScope, blockUI, apiError) {
      $scope.changePassword = function (item) {
        blockUI.start("A verificar elegibilidade...");
        $auth.changePassword($rootScope.login, item.password, item.repeat).then(function (response) {
          $auth.logout(function () {
            //user redirected to anonymous page "/#/"
          });
        }).catch(function (response) {
          swal("Não foi possível alterar a sua password", response.data  || apiError.timeout, "warning");
        }).finally(function () {
          blockUI.stop();
        });
      };
    }]
  };
});
app.directive('ngClick', ["$license", "$interval", "$rootScope", function ($license, $interval, $rootScope) {
  function bindClick(element, moduleId) {
    element.bind('click', function (e) {
      e.preventDefault();
      $license.notify(moduleId);
    });
  }

  return {
    restrict: 'A',
    replace: false,
    link: function (scope, element, attributes) {
      if (typeof attributes.license === 'undefined') return;

      var intervalId = $interval(initialize, 100);

      function initialize() {
        if (!$rootScope.login) return;
        if (!$rootScope.login.role) return;

        $interval.cancel(intervalId);
        var isAllowed = $license.isLicensed(attributes.license, $rootScope.login);
        if (!isAllowed) return bindClick(element, attributes.license);
      }
    }
  };
}]);
app.controller('authLoginCtrl', ["blockUI", "$auth", "$location", "$scope", "$uibModalStack", "$interpolate", "apiError", function (blockUI, $auth, $location, $scope, $uibModalStack, $interpolate, apiError) {
  $scope.login = function () {
    if (!$scope.item.username) return;
    if (!$scope.item.password) return;

    blockUI.start($interpolate("{{'api.services.auth.loginLoad' | translate}}")($scope));
    $auth.login($scope.item.username, $scope.item.password).then(function (response) {
      $location.path('/profile');
      $uibModalStack.dismissAll();
    }).catch(function (response) {
      swal($interpolate("{{'api.services.auth.loginErrorTitle' | translate}}")($scope), response.data || apiError.timeout, "error");
      reset();
    }).finally(function () {
      blockUI.stop();
    });
  };

  function reset() {
    $scope.item.username = "";
    $scope.item.password = "";
  }
}]);
app.directive('authLogin', function () {
  return {
    restrict: 'A',
    scope: true,
    transclude: true,
    templateUrl: 'directives/auth/login/login.html',
    controller: 'authLoginCtrl'
  };
});
app.directive('passwordMeter', ["$interpolate", function ($interpolate) {
  return {
    templateUrl: 'directives/auth/passwordMeter/passwordMeter.html',
    restrict: 'EA',
    scope: {
      password: '='
    },
    link: function (scope) {
      var measureStrength = function (p) {
        var stringReverse = function (str) {
          for (var i = str.length - 1, out = ''; i >= 0; out += str[i--]) { }
          return out;
        };

        var matches = { pos: {}, neg: {} };
        var counts = { pos: {}, neg: { seqLetter: 0, seqNumber: 0, seqSymbol: 0 } };
        var tmp, back, forth, i;
        var strength = 0;
        var letters = 'abcdefghijklmnopqrstuvwxyz';
        var numbers = '01234567890';
        var symbols = '\\!@#$%&/()=?¿';

        if (p) {
          // Benefits
          matches.pos.lower = p.match(/[a-z]/g);
          matches.pos.upper = p.match(/[A-Z]/g);
          matches.pos.numbers = p.match(/\d/g);
          matches.pos.symbols = p.match(/[$\-\/:-?{-~!^_`\[\]]/g);
          matches.pos.middleNumber = p.slice(1, -1).match(/\d/g);
          matches.pos.middleSymbol = p.slice(1, -1).match(/[$\-\/:-?{-~!^_`\[\]]/g);

          counts.pos.lower = matches.pos.lower ? matches.pos.lower.length : 0;
          counts.pos.upper = matches.pos.upper ? matches.pos.upper.length : 0;
          counts.pos.numbers = matches.pos.numbers ? matches.pos.numbers.length : 0;
          counts.pos.symbols = matches.pos.symbols ? matches.pos.symbols.length : 0;

          tmp = Object.keys(counts.pos).reduce(
            function (previous, key) {
              return previous + Math.min(1, counts.pos[key]);
            },
            0);

          counts.pos.numChars = p.length;
          tmp += (counts.pos.numChars >= 8) ? 1 : 0;

          counts.pos.requirements = (tmp >= 3) ? tmp : 0;
          counts.pos.middleNumber = matches.pos.middleNumber ? matches.pos.middleNumber.length : 0;
          counts.pos.middleSymbol = matches.pos.middleSymbol ? matches.pos.middleSymbol.length : 0;

          // Deductions
          matches.neg.consecLower = p.match(/(?=([a-z]{2}))/g);
          matches.neg.consecUpper = p.match(/(?=([A-Z]{2}))/g);
          matches.neg.consecNumbers = p.match(/(?=(\d{2}))/g);
          matches.neg.onlyNumbers = p.match(/^[0-9]*$/g);
          matches.neg.onlyLetters = p.match(/^([a-z]|[A-Z])*$/g);

          counts.neg.consecLower = matches.neg.consecLower ? matches.neg.consecLower.length : 0;
          counts.neg.consecUpper = matches.neg.consecUpper ? matches.neg.consecUpper.length : 0;
          counts.neg.consecNumbers = matches.neg.consecNumbers ? matches.neg.consecNumbers.length : 0;

          // sequential letters (back and forth)
          for (i = 0; i < letters.length - 2; i++) {
            var p2 = p.toLowerCase();
            forth = letters.substring(i, parseInt(i + 3));
            back = stringReverse(forth);
            if (p2.indexOf(forth) !== -1 || p2.indexOf(back) !== -1) {
              counts.neg.seqLetter++;
            }
          }

          // sequential numbers (back and forth)
          for (i = 0; i < numbers.length - 2; i++) {
            forth = numbers.substring(i, parseInt(i + 3));
            back = stringReverse(forth);
            if (p.indexOf(forth) !== -1 || p.toLowerCase().indexOf(back) !== -1) {
              counts.neg.seqNumber++;
            }
          }

          // sequential symbols (back and forth)
          for (i = 0; i < symbols.length - 2; i++) {
            forth = symbols.substring(i, parseInt(i + 3));
            back = stringReverse(forth);
            if (p.indexOf(forth) !== -1 || p.toLowerCase().indexOf(back) !== -1) {
              counts.neg.seqSymbol++;
            }
          }

          // repeated chars
          var repeats = {};
          var _p = p.toLowerCase();
          var arr = _p.split('');
          counts.neg.repeated = 0;
          for (i = 0; i < arr.length; i++) {
            var cnt = 0, idx = 0;
            while (1) {
              idx = _p.indexOf(arr[i], idx);
              if (idx == -1) break;
              idx++;
              cnt++;
            }
            if (cnt > 1 && !repeats[_p[i]]) {
              repeats[_p[i]] = cnt;
              counts.neg.repeated += cnt;
            }
          }

          // Calculations
          strength += counts.pos.numChars * 4;
          if (counts.pos.upper) {
            strength += (counts.pos.numChars - counts.pos.upper) * 2;
          }
          if (counts.pos.lower) {
            strength += (counts.pos.numChars - counts.pos.lower) * 2;
          }
          if (counts.pos.upper || counts.pos.lower) {
            strength += counts.pos.numbers * 4;
          }
          strength += counts.pos.symbols * 6;
          strength += (counts.pos.middleSymbol + counts.pos.middleNumber) * 2;
          strength += counts.pos.requirements * 2;

          strength -= counts.neg.consecLower * 2;
          strength -= counts.neg.consecUpper * 2;
          strength -= counts.neg.consecNumbers * 2;
          strength -= counts.neg.seqNumber * 3;
          strength -= counts.neg.seqLetter * 3;
          strength -= counts.neg.seqSymbol * 3;

          if (matches.neg.onlyNumbers) {
            strength -= counts.pos.numChars;
          }
          if (matches.neg.onlyLetters) {
            strength -= counts.pos.numChars;
          }
          if (counts.neg.repeated) {
            strength -= (counts.neg.repeated / counts.pos.numChars) * 10;
          }
        }
        return Math.max(0, Math.min(100, Math.round(strength)));
      };

      scope.colClass = '';
      scope.masterClass = '';

      scope.$watch('password', function () {
        scope.first = '';
        scope.second = '';
        scope.third = '';
        scope.fourth = '';
        scope.message = '';

        if (!scope.password) {
          scope.masterClass = 'hidden';
          return;
        }
        scope.strength = measureStrength(scope.password);
        scope.masterClass = '';

        if (scope.strength < 25) {
          scope.first = 'poor';
          scope.message = $interpolate("{{ 'api.passwordMeter.poor' | translate}}")(scope);
        } else if (scope.strength < 50) {
          scope.first = 'weak';
          scope.second = 'weak';
          scope.message = $interpolate("{{ 'api.passwordMeter.weak' | translate}}")(scope);
        } else if (scope.strength < 75) {
          scope.first = 'good';
          scope.second = 'good';
          scope.third = 'good';
          scope.message = $interpolate("{{ 'api.passwordMeter.good' | translate}}")(scope);
        } else if (scope.strength <= 100) {
          scope.first = 'strong';
          scope.second = 'strong';
          scope.third = 'strong';
          scope.fourth = 'strong';
          scope.message = $interpolate("{{ 'api.passwordMeter.strong' | translate}}")(scope);
        }
      });
    }
  };
}]);
app.controller('authResetCtrl', ["$scope", "$auth", "$location", "$interpolate", "blockUI", "apiError", function ($scope, $auth, $location, $interpolate, blockUI, apiError) {
  $scope.reset = function (item) {
    if ($scope.validateReset(item)) return;

    blockUI.start($interpolate("{{'api.services.auth.resetPasswordLoad' | translate}}")($scope));
    $auth.resetPassword(item.email, item.username).then(function (response) {
      swal(
        $interpolate("{{'api.services.auth.resetPasswordSuccessTitle' | translate}}")($scope),
        $interpolate("{{'api.services.auth.resetPasswordSuccessContent' | translate}}")($scope),
        "success"
      );
      $location.path("/");
    }).catch(function (response) {
      swal($interpolate("{{'api.services.auth.resetPasswordErrorTitle' | translate}}")($scope), response.data || apiError.timeout, "error");
    }).finally(function () {
      blockUI.stop();
    });
  };

  $scope.validateReset = function (item) {
    if (!item) return true;
    if (!item.email) return true;
    if (!item.username) return true;
    return false;
  };
}]);
app.directive('authReset', function () {
  return {
    restrict: 'A',
    transclude: true,
    scope: {
      item: '=?',
    },
    templateUrl: 'directives/auth/reset/reset.html',
    controller: 'authResetCtrl'
  };
});
app.controller('authSignupCtrl', ["$scope", "$entity", "$uibModalStack", "blockUI", "apiError", function ($scope, $entity, $uibModalStack, blockUI, apiError) {
  $scope.signup = function (item) {
    if ($scope.validateSignup(item)) return;

    blockUI.start("A reservar conta...");
    $entity.add('user', item, $scope).then(function (response) {
      swal("Está quase!", "Consulte o seu email para ativar a conta de utilizador", "success");
      if ($scope.onComplete && typeof $scope.onComplete() === 'function') return $scope.onComplete()();

      $uibModalStack.dismissAll();
    }).catch(function (response) {
      swal("Não foi possível concluir a criação de conta", response.data || apiError.timeout, "error");
    }).finally(function () {
      blockUI.stop();
    });
  };

  $scope.validateSignup = function (item) {
    if (!item) return true;
    if (!item.username) return true;

    var validUsername = new RegExp('^[a-zA-Z0-9.\-_$@*!]{3,30}$');
    if (!validUsername.test(item.username)) return true;
    if (!item.email) return true;

    return false;
  };
}]);
app.directive('authSignup', function () {
  return {
    restrict: 'A',
    scope: {
      item: '=',
      onComplete: '&'
    },
    transclude: true,
    templateUrl: 'directives/auth/signup/signup.html',
    controller: 'authSignupCtrl'
  };
});
app.directive('sessionMaintenance', function () {
  return {
    restrict: 'A',
    scope: true,
    controller: ["mySocket", function (mySocket) {
      mySocket.on('maintenance', function (data) {
        swal("Manutenção Programada", data, "info");
      });
    }]
  };
});
app.directive('checkImage', ["$http", function ($http) {
  return {
    restrict: 'A',
    link: function (scope, element, attrs) {
      attrs.$observe('ngSrc', function (ngSrc) {
        if (!ngSrc) {
          element.attr('src', attrs.imgDefault); // set default image
        } else {
          $http.get(ngSrc).then(function () {
            //alert('image exist');
          }).catch(function () {
            //alert('image not exist');
            element.attr('src', attrs.imgDefault); // set default image
          });
        }
      });
    }
  };
}]);
app.directive('uploadImage', ["$util", "$http", "apiError", function ($util, $http, apiError) {
  var defaultHeaders = { transformRequest: angular.identity, headers: { 'Content-Type': undefined } };

  function upload(key, item, callback) {
    var fd = new FormData();
    $util.setFormFiles(fd, item);
    fd.append('item', angular.toJson(item));

    $http.post('/api/image/upload/' + key, fd, defaultHeaders).then(function (response) {
      callback(null, response.data);
    }).catch(function (response) {
      callback(response.data || apiError.timeout);
    });
  }

  return {
    restrict: 'EA',
    scope: {
      item: '=',
      key: '@',
      isEditable: '=',
      label: '@?'
    },
    templateUrl: 'directives/document/image/upload.html',
    controller: ["$scope", function ($scope) {
      $scope.label = $scope.label || "Imagem";
      
      $scope.upload = function (key, item, callback) {
        upload(key, item, function (err, url) {
          if (err) return swal("Envio falhou", err, "warning");

          $scope.item[key] = url;
        });
      };
    }]
  };
}]);
app.directive('queryBuilder', function () {
  return {
    restrict: 'A',
    scope: {
      field: '=',
      model: '=',
      key: '@'
    },
    replace: false,
    template: '<div ng-include src="contentUrl" include-replace></div>',
    controller: ["$scope", function ($scope) {
      $scope.$watch('field.type', onFieldChange);

      function onFieldChange(newField) {
        if (!newField) return;
        var type = $scope.field.type || 'Unknown';
        if ($scope.field.type === 'ObjectId' && typeof $scope.field.ref === 'undefined') {
          type = "String";
        }
        $scope.contentUrl = "directives/report/queryBuilder/" + type + ".html";
      }
    }]
  };
});
app.directive('hideElement', ["$window", function($window) {
  return {
    restrict: 'A',
    scope: {
      exclude: '@'
    },
    link: function(scope, element, attrs) {
      function isVisible(ele) {
        if (angular.element(ele).hasClass('ng-hide')) return true;
        var rect = ele.getBoundingClientRect();
        var top = rect.top;
        var height = rect.height;
        return rect.top + rect.height <= $window.innerHeight;
      }

      function doResize() {
        var elements = document.querySelectorAll("[hide-element='" + attrs.hideElement + "']");
        var allVisible = true;
        elements.forEach(function(e) {
          allVisible = allVisible && isVisible(e);
        });
        if (!allVisible) {
          elements.forEach(function(e) {
            angular.element(e).removeClass('ng-hide');
          });
        } else {
          elements.forEach(function(e) {
            if (e.attributes.exclude.value !== 'true') {
              angular.element(e).addClass('ng-hide');
            } else {
              angular.element(e).removeClass('ng-hide');
            }
          });
        }
      }

      angular.element(document).ready(function() { doResize(); });
      angular.element($window).on('resize', doResize);
    }
  };
}]);
app.directive("contenteditable", function () {
  return {
    require: "ngModel",
    link: function (scope, element, attrs, ngModel) {
      function read() {
        ngModel.$setViewValue(element.html());
      }

      ngModel.$render = function () {
        element.html(ngModel.$viewValue || "");
      };

      element.bind("blur keyup change", function () {
        scope.$apply(read);
      });
    }
  };
});
app.directive('includeReplace', function () {
  return {
    require: 'ngInclude',
    restrict: 'A',
    link: function (scope, el, attrs) {
      el.replaceWith(el.children());
    }
  };
});
app.directive('dlKeyCode', dlKeyCode);

function dlKeyCode() {
  return {
    restrict: 'A',
    link: function($scope, $element, $attrs) {
      $element.bind("keypress", function(event) {
        var keyCode = (event.which || event.keyCode).toString();
        if (keyCode !== $attrs.code) return;

        $scope.$apply(function() {
          $scope.$eval($attrs.dlKeyCode, { $event: event });
        });
      });
    }
  };
}

app.directive('ngAttr', ["$parse", function ($parse) {
  return {
    restrict: 'A',
    link: function (scope, element, attrs) {
      var el = element[0];

      scope.$watch(attrs.ngAttr, setAttributes, true);

      function setAttributes() {
        var attrsAndValueRefs = $parse(attrs.ngAttr)(scope) || {};

        Object.keys(attrsAndValueRefs).filter(function (attr) {
          return typeof attrsAndValueRefs[attr] === 'string' && attrsAndValueRefs[attr] !== el.getAttribute(attr);
        }).forEach(function (attr) {
          el.setAttribute(attr, attrsAndValueRefs[attr]);
        });
      }
    }
  };
}]);
app.directive('asDate', ["moment", function(moment) {
  return {
    require: '^ngModel',
    restrict: 'A',
    link: function(scope, element, attrs, ctrl) {
      ctrl.$formatters.splice(0, ctrl.$formatters.length);
      ctrl.$parsers.splice(0, ctrl.$parsers.length);
      ctrl.$formatters.push(function(modelValue) {
        if (!modelValue) return;
        return moment(modelValue).format('YYYY-MM-DD');
      });
      ctrl.$parsers.push(function(modelValue) {
        return modelValue;
      });
    }
  };
}]);
app.directive('asFloat', function() {
  return {
    require: '^ngModel',
    restrict: 'A',
    link: function(scope, element, attrs, ctrl) {
      ctrl.$formatters.splice(0, ctrl.$formatters.length);
      ctrl.$parsers.splice(0, ctrl.$parsers.length);
      ctrl.$formatters.push(function(modelValue) {
        if (typeof modelValue === 'undefined') return;
        return parseFloat(modelValue);
      });
      ctrl.$parsers.push(function(modelValue) {
        return modelValue;
      });
    }
  };
});
app.directive('asInteger', function() {
  return {
    require: '^ngModel',
    restrict: 'A',
    link: function(scope, element, attrs, ctrl) {
      ctrl.$formatters.splice(0, ctrl.$formatters.length);
      ctrl.$parsers.splice(0, ctrl.$parsers.length);
      ctrl.$formatters.push(function(modelValue) {
        if (typeof modelValue === 'undefined') return;
        return parseInt(modelValue);
      });
      ctrl.$parsers.push(function(modelValue) {
        return modelValue;
      });
    }
  };
});
app.directive('lettersOnly', function() {
  return {
    require: 'ngModel',
    link: function(scope, element, attr, ngModelCtrl) {
      function onlyLetters(text) {
        if (!text) return undefined;

        var transformedInput = text.replace(/[^A-Za-z]/g, '');
        if (transformedInput !== text) {
          ngModelCtrl.$setViewValue(transformedInput);
          ngModelCtrl.$render();
        }
        return transformedInput;
      }

      if (attr.lettersOnly === 'true') {
        ngModelCtrl.$parsers.push(onlyLetters);
      }
    }
  };
});
app.directive('numbersOnly', function() {
  return {
    require: 'ngModel',
    link: function(scope, element, attr, ngModelCtrl) {
      function onlyNumbers(text) {
        if (!text) return undefined;

        var transformedInput = text.replace(/[^0-9]/g, '');
        if (transformedInput !== text) {
          ngModelCtrl.$setViewValue(transformedInput);
          ngModelCtrl.$render();
        }
        return transformedInput;
      }

      if (attr.numbersOnly === 'true') {
        ngModelCtrl.$parsers.push(onlyNumbers);
      }
    }
  };
});
app.directive('slimscroll', function () {
  return {
    restrict: 'A',
    link: function ($scope, $elem, $attr) {
      var off = [];
      var option = {};

      var refresh = function () {
        if ($attr.slimscroll) {
          option = $scope.$eval($attr.slimscroll);
        } else if ($attr.slimscrollOption) {
          option = $scope.$eval($attr.slimscrollOption);
        }

        $($elem).slimScroll({ destroy: true });

        $($elem).slimScroll(option);
      };

      var registerWatch = function () {
        if ($attr.slimscroll && !option.noWatch) {
          off.push($scope.$watchCollection($attr.slimscroll, refresh));
        }

        if ($attr.slimscrollWatch) {
          off.push($scope.$watchCollection($attr.slimscrollWatch, refresh));
        }

        if ($attr.slimscrolllistento) {
          off.push($scope.$on($attr.slimscrolllistento, refresh));
        }
      };

      var destructor = function () {
        $($elem).slimScroll({ destroy: true });
        off.forEach(function (unbind) {
          unbind();
        });
        off = null;
      };

      off.push($scope.$on('$destroy', destructor));

      registerWatch();
    }
  };
});